About

About Previous page Return to chapter overview Next page

General help file for ssTEK Tools (SetupS, ssControlPanel, ssRegenerator, ssEditor)

Version 20.02.13.0 (Release Date 2020-02-13)

© Copyright 2017, Vergitek Solutions.

ssTek Forum

LastOS Team

Copyright © 2017, Vergitek Solutions

ssTek Forum: Tools for custom Operating Systems!


Introduction

Introduction Previous page Return to chapter overview Next page

ssTek® is a name derived from "SetupS Technologies" and all the tools using that technology. These tools are collectively called a package management system -- a collection of software tools that automates the process of installing, upgrading, configuring, and removing applications and games for a Windows™ operating system in a consistent manner.

SetupS , meaning "Setup Silently", is the central tool responsible for managing the install and setup of certain deployment packages. These deployment packages have file extensions that SetupS automatically recognizes and can be installed simply by double clicking on those deployment package files. One can also use the context-menu "Sendto" option to install these packages or to install an entire folder of them.

Although SetupS is not an installer itself but rather a "manager" for other installers, the main feature (and advantage) of SetupS is its advanced ability to customize an install for nearly any application or game and to do that install without user interaction. This is sometimes also called an unattended or silent install.

Another ssTek tool is ssWPI -- a highly modded Windows Post Installer that works in conjunction with SetupS; and hence the name. ssWPI presents the user with a list of available deployment packages each with their own descriptions and screenshot/previews. The user can then select from any number of these items to install... all in one sitting... all without requiring any further interaction from the user.

Included with the SetupS suite is another application called "SetupS Editor", or ssEditor , that can create these deployment packages for ssWPI or SetupS. The ssEditor can also be used to edit existing deployment packages or simply to view them.

ssTek has several types of deployment packages available:

•

installer based apps, installed silently or unattended (ssApp)

•

a portable and permanent application (ppApp) and

•

a portable and permanent game (ppGame).

An advantage of ppApps or ppGames is that they can be located anywhere on any drive (i.e., portable) -- for example, "D:\ppApps" or "D:\ppGames". Another is that as long as they remain on a different drive than the operating system (OS) then even after a new OS is re-installed, these apps or games can then be "brought back to life" and reused exactly as they were before (i.e., they're also permanent). This recovery can be accomplished by means of another ssTek tool called ssRegenerator .

With ssTek a user can also opt for an advanced startmenu structure that allows SetupS to automatically sort these apps or games while it is installing them or while they are being "regenerated". Of course the user can also opt for the standard startmenu structure if that is preferred. The ssTek tool that does this is called the ssControlPanel . And for cleaning dud shortcuts from the advanced startmenus is ssCleaner, which can be accessed via the ssControlPanel.

Each ss/ppApp contains a file with an .app extension (or .ppg for ppGames). It is a text-file which contains all the essential install information, startmenu sorting, and shortcut options, etc. This SetupS-file basically tells SetupS how to install the app or game. It can also contain many other bits of information pertaining to the app or game. See SetupS File Specification for more details about what's inside this file.

There are also many other SetupS-recognized files a typical ssTek deployment package might use. Installers (in the case of ssApps), or archives (in the case of ppApps); and various graphics files not essential to the apps' installations, but are added to provide other fun things ssTek tools can do. For example, screenshots of the apps or games when used with ssWPI. See Deployment Package Specifications , to explain in greater detail what all is present in some typical deployment packages.

Best of all, SetupS works with all the popular "NT-based" Windows, such as Windows 10, 8.x, 7, Vista, XP, & 2K.1

And finally, ssTek tools are licensed under the open-source GNU General Public License v3 . For details, please see http://www.gnu.org/licenses/ .

1Disclaimer: Because of the many fundamental changes to the OS experience by Windows 8/10 -- and although technically SetupS should work with it -- there is NO GUARANTEE that all features will be functional or without some bugs. In other words, use of ssTek and all its tools with Windows 8/10 is purely AT ONE'S OWN RISK.


SetupS

SetupS Previous page Return to chapter overview Next page

SetupS automates the installation of your applications and games, either full software (ssApp) or portable (ppApp/ppGame). To install with SetupS, merely double-click on the ".app" or ".ppg" file -- even on a special archive file ".apz" or ".pgz".

And for greater convenience, SetupS is added to the SendTo Menu. Simply right-click on an archive or the entire folder and SendTo "SetupS".

That's it!

Now, easily update existing applications to the current one(s) -- especially ppApps and still keep all your settings!

To uninstall, simply use the Add/Remove applet in Control Panel or if it's a ppApp/Game then simply delete the associated folder from the ppApps/Games folder -- and don't forget to run "ssCleaner" ;-)

Don't need or want "SetupS" available all the time? Also use the Add/Remove applet in Control Panel to uninstall it.


Command Line Usage

SetupS Command Line Usage Previous page Return to chapter overview Next page

SetupS can be invoked via the command line as follows:

Usage: SetupS [Input] [<Switches>...]

Input: <path>|<file_name>|<archive_name>

<path>: folder containing a SetupS recognized file via a command-line, shortcut, or with SendTo.

<file_name>: a SetupS recognized file via a command-line, shortcut, or with "SendTo", or "Open With", or by a double-click.

<archive_name>: an archive containing a SetupS recognized file via a command-line, shortcut, or with SendTo.

<Switches>

-Verbose: Show progress as both splash text and tray-balloon tips.

-Mute|Silent|Quiet: Totally silent install; hides everything including system tray icon and balloon tips.

-TrayOnly: Show progress only as balloon tips from the tray. Must have balloon tips enabled!

-SplashOnly: Show progress only as splash text/message boxes and hides both the tray icon and any balloon tips from the tray.

-SplashOnTop=Yes|No : "Always On Top" option for Splash Text. Default=No

-Regenerate : Force this function on any folder/file passed.

-Fadertainer=On|Off : Default = Off

-FaderSpeed={seconds} : Number of seconds to Fade in or fade out. Default=.5. IE, -FaderSpeed=.3

-FaderLocation=TL|TC|TR|ML|MC|MR|BL|BC|BR : T=Top, L=Left, R=Right, C=Center, M=Middle, B=Bottom

-FaderOnTop=Yes|No : Fadertainer Option for use "Always On Top". Default=Yes

-ppDrivesScanDirection=Backward|Forward: Specify scan direction for ppDrives. Default is "Backwards" (z: to c:).

-LLClean[=Off|StartMenuOnly|AllShortcuts]: Perform Shortcut cleaning and whether to limit the cleaning to never, or only the StartMenu dud shortcuts or to include all shortcut locations such as Desktop, Sendto, & Quicklaunch.

-KeepStartmenuFolders[=Yes|No]: Option to retain the full selected Advanced Startmenu. Default=No

-Wait|NoWait: Depends whether or not you need to hold onto the SetupS(x86) process and return to it after SetupS(x64) is finished. Dual-architecture ppApp-mode only. (Default is 'Wait').

-KillLauncher={NameOfLauncher}|KillProcess={NameOfProcess}: If you need to close a launcher or process. Especially useful if using the 'NoWait' switch above.

-Help|About|?: This help file.

A valid recognized SetupS file is one of the following: SetupS.app, ssApp.app, ppApp.app, or ppGame.ppg. Also, any type of archive with the extension '.apz' or '.pgz' containing a recognized SetupS file as listed above.

Usage example:

SetupS.exe "D:\ppGamesInstalls\My_ppGame.pgz" -TrayOnly


ssRegenerator

ssRegenerator Previous page Return to chapter overview Next page

A shortcut generator for all your SetupS-installed apps and games.


Command Line Usage

ssRegenerator Commands Previous page Return to chapter overview Next page

ssRegenerator can be invoked via the command line as follows:

Usage: ssRegenerator [<switches>...]

Alias: ssRegen

<Switches>

-ppApps|ppGames|ssApps|SetupS: Only shortcuts of this type get created. Otherwise, all.

-AllDrives=Yes|No : Default is "No". A "Yes" will force searching all available drives for ppApps/ppGames folders.

-Verbose: Show progress as both splash text and tray-balloon tips.

-Mute|Silent|Quiet: Totally silent install; hides everything including system tray icon and balloon tips.

-TrayOnly: Show progress only as balloon tips from the tray. Must have balloon tips enabled!

-SplashOnly: Show progress only as splash text/message boxes and hides both the tray icon and any balloon tips from

the tray.

-SplashOnTop=Yes|No : "Always On Top" option for Splash Text. Default=No

-Fadertainer=On|Off : Default = Off

-FaderSpeed={seconds} : Number of seconds to Fade in or fade out. Default=.5. IE, -FaderSpeed=.3

-FaderLocation=TL|TC|TR|ML|MC|MR|BL|BC|BR : T=Top, L=Left, R=Right, C=Center, M=Middle, B=Bottom

-FaderOnTop=Yes|No : Fadertainer Option for use "Always On Top". Default=Yes

-FaderInstallsOnly=Yes|No : Fadertainer during installs only. Default=Yes.

-Wait|NoWait: Depends whether or not you need to hold onto the SetupS(x86) process and return to it after SetupS(x64) is finished. Dual-architecture ppApp-mode only. (Default is 'Wait').

-KillLauncher={NameOfLauncher}|KillProcess={NameOfProcess}: If you need to close a launcher or process. Especially useful if using the 'NoWait' switch above.

-Help|?: This help file

Usage example:

ssRegenerator -ppApps -TrayOnly


ssControlPanel

ssControlPanel Previous page Return to chapter overview Next page

This is where to set features and options for the various ssTek tools. Use it to select an Advanced StartMenu/Sorting Style, SetupS preferences, Fadertainer settings, ppDrives, etc. Also has "ssCleaner" built-in for StartMenu cleaning.

Click on "Check for updates" to see if there is a new release and to optionally download & install it.

Click on "Help-file (F1)" or press F1 to get context-sensitive help. For example, click on a tab and press F1 to learn more:

StartMenu Styles

Preferences

Shortcuts Options

Fadertainer Options

ppDrives Options

ssCleaner Options


Command Line Usage

ssControlPanel Commands Previous page Return to chapter overview Next page

ssControlPanel can be invoked via the command line as follows:

Usage: ssControlPanel [<switches>...]

Alias: SetupSCP

<Switches>

Except where noted, these settings affect the defaults for all SetupS tools.

Startmenu:

-LastOS|Kazz: Force or change to a different SetupS advanced Startmenu sorting-structure(s).

-Standard: Force or change to a standard/non-SetupS Startmenu sorting-structure(s).

-MenuInstallOnly: Do not sort (organize) any Apps/ppGames shortcuts; just the Startmenu structure gets installed.

-ReSort: Force sorting (organize) of Apps/ppGames using the current Startmenu sorting preference.

-ssClean [=Off][,StartMenuOnly][,AllShortcuts][,DudInstallPaths][,NotDudInstallPaths][,DeepScan][,NoDeepScan]:

Perform shortcut cleaning and whether to limit the cleaning to never, or only the StartMenu dud shortcuts or to include all shortcut locations such as Desktop, Sendto, & Quicklaunch. Also whether or not to remove the install-to paths referenced by dud shortcuts or to do a deep-scan of uninstalled apps or games. Multiple settings are comma-separated, like so:

-ssClean=StartMenuOnly,NoDeepScan

ppDrives:

-ppAppsDrive=[x]: Sets desired ppApps Drive to x. Over-rides any current setting.

-ppGamesDrive=[y]: Sets desired ppGames Drive to y. Over-rides any current setting.

-ppDrivesScan[=Backwards|Forwards]: Scan and set for ppDrives. Scan direction can also be specified.

-ppDrivesRegen: Runs ssRegenerator on ppDrives.

-AllDrives: A ssRegenerator-only option for scanning all drives. Caution: this enables scans of portable and mapped network drives!

Reporting / notifications:

-SplashOnTop=Yes|No: "Always On Top" option for Splash Text.

-Verbose: Show progress as both splash text and tray-balloon tips.

-Mute|Silent|Quiet: Totally silent install; hides everything including system tray icon and balloon tips.

-TrayOnly: Show progress only as balloon tips from the tray. Must have balloon tips enabled!

-SplashOnly: Show progress only as splash text/message boxes and hides both the tray icon and any balloon tips from the tray.

Process without shortcuts:

-ssAppsShortcutsSkip: Do not create or process any shortcuts for ssApps.

-ppAppsShortcutsSkip: Do not create or process any shortcuts for ppApps.

-ppGamesShortcutsSkip: Do not create or process any shortcuts for ppGames.

Logging ("global" settings for all SetupS tools):

-Log: Creates activity logs. Files created are in the form "ReportingConsole.000x.txt".

-Debug: Turns on Debug-mode. Files created are in the form "DebugConsole.000x.txt".

Fadertainer ("global" settings for all SetupS tools):

-Fadertainer=On|Off : Activate or deactivate the Fadertainer.

-FaderSpeed={seconds} : Number of seconds to fade in or fade out. Default=.5. IE, -FaderSpeed=.3

-FaderLocation=TL|TC|TR|ML|MC|MR|BL|BC|BR : T=Top, L=Left, R=Right, C=Center, M=Middle, B=Bottom

-FaderOnTop=Yes|No : Fadertainer Option for use "Always On Top".

-FaderModule={executable} : Module to run in the background with Fadertainer.

-FaderInstallsOnly=Yes|No : Fadertainer Option for use "During Installs Only" (ssRegenerator-only option).

Options ("global" settings for all SetupS tools):

-SafeInstall=On|Off : (depreciated/disabled)

-SkipOSArch=Yes|No : SetupS/ssRegenerator option to process or skip apps/games based on the <Architecture> and/or <OS> information in an .app/.ppg file.

-ssCleanOptions=Off[,StartMenuOnly][,AllShortcuts][,DudInstallPaths][,NotDudInstallPaths][,DeepScan][,NoDeepScan]:

Determines whether to limit the cleaning to never, or only the StartMenu dud shortcuts or to include all shortcut locations such as Desktop, Sendto, & Quicklaunch. Also whether or not to remove the install-to paths referenced by dud shortcuts or to do a deep-scan of uninstalled apps or games.

-Path=Add|Del: Permanently adds (or removes) the SetupS path to/from the environment path variable.

-ssUninstall=On|Off|Fix|Refresh|Force : Activate/Deactivate the extra post-uninstall cleaning feature. Use "Refresh" or "Force" to update all to the current setting, "Fix" to revert everything without the feature (Note, "Fix" is the equivalent of "-ssUninstall=Off,Force").

-Wait|NoWait: Depends whether or not you need to hold onto the SetupS(x86) process and return to it after SetupS(x64) is finished. Dual-architecture ppApp-mode only. (Default is 'Wait').

-KillLauncher={NameOfLauncher}|KillProcess={NameOfProcess}: If you need to close a launcher or process. Especially useful if using the 'NoWait' switch above.

Auto Update:

-AutoUpdate=On|Off : Automatic online updates of the SetupS Sendto Suite using one of the Repo links, below.

-Repo={Link} : Primary link to find "Update.ini"

-BackupRepo={Link} : Backup link to find "Update.ini" in case the primary one isn't working.

-Help|About|?: This help file.

Usage example:

ssControlPanel -LastOS -Mute -ppGamesDrive=D:


StartMenu Styles

StartMenu Styles Previous page Return to chapter overview Next page

Install an Advanced StartMenu.
Sets an Advanced StartMenu style by selecting from the drop box. Also, revert back to Standard (default) StartMenu if desired.

Sort (organize) Startmenu shortcuts.
Select this option to sort all existing shortcuts to the selected StartMenu style. Otherwise, only the StartMenu style is installed.

Keep empty Advanced Startmenu folders.
Select this option to install (and retain) the full selected Advanced Startmenu including empty folders.

Ξ Note: Click the "Okay" button to make the changes to the StartMenu.


Preferences

Preferences Previous page Return to chapter overview Next page

Default reporting / notifications.

    • Show Everything.
      "Verbose" setting. Show progress as both splash text and tray-balloon tips.
    • Hide Everything:
      "Mute" setting. Totally silent install; hides everything including system tray icon and balloon tips.
    • Tray Only.
      Show progress only as balloon tips from the tray. Must have balloon tips enabled!
    • Splash Only.
      Show progress only as splash text/message boxes and hides both the tray icon and any balloon tips from the tray.
    • Always On Top (Splash)
      The splash text remains visible no matter which window has focus.

Logging.

    • Reporting.
      Creates activity logs in the SetupS folder. Files created are in the form "ReportingConsole.000x.txt".
    • Debugging.
      Turns on Debug-mode. Creates debug logs in the SetupS folder in the form "DebugConsole.000x.txt".

Options.

    • SafeInstall.
      (depreciated/disabled)
    • SkipOSArch.
      SetupS/Regenerator option to process or skip apps/games based on the <Architecture> and/or <OS> information in an .app/.ppg file.
    • ssUninstall.
      Option for automatic ssCleaning after uninstalling an App or Game that was installed with SetupS.

DualArch Installs. Set the default for which type of DualArch that ppApps are supposed to assume during install-mode. See DualArch-Installers .

    • Force Type 2a.
    • Force Type 2b.

Updates.

    • Auto Update.
      Automatic online updates of the SetupS Sendto Suite using one of the Repo links, below.
    • Primary.
      Primary link to find the "Update.ini" file online.
    • Backup.
      Backup link to find "Update.ini" in case the primary one isn't working.

Ξ Note: Click the "Okay" button to make the changes to the StartMenu.


Shortcuts Options

Shortcuts Options Previous page Return to chapter overview Next page

Skip shortcuts.
During processing, do not create or process any shortcuts for:

    • ssApps.
    • ppApps.
    • ppGames.

Remove pre-existing.
If shortcuts from the following already exist, then do not remove:

    • Root (Startmenu).
    • Programs (Startmenu).
    • Startup (Startmenu).
    • Pin (Startmenu).
    • Desktop.
    • Quick Launch.
    • SendTo.
    • Taskbar Pin.


Fadertainer Options

Fadertainer Options Previous page Return to chapter overview Next page

Use to set Fadertainer options globally for all SetupS tools.

    • Activate: Use to turn on (or off) the Fadertainer.
    • Always On Top: The Fadertainer will always show in the foreground.
    • During Installs Only: (ssRegenerator-only option)
    • Speed: Number of seconds to fade in or fade out.
    • Screen Location: Where the Fadertainer is to appear.
      (T=Top, L=Left, R=Right, C=Center, M=Middle, B=Bottom)
    • Fader Module: The addon (executable) to run in the background with Fadertainer.
      • RunRUNAway -- Fadertainer moves away from the mouse. Automatically exit after 8 second timeout.


ppDrives Options

ppDrives Options Previous page Return to chapter overview Next page

Use to set ppDrive options globally for all SetupS tools.

    • Scanning: Scan and set for ppDrives. Scan direction can also be specified.
    • ppApps/ppGames: The current setting of ppDrive letters.
    • Options (ssRegenerator):
      • Run ssRegenerator (after setting). Resets shortcuts for the new drive letters.
      • ssRegenerator processes all available ppDrives. Option for scanning all drives.
        Caution: this enables scans of portable and mapped network drives!


ssCleaner Options

ssCleaner Options Previous page Return to chapter overview Next page

Dud-shortcut removal:
(Global options for all SetupS tools.)

    • Disabled. Do not perform any ssCleaning functions.
    • Startmenu-only. Limits the ssCleaning location to only the Startmenu.
    • All Dud Shortcuts. All shortcut locations such as Desktop, Sendto, & QuickLaunch will be included in the ssCleaning.
    • Check for removed Startmenu items. ssCleaning is automatically performed whenever shortcuts are removed such as during Startmenu Style changes. (Recommended to leave this "on").
  • Remove Folders:
    (Global options for all SetupS tools.)
    • Dud Installed-to paths. Whether or not to remove the install-to paths referenced by dud shortcuts.
    • Uninstalled (deep scan). Do a deep-scan of uninstalled apps or games and remove their folders.
  • Instant ssCleaning: Perform ssCleaning right now.


ssEditor

ssEditor Previous page Return to chapter overview Next page

This is an application that can view, edit, or create the deployment packages for SetupS or ssWPI.

Simply press F1 to get context-sensitive help. For example, click on a tab and press F1 to learn more:

General Tab

Assembly Tab

Shortcuts Tab

Post-processing Tab

Graphics Tab

Menu Bar

To get started in creating your own application or game deployment packages, see: Tutorials .


Command Line Usage

ssEditor Command Line Usage Previous page Return to chapter overview Next page

ssEditor can also be invoked via the command line as follows:

Usage: ssEditor [Input] [<Switches>...]

Input: <path>|<file_name>|<archive_name>

<path>: folder containing a SetupS recognized file via a command-line, shortcut, or with SendTo.

<file_name>: a SetupS recognized file via a command-line, shortcut, or with "SendTo", or "Open With", or by a double-click.

<archive_name>: an archive containing a SetupS recognized file via a command-line, shortcut, or with SendTo.

<Switches>

-SaveFormat=Legacy|INI|Dual|UpdateOnly : Which app-file format to save to. Over-rides the default.

-Save|SaveAs|SaveTo[=Legacy|INI|Dual|UpdateOnly] : Only perform a save operation. If no value is specified then it will use the default or the SaveFormat switch to determine the file format.

-Build|Autobuild : Tells ssEditor to automatically build based on the current options/settings. Can be overridden with the following (optional) switches:

-MakeExpressInstaller=off|on : "On" makes the .apz/pgz archive packages. "Off" forces building of ssWPI type packages instead (folder packages).

-ppCompress=off|on : Whether or not you want to use archives for ppApps or ppGames.

-PatchCompress=off|on : Whether or not you want to use archives for the Patch-folders.

-CalcMD5=off|on : Create MD5 checksums for the packages.

-CompressionLevel=0|1|3|5|7|9 : 0=Store/Copy mode, 1=Fastest, 3=Fast, 5=Normal/Default, 7=Maximum, 9=Ultra.

-7zProcessPriority=0|1|2|3|4|5 : 0=Idle/Low, 1=Below Normal, 2=Normal, 3=Above Normal, 4=High, 5=Realtime.

-UseLZMA2=off|on : Toggle the use of the LZMA2 compression method.

-DeleteSource=off|on : Whether or not you want to keep source files/folders.

-UseRAR=off|on : Create archives and files using RAR instead of 7z. See Options Menu for details.

-Help|About|?: This help file.

A valid recognized SetupS file is one of the following: SetupS.app, ssApp.app, ppApp.app, or ppGame.ppg. Also, any type of archive with the extension '.apz' or '.pgz' containing a recognized SetupS file as listed above.

Usage example:

ssEditor "C:\Temp\My_ppGame.pgz" -Build -MakeExpressInstaller=on -UseOutputDir="C:\ppGamesInstalls"


General Tab

General Tab Previous page Return to chapter overview Next page

Application/Game Details (general information about the application or game):

Title

Version

URL(s)

Category

Description

Build Type

Architecture

For OS

ssWPI Options

Meta-Data Editor . Click the button to open a window for editing the meta data.


Title

Title Previous page Return to chapter overview Next page

Name of Application or Game.

Status: Required.

Example of Usage:

SetupS Editor

See also:

SetupS File Specification (.app/.ppg)


Version

Version Previous page Return to chapter overview Next page

Version information for ssApp's/ppApp's or Copyright/Year of make for ppGames.

Status: Optional.

Example of Usage:

v8.11.5.0

c2010

See also:

SetupS File Specification (.app/.ppg)


URLs

URLs Previous page Return to chapter overview Next page

Web-link(s) for the easy lookup for information or updates regarding the application or game.

Hint: Click on the URL(s) label/hotspot to launch the link(s) listed.

Status: Optional. Currently only used by ssWPI.

Example of Usage:

http://www.xyz.com
http://www.example.com

Ξ Note: Multiple lines of URL's are allowed.

See also:

SetupS File Specification (.app/.ppg)


Category

Category Previous page Return to chapter overview Next page

General category of the application or game. See Category List for a complete list.

Status: Recommended. Currently only used by ssWPI.

Example of Usage:

Disk | System

Ξ Note 1: Separate multiple categories with "|" on the same line.

Ξ Note 2: Use the dropbox to the left of the Categories box to select the individual category. Also, the "Games" checkbox will show the games categories available.

See also:

SetupS File Specification (.app/.ppg)


Description

Description Previous page Return to chapter overview Next page

Enter Information about the application or game. This can be as brief or detailed as desired.

Status: Optional. Currently only used by ssWPI.

Example of Usage:

With more and more people finding uses for SetupS and ppApps, this will allow anyone to make their very own Silent Setup app or game. It will show up on ssWPI or can be used via SendTo SetupS for whenever one is in a rush to put an app (or game) back onto their PC.

Ξ Note: Multiple lines (even blank ones) are allowed.

See also:

SetupS File Specification (.app/.ppg)


Build Type

Build Type Previous page Return to chapter overview Next page

This is important as it will determine SetupS's basic operations and also what options and utilities will be available.

Status: Required.

    • ssApp: (s)ilent (s)etup (App)lication. Typically involving the application's own installer or some type of setup software to install both the application and its shortcuts. SetupS's role in all this is to make it as unattended (silent) as possible.
    • ppApp: (p)ermanent & (p)ortable (App)lication. These are applications that do not need to be installed -- they do however, require re-initializing which basically restores the shortcuts to the start menu, adds any required registry entries, file associations, and system files. Although not true portables in the strictest sense, after they have been processed by SetupS, they are nearly indistinguishable from their ssApp brethren.
    • ppGame: (p)ermanent & (p)ortable (Game). A special kind of ppApp but with its own separate install folders and/or locations.
    • ppTweak: (p)ermanent & (p)ortable (Tweak). This is a special kind ppApp but no shortcuts are created.


Architecture

Architecture Previous page Return to chapter overview Next page

Architecture in this document will come to mean the type of machine CPU and corresponding Operating System (OS) blend that this application or game will only work on.

Status: Optional.

    • Any: Nothing significant about this application or game which requires a particular architecture.
    • x86: only a 32-bit architecture will do. Even though x64 OS/Architectures are supposed to be backwards compatible with 32-bit software unfortunately sometimes this is not always the case. For example, only 16-bit apps/games work on x86 machines.
    • x64: only runs on a 64-bit architecture.
    • DualArch: will run on either x86 or x64 systems... this only works with ppApps or ppGames exclusively.

See also:

SetupS File Specification (.app/.ppg)

DualArch-Installers


OS

For OS Previous page Return to chapter overview Next page

This selects what Operating System (OS) this application or game will only work on.

Status: Optional.

Note: None / All selected: doesn't matter what OS. Any of the following:

    • NT5.x (XP/2K): Windows 2000, XP, 2003 only. In other words, this app is not known to work with a later Windows OS.
    • NT6.x (pre-Metro/Modern): Windows Vista, 7, 2008, 2011.
    • Metro/Modern (pre-Win10): Windows 8, 8.1, 2012.
    • NT10.x: Windows 10, 2016, etc.

See also:

SetupS File Specification (.app/.ppg)


ssWPI Options

ssWPI Options Previous page Return to chapter overview Next page

Some options pertaining to only to ssWPI:

Status: Optional.

Always show: If selected it will always show in the ssWPI list.

Always hide: If selected it will always hide from the ssWPI list.

At Setup only: If selected it will show only during setup.

Install T13: If selected will be installed at setup time of 13 Minutes remaining.

Run as x64: Redirect folder locations and reg entries, enabling this will treat it as a x64 OS and allow SetupS to access x64 locations. Note, this flag is both non-functioning and obsolete.

Install Instant: .

Priority Order: to install items from ssWPI selection screen.

See also:

SetupS File Specification (.app/.ppg)


Meta-data Editor

Meta-data Editor Previous page Return to chapter overview Next page

Use drop-down box to select the desired Tags then click "Add" to add it to the Tags list.

  • Additional App/Game details:
    • Publisher: Original author or developer of the app/game.
    • Language: Language (if not English).
    • Rating: Use ratings between 1 to 5.
    • Additional: Extra information or comments.
    • Release Version: The version of publication by the original developer(s).
    • Release Date: The date of publication by the original developer(s). Recommended format: yyyy-mm-dd.
    • Required Runtimes: Prerequisites that need installed (such as, DirectX, Java, Flash, etc.).
    • Builder: The person or group who prepared this SetupS package.
    • Installed Size: The approximate size on the drive this package will ultimately require.
    • License Type:
      • Unknown: Unassigned.
      • Commercial: Non-gratis (Non-Free) proprietary/closed-source.
      • Non-profit: Gratis-only (Free as in beer) proprietary/closed-source.
      • Open source: Libre (Free as in speech and beer) non-proprietary.

See also:

SetupS File Specification (.app/.ppg)


Tags

Tags Previous page Return to chapter overview Next page

Unlike category, this is a searchable-freeform field where any keyword or phrase is allowed.

Status: Optional. Currently only used by ssWPI.

Example of Usage:

Action | Adventure

Ξ Note: Separate multiple tags with "|" on the same line.

See also:

Application Tag List

Game Tag List


Application Tag List

Application Tag List Previous page Return to chapter overview Next page

The following are some suggestions that can be used as "Tags" for applications (ssApps or ppApps). Merely copy (or ctrl+c) and paste (ctrl+v) each desired tag. (Also, can use right-click, copy/paste from the context-menu).

Ξ Note: Separate each tag with the pipe-character "|".

Addon

Anti-Malware

Audio

Bandwidth

Burn

Collection

Comics

Database

Development

Device

Disk

Driver

eBook

eMail

File

Fitness

Emulation

Genealogy

GPS

Graphics

Install

Instant Message

Internet

Mobile

Tool

Movie

Multimedia

Music

Network

Office

Optical

Peer to Peer

Print

Recovery

Remote Access

Scan

Security

Sound

System

Theme

TV

Tweak

Utility

Video

Viewer

Virtual Drive

Virtual Machine


Game Tag List

Game Tag List Previous page Return to chapter overview Next page

The following are some suggestions that can be used as "Tags" for games (ppGames). Merely copy (or ctrl+c) and paste (ctrl+v) each desired tag. (Also, can use right-click, copy/paste from the context-menu).

Ξ Note: Separate each tag with the pipe-character "|".

Basic Genre:

Action

Adventure

Arcade

Artificial Life

Board Games

Card Games

Dash

Educational

Emulation

Hidden Object

Jigsaw

Management

Match

Mixed

Pinball

Platform

Puzzle

Quiz

Racing

Roll Playing

Shooter

Simulation

Sport

Strategy

Utility

Word

Perspective:

2D

3D

Abstract

Anime & Manga

Arcade

Board

First-Person

Grid

Interactive

Isometric

Lines

Open World

Platform

Point & Click

Real-Time

Side-Scrolling

Simulation

Third-Person

Top-Down

Turn-Based

Vertical-Scrolling

Location:

Dungeon

Casino

Egypt

Game Show

Garden

Home

Hotel

Island

Maze

Ocean

Sandbox

School

Sky

Space

Tower

World

Vehicle:

Aircraft

Bike

Car

Motorbike

Tank

Train

Beings & Objects:

Alien

Animal

Dice

Food

Gangster

God

Insects

Lists

Marble

Shape

Slot Machine

Table-Top

Tile

Vampire

Vehicle

Zombie

Actions:

Battle

Bowling

Building

Collapse

Collecting

Combat

Construction

Cooking

Crawl

Decorating

Defense

Delivery

Detective

Digging

Driving

Escape

Fighting

Fishing

Flying

Gambling

Hero

Search

Service

Shoot ’Em Up

Shooting

Stealth

Swap

Target

Time Management

Travel

Style:

A To B

Adaptation

Adult

Anagram

Brainteaser

Breakout

Chess

Comedy

Crime

Crossword

Death

Demo

Design

Difference

Emulation

Fantasy

Fractured

Futuristic

History

Horror

Inlay

Life

Mahjong

Medical

Medieval

Mental Training

Military

Multiplayer

Mystery

Open

Other

Path

Physics

Poker

Post Apocalyptic

Precision

Rhythm & Dance

Romance

Sci-Fi

Sequence

Sokoban

Solitaire

Survival

Tycoon

Unique

War

Western

Zen


Assembly Tab

Assembly Previous page Return to chapter overview Next page

Install-to Path

Installer(s)

Process Order

Uninstall Data (under-developement):

    • Disable ssUninstall for this App.
      Prevents the ssUninstall feature from being used with this particular app or game.

See also:

Directives

Components


Install-to Path

Install-to Path Previous page Return to chapter overview Next page

Destination path -- the actual physical (final) location of the app or game. Typically %ProgramFiles% for ssApps, %ppApps% for ppApps, and %ppGames\% for ppGames.

Status: Required.

Example of Usage:

%ProgramsFiles%\MyApp

%ppGames%\MyGame

Ξ Note: Strings such as 'C:\Program Files\' will automatically be converted to %ProgramFile% for ssApps, %ppApps% for ppApps, and %ppGames% for ppGames. And vise versa.


Installer(s)

Installer Details Previous page Return to chapter overview Next page

This is the necessary information for making an ordered list of installers (.exe .msi) or other actions that must occur in order to setup and create shortcuts for this application. The box at the bottom of this section is that list of actions and/or installers plus any silent switches accompanying them -- all in the order of occurrence.

  • Installer: For ssApps only. Use the browse button to select the installer or setup program. ssEditor will attempt to find the correct silent switch for that installer with its built-in Auto Silent Switch Finder (ASSF) but sometimes a best match is not always made1.

    Click the 'Add' button to add this information to the Installer List.

Example:

Installer: Setup.exe

  • Usage: For ssApps only. These are the silent switches to accompanying the installer above to force the setup program to do what is called an "unattended" setup. Click the 'Add' button to add this information to the Assembly List.

Example:

Usage: /S

____________________

1 Note: ASSF performs its function with these utilities in the following order of success:

    1. SKF - Silent Key Finder
    2. TrID - File Identifier
    3. USSF - Universal Silent Switch Finder
    4. PEiD - Portable Executable iDentifier


Process Order

Process Order Previous page Return to chapter overview Next page

Install-mode only. Multiline allowed. Place commands, components, directives (see below), setup, or install package(s) here with proper silent install switches or script(s) to automate the install. Mainly for ssApps, but can be used with ppApps/ppGames for any post-install or preprocessing commands, script(s), or registry entries.

Status: Recommended for ssApps. Optional for ppApps/ppGames.

Some examples:

setup.msi /qb
%WaitForIt% "%ProgramsCommon%\TestStartmenu.lnk"
%ProcessKill% "Notepad.exe"
%AddonInstaller% "%SourcePath%\Test_addon.7z"
%AddToHosts% "127.0.0.1 secure.example.com"
%Extract% "Extras.rar" -o"%SystemRoot%\LastXP"
md "%ProgramFiles%\Something" #CMD#
"7z920-x64.msi" /qb #Is_x64#
ImportTest.reg
ScriptTest.cmd

Ξ Some Notes:

    1. Use the process-order #Directives# here to control or fine-tune the assembly process.
    2. The <Assembly> section is ignored in Regen-mode .
    3. With the exception of %Extract%, the <Assembly> section uses the %Components% in their internal/built-in forms.

See also:

Assembly Sequence

Install and Regen modes

Automatic Variable Substitution Chart


Assembly Sequence

Mainline Sequence Previous page Return to chapter overview Next page

The following is the CURRENT default post-assembly sequence, if you do not supply any #directives# in <Assembly>. (This saves from having to specify the sequence every single time):

1. "ssInstall" (always step 1, regardless):

      • Extract archives (ie. {Buildtype}, etc.) -- This is the "install" stage for ppApps/ppGames
      • Copy SetupS-auxiliary files (screenshots, faders, etc.)

------- Post-processing ------

2. #ApplyPatch# : Process the patch folder or archive.

3. #ShortcutS# : Process the <ShortcutS> section... all shortcut/startmenu related tasks (w/ StartMenu Folder icons) AND File Association(s).

4. #AppPathFolderIcon# : Install-path Folder Icon

5. #RunScript# : Run the <Script> section. Uses the Source folder as the 'Start In' or working folder.

6. #ApplyRegistry# : Apply the <Registry> section.

7. #InstallFonts# : Process the <InstallFonts> section.

8. #RegisterDLL# : Process the <RegisterDLL> section.

Ξ Some Notes:

    1. The Post-processing sequence can now be altered by including ANY of the above Post-processing #Directive#'s inside the <Assembly> list; and it will correspondingly be skipped during Post-processing. Any #Directives# not included inside the <Assembly> list will be simply be processed in its normal default sequence -- effectively altering the post-processing sequence.
    2. "ssInstall" is essentially a placeholder and does not itself have a #Directive# since it is *Always* automatically processed before any of the the other Post-processing #Directives# (ie, #ShortcutS#, #ApplyRegistry#, etc.)
    3. The new <Flag> 'NoneThing' suppresses a couple of these processes/directives: #ShortcutS# and #AppPathFolderIcon#. Also suppresses SetupS-auxiliary files (screenshots, faders, etc.)

Here's a simple example:

<Assembly>

setup.msi /qb

%WaitForIt% "%ProgramsCommon%\Startmenu.lnk"

%ProcessKill% "something.exe"

#ApplyRegistry#

Now the sequence is altered to:

1. "ssInstall" (always step 1, regardless):

      • Extract archives (ie. {Buildtype}, etc.) -- This is the "install" stage for ppApps/ppGames
      • Copy SetupS-auxiliary files (screenshots, faders, etc.)

------- Post-processing ------

2. #ApplyRegistry# : Apply the <Registry> section.

3. #ApplyPatch# : Process the patch archive or folder.

4. #ShortcutS# : Process the <ShortcutS> section... all shortcut/startmenu related tasks (w/ StartMenu Folder icons) AND File Association(s).

5. #AppPathFolderIcon# : Install-path Folder Icon

6. #RunScript# : Run the <Script> section. Uses the Source folder as the 'Start In' or working folder.

7. #InstallFonts# : Process the <InstallFonts> section.

8. #RegisterDLL# : Process the <RegisterDLL> section.


Install & Regen modes

Install & Regen modes Previous page Return to chapter overview Next page

SetupS operates in two modes. They are self-determined by SetupS automatically but if one is aware of which mode it could be operating in, the behavior of SetupS becomes more predictable (and much easier to understand). For example, <Assembly> is ignored during Regen-mode.

  • Install-mode

This is the mode whenever an application or game is being installed for the first-time or for updates. Generally it is activated whenever SetupS processes the application or game from the source-path, which is typically the path of the deployment package from whatever medium it resides on; or the system temp folder if the deployment packages is an archive file (such as .apz or .pgz).

  • Regen-mode

So called because it effectively "regenerates" the application or game without actually installing it. And it does so by recreating shortcuts, processing registry entries, executing scripts, etc. This mode is activated whenever SetupS processes the application or game from its Installed-to path.


Shortcuts Tab

Shortcuts Previous page Return to chapter overview Next page

StartMenu Location(s)
This section determines where shortcuts will be created in the Startmenu.

Default Menu

Menu Catalog

Shortcut(s) Location(s)

Shortcut(s) Options

Shortcut(s) Definitions

Hotkey

Shortcut Names to Keep


Default Menu

Default Menu Previous page Return to chapter overview Next page

This is one of the most important items that needs attention. This is where shortcuts get created if no advanced StartMenu sorting is selected. For ssApps, this is where the installer or setups software will install its shortcuts even if it is subsequently moved by SetupS later. And finally, this item is required for all shortcuts (Desktop, Quicklaunch, Sendto, etc.) no matter if they are created in the Startmenu or not.

In other words, do NOT skip this one.

Status: Required.

Example of Usage:

SetupS Editor


Menu Catalog

Menu Catalog Previous page Return to chapter overview Next page

A recent new feature of SetupS is its ability to locate or sort shortcuts based on a catalog of categories rather than explicitly specifying its location. This allows for any number of custom designed Startmenu structures besides the two already included: LastXP and Kazz.

Simply select one or more categories from the Menu Catalog dropbox and click "+" add button to include it in the list.

Status: Optional.

Example of Usage:

Development Setup & Installing

Ξ Note: This only affects shortcut placement for Advanced Startmenus only and therefore will have no effect on those choosing the Standard Startmenu option instead. But it would still be wise to choose at least one appropriate item from the catalog.


Shortcut(s) Location(s)

Shortcut(s) to Previous page Return to chapter overview Next page

All Users - Create shortcut(s) for "AllUsers" instead of "Current User" using the flags below.

Start menu (normal) - Create Shortcuts in the Start Menu. Affected by the Shortcut Options: ''Keep in folder'' and ''Keep all''.

Root - Make a shortcut in the Root of the Start Menu. Only the first shortcut from ''Shortcut Names to Keep'' or from ''Definitions''.

Programs - Make a shortcut in the Programs group of the Start Menu. Only the first shortcut from ''Shortcut Names to Keep'' or from ''Definitions''.

Startup - Make a shortcut in the Startup group of the Start Menu. Only the first shortcut from ''Shortcut Names to Keep'' or from ''Definitions''.

Pin - (Windows 7 only) Pins a shortcut to the Start Menu. Only the first shortcut from ''Shortcut Names to Keep'' or from ''Definitions''.

Desktop - Makes Desktop Icons. Only the first shortcut from ''Shortcut Names to Keep'' or from ''Definitions''.

Quick launch - Makes Quick Launch Icons. Only the first shortcut from ''Shortcut Names to Keep'' or from ''Definitions''.

SendTo - Create a Shortcut in the Send To Menu. Only the first shortcut from ''Shortcut Names to Keep'' or from ''Definitions''.

Taskbar Pin - (Windows 7 only) Pins a shortcut to the Taskbar. Only the first shortcut from ''Shortcut Names to Keep'' or from ''Definitions''.


Shortcut(s) Options

Shortcut(s) Options Previous page Return to chapter overview Next page

Keep in folder - Keeps the Default Menu Folder and moves to sorting location if sorting is enabled. Applies to ''Start Menu (normal)'' only.

Keep all - Keep all available shortcuts. Applies to ''Start Menu (normal)'' only.

Adv. menu always - Force shortcut creation into an Advanced menu rather than the Standard one. In other words, never use the default Menu location - even when sorting is disabled on the current OS. ("Always Sort" flag)

No menu icons - Suppress StartMenu icon folder creation for this App/Game.

Refresh Explorer - Force a desktop refresh (without having to cycle thru a logoff then logon).

Live PE - Mark this ppApp/ppGame for LivePE's such as ppAppsLive or ppGamesLive (not implemented).

Leave alone - Suppress shortcut creation of any kind whatsoever. Over-rides "Always Sort", above. ("Never Sort" flag)

StartScreen-friendly - Over-rides KeepInFolder and KeepAll (above) to place shortcuts from the "Shortcut names to keep" list or if empty, then the first ShortcutS def listed. Note: this will only affect shortcuts on Windows 8 (NT6.2) or greater.


Shortcut(s) Definitions

Shortcut(s) Definitions Previous page Return to chapter overview Next page

List ppApp/ppGame or extra ssApp shortcuts here. Each Shortcut is defined as follows:

Display name: This is the link (.lnk) or name of the shortcut as it will appear in the StartMenu, etc.

Example of Usage:

My Application Name

File Target: File that will be run/opened/executed. This is the actual physical filename of an application or game; usually the .exe. Do not use parameters or arguments here (see "Arguments" below for that).

Example of Usage:

C:\ppApps\ApplicationName\Start.exe

Start In: What folder to start in, or work from.

Example of Usage:

Icon File: File name of icon to use.

Example of Usage:

(Icon) Index: The icon instance to use (default is 0).

Example of Usage:

Arguments: Shortcut arguments or parameters, if any.

Example of Usage:

-ppApps -AllDrives=no

Assoc. Ext(s): File extension(s) to associate with this Shortcut/app. Over-rides Post-processing "App. Extensions". Each association can be separated by full stops (a.k.a., periods or dots), spaces, commas, pipes, or a combination of any of these.

Example of Usage:

.txt.nfo.diz.ini.app

Description: A short description of this shortcut. Also, the tooltip information in most cases.

Example of Usage:

This Application is for doing this.

Flags: Advanced or specials function(s) for this particular shortcut.

Example of Usage:

Is_x86 | Is_NT5

Catalog: (Undeveloped).

Hotkey: Define the Hotkey /" Shortcut key " to use for this shortcut.


Hotkey

Hotkey Previous page Return to chapter overview Next page

Hotkeys for windows shortcuts are of the following form: Ctrl+Alt+X, Ctrl+Shift+X, Shift+Alt+X, Ctrl+NumPadKey, or Alt+NumPadKey where X represents a letter, number, punctuation, or function key. Allows the creation of Ctrl+X and Alt+X shortcuts (which Windows normally only allows when X is a NumPadKey); however, you should avoid these assignments as they may conflict with standard application hotkeys.

Note that Windows distinguishes number pad keys from regular number and punctuation keys. Windows prohibits ESC, ENTER, TAB, SPACEBAR, PRINT SCREEN, SHIFT, or BACKSPACE from being used as hotkeys.

Use the following table for the Hotkey codes to use with SetupS:

Resulting Keypress | SetupS Hotkey Code
ALT | !
SHIFT | +
CTRL | ^
{ | {{}
} | {}}
Up arrow | {UP}
Down arrow | {DOWN}
Left arrow | {LEFT}
Right arrow | {RIGHT}
HOME | {HOME}
END | {END}
INS | {INSERT} or {INS}
Function keys | {F1} - {F12}
NUMLOCK (on/off/toggle) | {NUMLOCK on}
CAPSLOCK (on/off/toggle) | {CAPSLOCK off}
SCROLLLOCK (on/off/toggle) | {SCROLLLOCK toggle}
Numpad digits | {NUMPAD0} - {NUMPAD9}
Numpad Multiply | {NUMPADMULT}
Numpad Add | {NUMPADADD}
Numpad Subtract | {NUMPADSUB}
Numpad Divide | {NUMPADDIV}
Numpad period | {NUMPADDOT}
Use the ALT+nnnn key combination | {ASC nnnn}

Example of Usage (for Ctrl + Alt + F2):

^!{F2}


Shortcut Names to Keep

Shortcut Names to Keep Previous page Return to chapter overview Next page

List which shortcuts desired to keep (if KeepAll=No). First one listed here is the most important one as it is the one to be used for creating the Desktop, Startup, Sendto, or QuickLaunch shortcut(s).

Status: Optional or Required depending on the KeepAll flag or if BuildType is a ppApp or ppGame.

Example of Usage:

Application Name
Application Name Help
Tools\Application Tool

Ξ Note: Multi-line allowed.


Post-processing Tab

Post-processing Tab Previous page Return to chapter overview Next page

Script/Batch/.Cmd

Registry Entries/.Reg

App Ext(s)

Install Fonts

Register Server

Post-processing Options

Explore Patch Folder


Script/Batch/.Cmd

Script/Batch/.Cmd Previous page Return to chapter overview Next page

A CMD (or BAT) file that contains an external script file. Place batch file (.bat) or script (.cmd) contents here.

Status: Optional.

Ξ Notes:

    1. The scripts both internal or external execute from the Install-to path <AppPath>.
    2. Scripts have access to all %Components% (in their .exe forms).
    3. Use of Gate Directives (#Is_x64#, #Is_NT6#, etc.) is allowed.

See also:

Mainline Sequence

Automatic Variable Substitution Chart


Registry Entries/.Reg

Registry Entries/.Reg Previous page Return to chapter overview Next page

A REG file that contains external registry entries to apply. Place the contents of registy tweaks or patches (.reg) here.

Status: Optional.

Ξ Notes:

    1. Use of %Variables% is allowed (and encouraged).
    2. Also the use of Gate Directives (#Is_x64#, #Is_NT6#, etc.) is allowed.

See also:

Mainline Sequence

Automatic Variable Substitution Chart


App Ext(s)

App Ext(s) Previous page Return to chapter overview Next page

These are file associations that apply to this entire application. Here each file association extension can be separated by full stops (a.k.a., periods or dots), commas, pipes, new lines, or a combination of any of these.

If it is a multi-executable or multi-application suite with each application having its own file association then see the section on Shortcut definitions .

Status: Optional.

Example of Usage:

.txt.nfo.diz.ini.app

Ξ Notes:

    1. The use of Gate Directives (#Is_x64#, #Is_NT6#, etc.) is allowed.

See also:

Mainline Sequence


Install Fonts

Install Fonts Previous page Return to chapter overview Next page

List font-files (one per line) here to be installed to the Windows Fonts applet.

Status: Optional.

Ξ Notes:

    1. Use of %Variables% and Gate Directives (#Is_x64#, #Is_NT6#, etc.) is allowed.

See also:

Mainline Sequence


Register Server

Register Server Previous page Return to chapter overview Next page

List any files (one per line) here to be installed via the Windows Register Server.

Status: Optional.

Ξ Notes:

    1. Use of %Variables% and Gate Directives (#Is_x64#, #Is_NT6#, etc.) is allowed.

See also:

Mainline Sequence


Post-processing Options

Post-processing Options Previous page Return to chapter overview Next page

Make Nonething App - Suppress SetupS related files. Basically, this prevents creation of the Aux files (screenshot, fader, etc.), advanced startmenu shortcuts, folder icons, and the .app-file. This also means that the app will be rendered invisible or nonexistent to SetupS and ssWPI.

Never update App-file - Forces SetupS to not update an .app/.pgz-file even if changes are found.


Explore Patch Folder

Explore Patch Folder Previous page Return to chapter overview Next page

The entire contents of this folder gets copied into the Install-to folder once the install is completed.

See also:

Mainline Sequence


Graphics Tab

Graphics Tab Previous page Return to chapter overview Next page

Pop Outs : Click the button (or the graphic) to open a window for viewing the graphics.


Pop Outs

Pop Outs Previous page Return to chapter overview Next page

ScreenShot

The JPG image file screen shot you will display in the ssWPI when the app/game title is selected.

Icon

The ICO image file will be used for startmenu and install-to folder icon.

Fader

A PNG image file that will to show on the fader screen, if enabled.

See also:

Deployment Package Specifications


Menu Bar

Menu List Previous page Return to chapter overview Next page

File Menu

View Menu

Options Menu

Builds Menu

Tools Menu

Help Menu


File Menu

File Menu Previous page Return to chapter overview Next page

New (CTRL + N)

Create a new .app or .ppg file.

Open (CTRL + O)

Open an existing .app or .ppg file for editing.

Save (CTRL + S)

Save the current .app or .ppg file.

Ξ Note: This will also convert strings to variables and convert between BuildTypes. For example, "C:\Program Files" becomes %ProgramFiles% and changes an ssApp to a ppApp (or vise-versa) including all the auxiliary support files and folders.

Save As

Save the current .app or .ppg file to a different folder.

Ξ Note: This will also convert strings to variables and convert between BuildTypes. For example, "C:\Program Files" becomes %ProgramFiles% and changes an ssApp to a ppApp (or vise-versa) including all the auxiliary support files and folders.

Exit

Leave the SetupS Editor application.


View Menu

View Menu Previous page Return to chapter overview Next page

Current working folder... (F2)

Open explorer view of the current working folder.

Current destination folder...

Open explorer view of the current destination folder.

Patch Folder

This folder gets copied into the Install-to folder once the install is completed.

Fader (.png)

A PNG image file that will to show on the fader screen, if enabled.

Icon (.ico)

The ICO image file will be used for startmenu and install-to folder icon.

ScreenShot (.jpg)

The JPG image file screen shot you will display in the ssWPI when the app/game title is selected.

Batch/Script file (.bat/.cmd)

A CMD (or BAT) file that contains an external script file.

Registry file (.reg)

A REG file that contains external registry entries to apply.

View %Variables% List (F3)

Displays a pop-up of the Automatic Variable Substitutions Chart .

Source in Notepad (F4)

View the actual .app or .ppg source file in Notepad.

Meta-data Editor

Opens the current file's meta-data to view or edit.

File Version info

Shows the current file's version information.

See also:

Deployment Package Specifications


Options Menu

Options Menu Previous page Return to chapter overview Next page

Integrate .Reg & .Cmd into App:

Reg and Cmd Script can now be included in the app-file. This allows use of variables from the system not usually available to access.You can still use other SetupS.reg or SetupS.cmd files, but it is a good idea to keep them all external or internal. (Not implemented)

Get Version from Title

Automatically attempt to get the version (copyright) information from what's already given in Title.

StartMenu Target Searching

If enable will search the Startmenu for the shortcut that matches the target specified in the Shortcut defs.

Activate Sendto Autobuild

Add "Autobuild" to the Sendto menu.

Icon Viewing Size...

Set the icon view size for the Previews tab.

Screen Capture

Various options and settings for the screen-capture tools .

Logging ...

Set the type of logging desired: Activity/Reporting or Debugging.

Restore Defaults

Resets configuration for ssEditor back to its defaults.


Builds Menu

Builds Menu Previous page Return to chapter overview Next page

Exit After Build

Closes SetupS Editor after finishing building a deployment package.

Calculate MD5 checksum

Creates the .md5 checksum for deployment packages.

Delete Source (folder/files)

After successfully building the deployment package, this option deletes any archived files.

Make Archive Deployment package (.apz/.pgz)

Creates the online distribution package rather than an ssWPI one (Folder Deployment package).

Webserver-friendly Filenames (.apz/.pgz)

Uses filenames for online distribution packages that won't conflict with webservers' filenaming conventions; such as having ".php" located anywhere in the filename not just at the end.

Use RAR

Create archives and files using RAR instead of 7z.

Ξ Note: Because of licensing, RAR.exe is not, nor will be, included in the Tools folder -- one must add it on their own recognizance. Fortunately, this is easy to do. Simply copy one file:

"C:\Program Files\WinRAR\Rar.exe" to "C:\Program Files\SetupS.SendTo\Tools".

Use Filename Tags

Create archives filenames selected from meta-data.

Filename Tags

Compression


Builds Compression

Builds Compression Previous page Return to chapter overview Next page

Use LZMA2 Method

Uses the new 7-Zip compression algorithm. Otherwise, it uses the original LZMA algorithm.

Make ppApp/ppGame Archive

Option to create the "install" archive exclusive to ppApps or ppGames. Also sometimes known as the "internal" archive if using archive deployment packages (.apz/.pgz).

Make Patch-folder Archive

Option to create an archive (called "Patch.7z") from the patch folder; ie, "\SetupS\", "\ssApp\", "\ppApp\", or "\ppGame\".

Process Priority

Level


Process Priority

Compression Process Priority Previous page Return to chapter overview Next page

This option determines much CPU thread or process priority one wants to allocate to the build:

Idle/Low (0)

Below Normal (1)

Normal (2)

Above Normal (3)

High (4)

Realtime (5)


Level

Compression Level Previous page Return to chapter overview Next page

Depending on one's computing power and the method/algorithm selected, these can be altered to maximum benefit of compress ratios versus compression time:

None/Store (0)

Fastest (1)

Fast (3)

Default (5)

Maximum (7)

Ultra (7)


Filename Tags

Builds Compression Previous page Return to chapter overview Next page

Select which tags to use for the Archive Deployment Package's filename.


Tools Menu

Tools Menu Previous page Return to chapter overview Next page

Screenshot

Extract Icon(s)... (F10)

Use this tool to capture or obtain an icon from another file.

SetupS Test (F8)

Handy debugging tool for testing this package through SetupS. Temporarily turns on Fadertainer to see how the Fader graphic will look.

Build (F5)

Use this tool to build either an ssWPI (folder) or archive deployment package depending on the Builds Options.

New file Wizard


Screenshot

Screenshot Previous page Return to chapter overview Next page

Two methods are available to get screen-shots. Whichever is selected, simply follow the on-screen directions.

Screen Capture (F11)

Grab Clipboard Picture (F12)


Help Menu

Help Menu Previous page Return to chapter overview Next page

Contents (F1)

This help-file. Now also context-sensitive.

About

Version and Credits information.

Check for update...

Get online updates of the SetupS Suite.


Mini-Toolbar

Mini-Toolbar Previous page Return to chapter overview Next page

Help (F1)

Help Contents (Context-sensitive).

New (CTRL + N)

Create a new .app or .ppg file.

Open (CTRL + O)

Open an existing .app or .ppg file for editing.

Save (CTRL + S)

Save the current .app or .ppg file.

Ξ Note: This will also convert strings to variables and convert between BuildTypes. For example, "C:\Program Files" becomes %ProgramFiles% and changes an ssApp to a ppApp (or vise-versa) including all the auxiliary support files and folders. See Automatic Variable Substitution Chart for details.

Explore Working Folder (F2)

Opens Explorer to the current working folder listed in the status bar.

View Variables List (F3)

See Automatic Variable Substitution Chart for details.

View Source in Notepad (F4)

Take a look at the .app/.ppg file at its most basic level.

Extract Icons (F10)

Useful for capturing some folder icons for SetupS to use.

Screen Capture (F11)

Useful for capturing some screen-shots for ssWPI.

Grab Clipboard Picture (F12)

An alternative way to obtain some screen-shots for ssWPI.

SetupS Test (F8)

Handy debugging tool for testing this package through SetupS. Temporarily turns on Fadertainer to see how the Fader graphic will look.

Build! (F5)

Builds the deployment package. See Builds Menu for details.


Tutorials

Tutorials Previous page Return to chapter overview Next page

How to create an ssApp

How to create a (basic) ssApp

How to create a ppApp

How to create a ppGame

How to create a ppTweak

How to make a ppApp from an ssApp

How to update a ppApp or ssApp


Creating an ssApp

Creating a ssApp Previous page Return to chapter overview Next page

1. Preparation.

  • Create a temporary "build" folder. Such as apzdev in the root of the drive c:\apzdev
  • under this directory create a working folder of the app name.
  • In this example create a folder 7-Zip C:\apzdev\7zip
  • under this folder create 7-Zip_v9.20Basic so the folder structure will be C:\apzdev\7zip\7-Zip_v9.20Basic
  • inside this folder add the file 7z920.exe, which is the 32bit file version of 7zip.
  • Install the app, this will also create the shortcuts needed.
  • Right-click the C:\apzdev\7zip\7-Zip_v9.20Basic folder and Sendto "SetupS Editor" this will open up the ssEditor.

  • Ensure 'ssApp' is the "Build Type".
  • Enter in the Title of the application in the Example "7-ZipBasic"
  • Enter in the version of the application in the Example "v9.20"
  • Enter in the URL of where the application can be located to enable users to find updates in the Example www.7-zip.org
  • Enter in a description of the application, this information can be found at the URL or the help file of the application.
  • Select the categories for the application, and click the "add" button for each one.

2. Assembly tab

  • Check that the "Install-to Path" is correct.

  • Under Assembly details Click browse button and select the installer.

  • This will then search for the silent install switch, after this click on the button and the process will be added to the assembly list in the Example "7z920.exe" /S
  • At this point save the file either by pressing (Ctrl+S) or clicking the save button on the toolbar.

3. Shortcuts tab

  • Click the "Default Menu" browse button and navigate to the Startmenu folder created by the app you just installed.

In the Example select 7-Zip and then click ok

  • From here select the shortcuts locations/options. Don't forget about the "shortcut names keep" box -- this will be used if the 'KeepAll' Option is not enabled.
  • Pick at least one "Menu Catalog" item for any advanced startmenu -- even if you don't use them others might.

4. Graphics tab

  • Folder Icon: Select from the main menu "Tools - Extract Icons (F10)" and find a file with the icon you'd like to represent the app. You'll get a window opened for the possible ones that has been extracted. Delete any extra files. Click Save button, for the preview to appear. Notice it creates a copy to the "ssApp.ico" -- delete the other file(s) so that they will not be added in the final deployment package.

  • ScreenShot: Select from the main menu "Tools - Screenshot - Grab Clipboard Picture (F12)". Open your app and when you have a nice picture you want press PrintScreen/Alt+PrintScreen. Return to ssEditor and click "Yes". Notice it automatically creates the necessary "ssApp.jpg".

  • Fader: You're basically on your own for this one. All you need to do is find (or convert to) a nice picture in .png format and copy that file to the "Build" folder. After copying the .png to the "Build" folder, simply click "Save" for it to appear in the Preview. Notice it creates a copy to the "ssApp.png" -- you'll need to delete the other file if you don't want that in your final deployment package.
    Hint: Places to look are the website, or sometimes from the "Install-to Path".

5. Post-processing tab

  • Examiine this to see if anything needs to be added. With ssApps it is likely that this tab will not be needed as the Installer carries out this process.

6. Build

  • IMPORTANT NOTE: This step is only available if building archive deployment packages (.apz/.pgz). Otherwise, the "Build" folder is complete for the ssWPI (folder) deployment package and no further action is required.
  • Check your Build options. Click Menu "Builds" and select options for how the builds will be done.
  • Finally, when ready, click "Tools, Build (F5)" -- or click the "Build" button on the Mini-Toolbar.

7. Uninstall

  • Now uninstall the app. Hint: Use CCleaner for this because after uninstalling simply use its built-in Registry cleaner.

8. Test

  • To test, simply double click on the .app or .apz file created by ssEditor.


Creating a (basic) ssApp

Creating a (basic) ssApp Previous page Return to chapter overview Next page

The following are some basic steps to make an ssApp. (See "Creating an ssApp" for a more detailed tutorial)

1. Preparation.

    • Create a temporary "build" folder. Any name will do.
    • Copy the installer to the "build" folder.
    • Install the app as you normally would.
    • Right-click the "build" folder and Sendto "SetupS Builder".
    • Important!: Select ssApp "Build Type". This configures "SetupS Builder" for the "what's and how's" of the package to be built.
    • Click Save (Ctrl+S) if desired -- or use the Save button on the Mini-Toolbar. Notice the Install-to Path changes to the %ProgramFiles% variable ;)

2. "Shortcuts" tab.

    • NOTE: Except for filling out the "shortcut names keep" box, the "Shortcuts" tab is mostly optional.
    • Click the "Default Menu" browse button and navigate to the Startmenu folder created by the app you just installed. If the app did not create a startmenu folder, then Click "Cancel" and use the Shortcut method below. Otherwise, when you find the app's default folder, click "Okay".
    • Notice at this point that some shortcuts are already filled in for you. Since this is an ssApp, this is not required; but they are convenient to have available. Especially if converting to a pppApp.
    • From here select the shortcuts locations/options. Don't forget about the "shortcut names keep" box -- this will be used if the 'KeepAll' Option is not enabled.
    • Pick at least one "Menu Catalog" item for any advanced startmenu -- even if you don't use them others might.
    • Shortcut Method: Click the "Display Name" browse button. Look for any shortcut for this app from such places as the Startmenu, the Desktop, etc.

3. "Assembly" tab

    • Check that the "Install-to Path" is what is desired.
    • Click Installer browse button and pick the installer you used. Hopefully it'll find the correct silent switches for you. If not, see # below on how to find them.
    • Click save here to see it placed into the Assembly box.

4. Go back to the "General" tab

    • Finish the rest of the Details -- such as Version, URL's, Category, and Description, etc.

5. Build!

    • IMPORTANT NOTE: This step is only available if building archive deployment packages (.apz/.pgz). Otherwise, the "Build" folder is complete for the ssWPI (folder) deployment package and no further action is required. Simply proceed to the next steps (Uninstall/Test).
    • Check your Build options. Click MenuBar "Builds" (between "Options" & "Tools") and select how you want you want your builds done.
    • Finally, when you're ready, click "Tools, Build (F5)" -- or click the "Build" button on the Mini-Toolbar.

6. Uninstall

    • Now uninstall the app. Hint: Use CCleaner for this because after uninstalling simply use its built-in Registry cleaner.

7. Test

    • To test, simply double click on the .app or .apz file created by ssEditor.


Creating an ssApp with Dual Arch

Creating an ssApp with Dual Arch Previous page Return to chapter overview Next page

Creating an ssApp with dual Architecture.

1. Preparation.

  • Create a temporary "build" folder. Such as apzdev in the root of the drive c:\apzdev
  • under this directory create a working folder of the app name.
  • In this example create a folder 7-Zip C:\apzdev\7zip
  • under this folder create 7-Zip_v9.20DualArch so the folder structure will be C:\apzdev\7zip\7-Zip_v9.20DualArch
  • inside this folder add the file 7z920.exe, which is the 32bit file version of 7zip.
  • inside this folder add the file 7z920-x64.msi, which is the 64bit file version of 7zip.
  • Install the app, this will also create the shortcuts needed.
  • Right-click the C:\apzdev\7zip\7-Zip_v9.20DualArch folder and Sendto "SetupS Editor" this will open up the ssEditor.

  • Ensure 'ssApp' is the "Build Type".
  • Enter in the Title of the application in the Example "7-Zip"
  • Enter in the version of the application in the Example "v9.20"
  • Enter in the URL of where the application can be located to enable users to find updates in the Example www.7-zip.org
  • Enter in a description of the application, this information can be found at the URL or the help file of the application.
  • Select the categories for the application, and click the "add" button for each one.

2. Assembly tab

  • Check that the "Install-to Path" is correct.

  • Under Assembly details Click browse button and select the installer.

  • This will then search for the silent install switch, after this click on the button and the process will be added to the assembly list in the Example "7z920.exe" /S
  • As this has two files one for 32bit and another for 64bit, click the browse button for the second file in the Example "7z920-x64.msi" /qb
  • In order for the ssApp to know which file to install according to the Operating System Architecture click on the appropiate directives to add to the assembly
  • So for 32bit select #Is_x86# so the line will read "7z920.exe" /S #Is_x86#
  • So for 64bit select #Is_x64# so the line will read"7z920-x64.msi" /qn #Is_x64#
  • At this point save the file either by pressing (Ctrl+S) or clicking the save button on the toolbar.

3. Shortcuts tab

  • Click the "Default Menu" browse button and navigate to the Startmenu folder created by the app you just installed.

In the Example select 7-Zip and then click ok

  • From here select the shortcuts locations/options. Don't forget about the "shortcut names keep" box -- this will be used if the 'KeepAll' Option is not enabled.
  • Pick at least one "Menu Catalog" item for any advanced startmenu -- even if you don't use them others might.

4. Graphics tab

  • Folder Icon: Select from the main menu "Tools - Extract Icons (F10)" and find a file with the icon you'd like to represent the app. You'll get a window opened for the possible ones that has been extracted. Delete any extra files. Click Save button, for the preview to appear. Notice it creates a copy to the "ssApp.ico" -- delete the other file(s) so that they will not be added in the final deployment package.

  • ScreenShot: Select from the main menu "Tools - Screenshot - Grab Clipboard Picture (F12)". Open your app and when you have a nice picture you want press PrintScreen/Alt+PrintScreen. Return to ssEditor and click "Yes". Notice it automatically creates the necessary "ssApp.jpg".

  • Fader: You're basically on your own for this one. All you need to do is find (or convert to) a nice picture in .png format and copy that file to the "Build" folder. After copying the .png to the "Build" folder, simply click "Save" for it to appear in the Preview. Notice it creates a copy to the "ssApp.png" -- you'll need to delete the other file if you don't want that in your final deployment package.
    Hint: Places to look are the website, or sometimes from the "Install-to Path".

5. Post-processing tab

  • Examiine this to see if anything needs to be added. With ssApps it is likely that this tab will not be needed as the Installer carries out this process.

6. Build

  • IMPORTANT NOTE: This step is only available if building archive deployment packages (.apz/.pgz). Otherwise, the "Build" folder is complete for the ssWPI (folder) deployment package and no further action is required.
  • Check your Build options. Click Menu "Builds" and select options for how the builds will be done.
  • Finally, when ready, click "Tools, Build (F5)" -- or click the "Build" button on the Mini-Toolbar.

7. Uninstall

  • Now uninstall the app. Hint: Use CCleaner for this because after uninstalling simply use its built-in Registry cleaner.

8. Test

  • To test, simply double click on the .app or .apz file created by ssEditor.


Creating a ppApp

Creating a ppApp Previous page Return to chapter overview Next page

1. Preparation.

  • Create a temporary "build" folder. Such as apzdev in the root of the drive c:\apzdev
  • under this directory create a working folder of the app name.
  • In this example create a folder wizmo C:\apzdev\wizmo
  • Under this create a directory ppApp
  • copy the file wizmo.exe to the directory C:\apzdev\wizmo\ppApp.
  • Right-click the C:\apzdev\wizmo folder and Sendto "SetupS Editor" this will open up the ssEditor.

  • Ensure 'ppApp' is the "Build Type".
  • Enter in the Title of the application in the Example "Wizmo Utils"
  • Enter in the version of the application in the Example "v1.1"
  • Enter in the URL of where the application can be located to enable users to find updates in the Example http://grc.com
  • Enter in a description of the application, this information can be found at the URL or the help file of the application.
  • Select the categories for the application, and click the "add" button for each one.

2. Assembly tab

  • Check that the "Install-to Path" is correct.
  • Type in %ppapp%\[apppath] replace [apppath] with the application name, with no spaces, in the example wizmo so the "Install-to Path" will have %ppapp%\wizmo

3. Shortcuts tab

  • Default menu - Enter in the default group that will be used to store the shortcuts in the example 'Wizmo'
  • Menu catalog - add in the catalog entries in the example 'System Utility'
  • Shortcuts Definitions - Display name, type in a shorcut name in the example 'Wizmo Lock Screen'
  • File target - select the file that will run in the example 'Wizmo.exe'
  • Icon file - select the icon file that will be displayed with the shortcut in the example 'lock.ico'
  • Tip: some icon files can be extracted using the utility 'Extract Icons' found under the Tools Menu.
  • Arguments - add in any arguments that will be used with the run file in the example 'lock' this will have the command 'wizmo.exe lock'
  • Description - enter in a brief description of what the shortcut will do, in the example 'Lock the screen'
  • To add another shortcut click on the create new shortcut button as shown in the figure below

  • Shortcuts Definitions - Display name, type in a shorcut name in the example 'Wizmo Power Off'
  • File target - select the file that will run in the example 'Wizmo.exe'
  • Icon file - select the icon file that will be displayed with the shortcut in the example 'wizmo_15.ico'
  • Arguments - add in any arguments that will be used with the run file in the example 'exit' this will have the command 'wizmo.exe exit'
  • Description - enter in a brief description of what the shortcut will do, in the example 'Power off computer'
  • Shortcut locations - Select Start Menu - Programs,
  • Optional select Desktop, this will add the first shortcut in the example 'Wizmo Lock Screen'

4. Graphics tab

  • Select the icon that will be shown in the application directory in the ppApps folder
  • Select the fader graphic that is in PNG graphic format
  • Select the screenshot that is in JPG graphic format

5. Post-processing tab

  • Examiine this to see if anything needs to be added. With some ppApps additional data such as registry entries will be required. In the example there is no additional data required.

6. Build

  • IMPORTANT NOTE: This step is only available if building archive deployment packages (.apz/.pgz). Otherwise, the "Build" folder is complete for the ssWPI (folder) deployment package and no further action is required.
  • Check your Build options. Click Menu "Builds" and select options for how the builds will be done.
  • Finally, when ready, click "Tools, Build (F5)" -- or click the "Build" button on the Mini-Toolbar.

7. Test

  • To test, simply double click on the .app or .apz file created by ssEditor.


Creating a ppApp with Dual Arch

Creating a ppApp with Dual Arch Previous page Return to chapter overview Next page


How to make a ppApp from an ssApp

How to make a ppApp from a ssApp Previous page Return to chapter overview Next page

Warning! This is is just too easy and may cause a false sense of security to develop after prolonged use of this quick and dirty method.

1. Preparation.

    • Create a temporary "build" folder. Any name will do.
    • Copy the contents of the the ssApp (i.e., "C:\Program Files") to the "build" folder.
    • Right-click the "build" folder and Sendto "SetupS Builder".
    • Important!: Select ppApp "Build Type". This will determine the .app-filename it needs to save the information to.
    • Click Save (Ctrl+S) -- or use the Save button on the Mini-Toolbar. Notice the Install-to Path changes to the %ppApp% variable ;)

2. "Assembly" tab

    • Remove the installer from the Assembly box. This step is not necessary except perhaps to keep things tidy.

3. Build!

    • Check your Build options. Click MenuBar "Builds" (between "Options" & "Tools") and select how you want you want your builds done.
    • Finally, when you're ready, click "Tools, Build (F5)" -- or click the "Build" button on the Mini-Toolbar.

4. Test

    • To test, simply double click on the .app or .apz file created by ssEditor.


Creating a ppGame

Creating a ppGame Previous page Return to chapter overview Next page

Creating a ppGame.

n

1. Preparation.

  • Create a temporary "build" folder. Such as apzdev in the root of the drive c:\apzdev
  • under this directory create a working folder of the app name.
  • In this example create a folder Real.Dominoes C:\apzdev\Real.Dominoes
  • Under this create a directory ppGame
  • copy the game files to the directory C:\apzdev\Real.Dominoes\ppGame
  • Right-click the C:\apzdev\Real.Dominoes folder and Sendto "SetupS Editor" this will open up the ssEditor.

  • Ensure 'ppGame' is the "Build Type".
  • Enter in the Title of the application in the Example "Real Dominoes"
  • Click on tick box for Game this will change the text from Version to Year and change the categories to games
  • Enter in the year of the application in the Example "2006"
  • Enter in the URL of where the application can be located to enable users to find updates in the Example http://www.brothersoft.com/games/real-dominoes.html
  • Enter in a description of the game, this information can be found at the URL or the help file of the game.
  • Select the categories for the game, and click the "add" button for each one.

2. Assembly tab

  • Check that the "Install-to Path" is correct.
  • Type in %ppgame%\[gamepath] replace [gamepath] with the game name, with no spaces, in the example RealDominoes so the "Install-to Path" will have %ppGames%\RealDominoes

3. Shortcuts tab

  • Default menu - Enter in the default group that will be used to store the shortcuts in the example 'Real Dominoes'
  • Menu catalog - add in the catalog entries in the example 'Board'
  • Shortcuts Definitions - Display name, type in a shorcut name in the example 'Real Dominoes'
  • File target - select the file that will run in the example 'real dominoes.exe'
  • Icon file - select the icon file that will be displayed with the shortcut
  • Tip: some icon files can be extracted using the utility 'Extract Icons' found under the Tools Menu.
  • Description - enter in a brief description of what the shortcut will do

4. Graphics tab

  • Select the icon that will be shown in the game directory in the ppGames folder
  • Select the fader graphic that is in PNG graphic format
  • Select the screenshot that is in JPG graphic format

5. Post-processing tab

  • Examine this to see if anything needs to be added.

6. Build

  • IMPORTANT NOTE: This step is only available if building archive deployment packages (.apz/.pgz). Otherwise, the "Build" folder is complete for the ssWPI (folder) deployment package and no further action is required.
  • Check your Build options. Click Menu "Builds" and select options for how the builds will be done.
  • Finally, when ready, click "Tools, Build (F5)" -- or click the "Build" button on the Mini-Toolbar.

7. Test

  • To test, simply double click on the .ppg or .pgz file created by ssEditor.


Creating a ppTweak

Creating a ppTweak Previous page Return to chapter overview Next page

Creating a ppTweak.

1. Preparation.

  • Create a temporary "build" folder. Such as apzdev in the root of the drive c:\apzdev
  • under this directory create a working folder of the app name.
  • In this example create a folder tweek C:\apzdev\tweak
  • under this folder create commandprompttogreen so the folder structure will be C:\apzdev\tweak\commandprompttogreen
  • Right-click the C:\apzdev\tweak\commandprompttogreen folder and Sendto "SetupS Editor" this will open up the ssEditor

  • Ensure 'ppTweek' is the "Build Type".
  • Enter in the Title of the application in the Example "tweak Command Prompt to Green"
  • Enter in the version of the application in the Example "v1.0"
  • Enter in the URL of where the application can be located to enable users to find updates in the Example www.lastos.org
  • Enter in a description of the application.

2. Assembly tab

  • Check that the "Install-to Path" is correct.
  • in this example %ppApps%\tweak has already been entered

3. Shortcuts tab

No Shortcuts

4. Graphics tab

  • Create a screenshot
  • Select a fader graphic

5. Post-processing tab

  • Enter or copy the Registry Entries in the example:

Windows Registry Editor Version 5.00

; Change Command Prompt Colours

; First value is background second is foreground eg. 0000000a = light green on black

;0=black 8=grey

;1=blue 9=light blue

;2=green a=light green

;3=aqua b=light aqua

;4=red c=light red

;5=purple d=light purple

;6=yellow e=light yellow

;6=white f=bright white

[HKEY_CURRENT_USER\Software\Microsoft\Command Processor]

"DefaultColor"=dword:0000000a

  • Tip: Click the "Pop-out editor" button to use notepad to edit instead.

6. Build

  • IMPORTANT NOTE: This step is only available if building archive deployment packages (.apz/.pgz). Otherwise, the "Build" folder is complete for the ssWPI (folder) deployment package and no further action is required.
  • Check your Build options. Click Menu "Builds" and select options for how the builds will be done.
  • Finally, when ready, click "Tools, Build (F5)" -- or click the "Build" button on the Mini-Toolbar.

7. Test

  • To test, simply double click on the .app or .apz file created by ssEditor.


How to update a ppApp or ssApp

How to update a ppApp or ssApp Previous page Return to chapter overview Next page

Updating a ppApp or ssApp is even easier:

    1. If .apz then first extract to a temporary build folder.
    2. Add any updated files (for the ppApp) or installers (for the ssApp -- don't forget to delete the old one)
    3. Right-click, "edit" (to use ssEditor) or "open with" (something like Notepad2)
    4. Make changes/updates as needed
    5. Save or Build (if .apz this will also update the .md5)


References

References Previous page Return to chapter overview Next page

Herein are miscellaneous articles of some interest or usefulness.


Deployment Package Specifications

Deployment Package Specifications Previous page Return to chapter overview Next page

The deployment packages can be in either of two forms. One is as a 'folder' package. The other is an archive package (usually with an extension of .apz or .pgz). Both can be utilized by ssWPI or SetupS. Both have their relative merits and downsides. None the less, their contents will remain the same.

In addition to the following, an ssApp will of course have to include all of its setup/install files in order to complete its install; whereas, ppApp's/ppGames would only need the following.

Ξ Note: 'BuildType' can be one of the following 'ssApp', 'ppApp', or 'ppGame'.

BuildType.app|ppg

This is the heart of the deployment package. Resembling an .ini file, this file tells SetupS and ssWPI exactly what to do. See SetupS File Specification (.app/.ppg) .

(Required)

BuildType.jpg

Screen-shot for ssWPI. Though there is no limit on resolutions, for practical reasons it's recommended to go no higher than 600x480.

(Optional)

BuildType.png

Fader (graphic) for ssWPI.

(Optional)

BuildType.ico

Folder icon for both the install-to folder and the Startmenu. Up to 256px for Vista/7 icons.

(Optional)

BuildType.md5

Allows for an integrity check since 7-Zip uses no recovery records. But better than nothing.

(Optional)

BuildType.7z|rar|zip|cab

Only used if the BuildType is ppApp or ppGame. The equivalent of an ssApp's "Installer" or "Setup". See Recommended 7zip archive settings .

(Required unless using a "ppApps Live" folder)

\BuildType\

A folder that gets copied to the installed-to folder during post-processing. Handy for patches or update files outside the standard install/setup files.

(Optional)

Patch.7z|rar|zip|cab

An archive that gets extracted to the installed-to folder during post-processing. Handy for patches or update files outside the standard install/setup files.

(Optional)

BuildType.cmd|bat

Run during post-processing, now depreciated (but still supported) as the file can simply be copy & pasted into the BuildType.app file.

(Optional)

BuildType.reg

Applied during post-processing, now depreciated (but still supported) as the file can simply be copy & pasted into the BuildType.app file.

(Optional)

Folder.jpg|gif

An image for thumbnail views of the installed-to folder.

(Optional)

As one can see, except for the 'BuildType.app|ppg' file, none are required. The others are only in how the packager wishes their packages to be deployed. But if all are available, then the package is not as limited otherwise.


SetupS File Specification (.app/.ppg)

SetupS File Specification (.app/.ppg) Previous page Return to chapter overview Next page

This is the most important file of the ssTek deployment package. It is an actual (and valid) .INI-file.

Use any text-editor, such as Notepad2, to create or modify one. Or the easiest way is to simply use the SetupS Editor (ssEditor) included with the SetupS package.

Also as in any .ini-file, most system and environmental variables, frequently seen enclosed in %...%, are recognized plus many new ones specific only to SetupS (i.e., %ppApps%). See Automatic Variable Substitutions Chart for more details.

For details, click on the Section names:

[SetupS] (Required)

Title=

(Required). Name of Application or Game.

Version=

(Optional). Version (for App's) or Copyright (for Games) information, for example:

v1.23|c2009, etc.

Description=

(Optional). Currently only used by ssWPI. Enter a description of the application or game. Use "^^" to force line-breaks.

URL=

(Optional). Currently only used by ssWPI. Enter websites addresses here. Separate multiple tags with "|". For example: http://www.xyz.com | http://www.example.com

Category=

(Recommended). Currently only used by ssWPI. See Category List for a complete list. Separate multiple categories with "|".

OS=

(Optional). Used by ssWPI for filtering app/game lists or by SetupS to gate installs. Use:

0 = None specified or "Any". Effectively the same as 15 ("All"), below.

1 = NT5: 2000, XP, 2003, etc. (20) #Is_OS=5#

2 = NT6 (pre-Metro/Modern): Vista, 7, 2008, 2011, etc. (21) #Is_OS>=6.0# #Is_OS<=6.1#

4 = Metro/Modern (pre-Win10): 8, 8.1, 2012 (22) #Is_OS>=6.2# #Is_OS<=6.3#

8 = NT10: 10, 2016, etc. (23) #Is_OS>=10.0#

15 = All (1+2+4+8)

Architecture=

(Optional). Used by ssWPI for filtering app/game lists or by SetupS to gate installs. Use:

1 (x86)

2 (x64)

3 (DualArch)

BuildType=

(Optional). Use:

ssApp

ppApp

ppGame

ppTweak

App-File Version=v9.20.02.13.0

Used only by SetupS internally to determine what version level the current file-format was created under. A five-number group with the first number always "v9" and rest being the current project core version.

App-File Style=1(Dual)|2 (INI)

Used internally by SetupS to determine what style the current file-format was created with. Either dual-format consisting of both the legacy format and the INI-file format; or strictly just the INI-file format.

AppPath=

(Recommended but not required). The "Installed-to" path goes here -- the actual physical (final) location of the app or game.

Assembly=

(Recommended for ssApps. Optional for ppApps/ppGames). Ignored during Regen-mode. Place commands, components, directives (see below), setup, or install package(s) here with proper silent install switches or script(s) to automate the install. Mainly for SetupS/ssApps, but can be used with ppApps/ppGames for any post-install or preprocessing commands, script(s), or registry entries. Use "^^" to force line-breaks.

See these for useful Components or Directives .

Some examples:

setup.msi /qb
%WaitForIt% "%ProgramsCommon%\TestStartmenu.lnk"
%ProcessKill% "Notepad.exe"
%AddonInstaller% "%SourcePath%\Test_addon.7z"
%AddToHosts% "127.0.0.1 secure.example.com"
%Extract% "Extras.rar" -o"%SystemRoot%\LastXP"
md "%ProgramFiles%\Something" #CMD#
"7z920-x64.msi" /qb #Is_x64#
ImportTest.reg
ScriptTest.cmd

StartMenuSourcePath=

(Required only if shortcuts are to be created). The original shortcut folder name for SetupS/ssApp's or default/non-advanced StartMenu folder for ppApps/ppGames. This is where shortcuts get created if no advanced StartMenu sorting is selected.

Catalog=

(Recommended) For Advanced StartMenu sorting only, this defines where to create shortcuts. See StartMenu Catalog for a complete list. Separate each catalog entry with "|".

ShortCutNamesKeep=

(Optional or Required depending on the KeepAll flag or if BuildType is a ppApp or ppGame). List which shortcuts desired to keep (if KeepAll=No). First one listed here is the most important one as it is the one to be used for creating the Desktop, Startup, Sendto, or QuickLaunch shortcut(s).

FileTypes=

(Optional). List the file extension(s) to associate with the entire Application or Game. The use of Gate Directives (such as #Is_x64#, #Is_NT6#, etc.) is allowed. Separate each with "|".

InstallFonts=

(Optional). List font-files here to be installed to the Windows Fonts applet. Use of %Variables% and Gate Directives (such as #Is_x64#, #Is_NT6#, etc.) is allowed. Separate each with "|".

RegisterDLL=

(Optional). List any files (one per line) here to be installed via the Windows Register Server. Use of %Variables% and Gate Directives (such as #Is_x64#, #Is_NT6#, etc.) is allowed.

PriorityOrder=

(Optional). Used by ssWPI for determining which get installed before or after others. Default is "5". Use as such:

0 - Installs these before any other apps.

1 - Installs these after the "0" PriortyOrder items.

5 - Default for items without PriorityOrder provided.

9 - Graphics Drivers.

99 - Antivirus (always do these last to stop it interfering with the install and slowing down the process by scanning everything you do during the install).

100+ - Anything else that may cause ssWPI to not be automatic (user interaction).

999 - Maximum PriorityOrder.

Flags=

(Optional). Merely list to set these (see list below); separating each with "|".

Shortcut Locations (applies to all ShortcutS defs listed):

NotInStartmenu

Use this to NOT create Shortcuts in the StartMenu. Over-rides the Shortcut Options flags: KeepInFolder and KeepAll, below.

Root

Create shortcut in "Start Menu" (a.k.a., Root). Only the first shortcut listed from "ShortCutNamesKeep" or from the ShortcutS defs.

Programs

Create shortcut in "Start Menu\Programs". Only the first shortcut listed from "ShortCutNamesKeep" or from the ShortcutS defs.

StartUp

Create shortcut in "Start Menu\Programs\Startup". Only the first shortcut listed from "ShortCutNamesKeep" or from the ShortcutS defs.

SendTo

Create shortcut in "SendTo" context-menu. Only the first shortcut listed from "ShortCutNamesKeep" or from the ShortcutS defs.

Desktop

Create shortcut on "Desktop". Only the first shortcut listed from "ShortCutNamesKeep" or from the ShortcutS defs.

QuickLaunch

Create shortcut in "QuickLaunch". Only the first shortcut listed from "ShortCutNamesKeep" or from the ShortcutS defs.

CurrentUserOnly

Create shortcut(s) for "Current User" instead of "AllUsers" using above listed flags. Default is to create shortcuts for "AllUsers".

TaskbarPin

(Windows 7 only). Pins a shortcut to the Taskbar. Only the first shortcut listed from "ShortCutNamesKeep" or from the ShortcutS defs.

StartmenuPin

(Windows 7 only). Pins a shortcut to the Startmenu. Only the first shortcut listed from "ShortCutNamesKeep" or from the ShortcutS defs.

Shortcut Options (applies to all ShortcutS defs listed):

KeepAll

Keep all the shortcuts available in the ShortcutS defs and ignore ShortCutNamesKeep.

KeepInFolder

Contain the shortcut(s) in the folder specified in "StartMenuSourcePath".

NoShortcuts

Suppress shortcut creation of any kind whatsoever. Over-rides AlwaysSort, below.

AlwaysSort

Force shortcut creation into an Advanced menu rather than the Standard one

NoMenuIcons

Suppress this App's StartMenu icon folder creation

RefreshDesktop

Force a desktop refresh (without having to cycle thru a logoff then logon). This will also refresh Explorer views as well.

LivePE

Mark this ppApp/ppGame for LivePE's such as ppAppsLive or ppGamesLive (not implemented).

NotMetroFriendly

Over-rides KeepInFolder and KeepAll (above) to place shortcuts from the 'Shortcut names to keep' list or if empty, then the first ShortcutS def listed. Note: this will only affect shortcuts on Windows 8 (NT6.2) or greater.

Post-processing Options:

NoneThing

Suppress SetupS related files. Basically, this prevents creation of the Aux files (screenshot, fader, etc.), advanced startmenu shortcuts, folder icons, and the .app-file. This also means that the app will be rendered invisible or nonexistent to SetupS and ssWPI.

ssWPI Options (the following only affect ssWPI):

AlwaysShow
DuringSetupOnly
InstallT13
InstallInstant

[Meta]

(Optional). Extra application or game information.

Tags=Basically, a list of sub-categories.

(Optional). Currently only used by ssWPI. Separate multiple tags with "|". Unlike "Category", this is a searchable-freeform field where any keyword or phrase is allowed.

Publisher=

(Optional). Currently only used by ssWPI.

Language=Mainly used only with NON English releases. Multilingual and bilingual are optional.

(Optional). Currently only used by ssWPI.

Releaser=The person or group who built or assembled this deployment package.

(Optional). Currently only used by ssWPI.

Additional=Any extra information desired.

(Optional). Currently only used by ssWPI.

Rating=

(Optional). Currently only used by ssWPI.

RequiredRuntimes=

(Optional). Currently only used by ssWPI.

ReleaseVersion=

(Optional). Currently only used by ssWPI.

ReleaseDate=

(Optional). Currently only used by ssWPI.

InstalledSize=

(Optional). Currently only used by ssWPI. This is a numeric value representing the number of bytes on a drive an application or game takes-up after an install.

LicenseType=

(Optional). Currently only used by ssWPI. The type of license that applies to the app or game. Used as so:

0 (N/A or Unassigned).

1 (non-gratis). Proprietary and closed-source (commercial). Example: Microsoft Office.

2 (gratis-only). Proprietary and closed-source (non-profit). Example: Kingsoft Office.

3 (libre). Non-proprietary and open-source. Example: LibreOffice.

[{Shortcut-name}.lnk]

(Optional). List ppApp/ppGame or extra ssApp shortcuts in these section(s). {Shortcut-name} is the link or name of the shortcut as it will appear in the StartMenu, etc. Each Shortcut is defined as follows:

Target=

(Required). This is the actual physical filename of app or game; usually the .exe. Do not use parameters or arguments here (see below for that).

WorkingDir=

(Optional). What folder to start in, or work from.

Comment=

(Optional). A short description of this shortcut.

Arguments=

(Optional). Shortcut arguments or parameters, if any

Icon=

(Optional). File name of icon to use.

IconIndex=

(Optional). The icon instance to use (default is 0)

Extension=

(Optional). File extension(s) to associate with this Shortcut/app. Over-rides <Extensions> above.

Windowstate=

(Optional). The state the shortcut is launched in. Use: 1=Normal (default), 2=Minimized, not active, 3=Maximized, 7=Minimized but not active.

Flags=

(Optional). Only gates (such as Is_x64, Is_NT6, etc.) are supported at the moment.

Catalog=

(Optional). Not supported at the moment.

Also, unique to DualArch forms is the link names, {Shortcut-name}, will have appended either {#1} or {#2} for their respective architecture information contained within the definition.


Legacy SetupS File Specification (.app/.ppg)

Legacy SetupS File Specification (.app/.ppg) Previous page Return to chapter overview Next page

Note: This file-format has been depreciated. It is provided here as reference-only and due to the requirement of maintaining backwards compatibility.

This is the most important file of the ssTek deployment package. It is an ordinary text file that resembles an .ini-file but is much more advanced. Section names are enclosed in <...> and although keys and their values are handled much the same way as .ini-files, this spec allows for values without keys and these values can actually be several lines of data.

Use any text-editor, such as Notepad2, to create or modify one. Or the easiest way is to simply use the SetupS Editor (ssEditor) included with the SetupS package.

Also like an .ini-file, most system and environmental variables, frequently seen enclosed in %...%, are recognized plus many new ones specific only to SetupS (i.e., %ppApps%). See Automatic Variable Substitutions Chart for more details.

Ξ Note: Section ordering is unimportant, with two exceptions: <Title> needs to be the first section (a requirement for ssWPI) and <End> needs to be last (for obvious reasons).
_____________________________________________________

<Title>

(Required)
Single-line only. Name of Application or Game.

<Version>

(Optional)
Single-line only. Version (for App's) or Copyright (for Games) information, for example:

v1.23|c2009, etc.

<URL>

(Optional)
Multiline allowed. Currently only used by ssWPI. Enter websites addresses here. For example:

http://www.xyz.com
http://www.example.com

<Description>

(Optional)
Multiline allowed. Currently only used by ssWPI. Enter a description of the application or game.

<Assembly>

(Recommended for ssApps. Optional for ppApps/ppGames)
Ignored during Regen-mode. Multiline allowed. Place commands, components, directives (see below), setup, or install package(s) here with proper silent install switches or script(s) to automate the install. Mainly for SetupS/ssApps, but can be used with ppApps/ppGames for any post-install or preprocessing commands, script(s), or registry entries.

See these for useful Components or Directives .

Some examples:

setup.msi /qb
%WaitForIt% "%ProgramsCommon%\TestStartmenu.lnk"
%ProcessKill% "Notepad.exe"
%AddonInstaller% "%SourcePath%\Test_addon.7z"
%AddToHosts% "127.0.0.1 secure.example.com"
%Extract% "Extras.rar" -o"%SystemRoot%\LastXP"
md "%ProgramFiles%\Something" #CMD#
"7z920-x64.msi" /qb #Is_x64#
ImportTest.reg
ScriptTest.cmd

<Category>

(Recommended)
Single-line only. Separate multiple categories with "|" on the same line. Currently only used by ssWPI. See Category List for a complete list.

<Flags>

(Optional)
Set these = "Yes/No", "1/0" or "True/False" (whatever your preference). Note: Assumed to be "No/0/False" unless otherwise noted; such as 'MakeInStartMenu' and 'AllUsers', below.

The following are recognized by SetupS and apply mainly to shortcut creation.

Shortcut Locations:

MakeInStartMenu=

Default is Yes, so set to "No" to NOT create Shortcuts in the StartMenu. . Affected by the Shortcut Options: "KeepInFolder" and "KeepAll", below.

MakeInRoot=

Create shortcut in "Start Menu" (Root). Only the first shortcut listed from <ShortCutNamesKeep> or from <ShortcutS>.

MakeInPrograms=

Create shortcut in "Start Menu\Programs". Only the first shortcut listed from <ShortCutNamesKeep> or from <ShortcutS>.

MakeInStartUp=

Create shortcut in "Start Menu\Programs\Startup". Only the first shortcut listed from <ShortCutNamesKeep> or from <ShortcutS>.

MakeSendTo=

Create shortcut in "SendTo" context-menu. Only the first shortcut listed from <ShortCutNamesKeep> or from <ShortcutS>.

MakeDesktop=

Create shortcut on "Desktop". Only the first shortcut listed from <ShortCutNamesKeep> or from <ShortcutS>.

MakeQuickLaunch=

Create shortcut in "QuickLaunch". Only the first shortcut listed from <ShortCutNamesKeep> or from <ShortcutS>.

AllUsers=

Create shortcut(s) for "AllUsers" instead of "Current User" using above listed flags.
Default is Yes, so set to "No" to create Shortcuts for "Current User".

TaskbarPin=

(Windows 7 only). Pins a shortcut to the Taskbar. Only the first shortcut listed from <ShortCutNamesKeep> or from <ShortcutS>.

StartmenuPin=

(Windows 7 only). Pins a shortcut to the Startmenu. Only the first shortcut listed from <ShortCutNamesKeep> or from <ShortcutS>.

Shortcut Options:

KeepAll=

Keep all the shortcuts available in <ShortcutS> and ignore <ShortCutNamesKeep>. Applies to Shortcut Location "MakeInStartMenu" only.

KeepInFolder=

Contain the shortcut(s) in the folder specified in <StartMenuSourcePath>. Applies to Shortcut Location "MakeInStartMenu" only.

NeverSort=

Suppress shortcut creation of any kind whatsoever. Over-rides "AlwaysSort", below.

AlwaysSort=

Force shortcut creation into an Advanced menu rather than the Standard one

NoMenuIcons=

Suppress this App's StartMenu icon folder creation

RefreshDesktop=

Force a desktop refresh (without having to cycle thru a logoff then logon)

LivePE=

Mark this ppApp/ppGame for LivePE's such as ppAppsLive or ppGamesLive (not implemented)

Post-processing Options:

NoneThing=

Suppress SetupS related files. Basically, this prevents creation of the Aux files (screenshot, fader, etc.), advanced startmenu shortcuts, folder icons, and the .app-file. This also means that the app will be rendered invisible or nonexistent to SetupS and ssWPI.

ssWPI Options (the following only affect ssWPI):

AlwaysShow=
DuringSetupOnly=
InstallT13=
InstallInstant=
Order=

<AppPath>

(Recommended but not required)
Single-line only. Install to path here -- the actual physical (final) location of the app or game.

<StartMenuSourcePath>

(Required only if shortcuts are to be created)
Single-line only. The original shortcut folder name for SetupS/ssApp's or default/non-advanced StartMenu folder for ppApps/ppGames. This is where shortcuts get created if no advanced StartMenu sorting is selected.

<MenuCatalog>

(Recommended)
Multiline allowed. For Advanced StartMenu sorting only, this defines where to create shortcuts. See StartMenu Catalog for a complete list. Note, if utilized, <StartMenuDestPath> is ignored.

<StartMenuDestPath>

(Depreciated)
Only two lines allowed. For Advanced StartMenu sorting only, this defines where to create shortcuts. The first line is for the Kazz Layout (see StartMenu Destinations - Kazz ); and the second line is the ssTek Layout (see StartMenu Destinations - LastOS ). Separate multiple locations with "|" on the same line as the layout. Ignored if <MenuCatalog> is used instead (see above).

<ShortCutNamesKeep>

(Optional or Required depending on the KeepAll flag or if BuildType is a ppApp or ppGame)
Multiline allowed. List which shortcuts desired to keep (if KeepAll=No). First one listed here is the most important one as it is the one to be used for creating the Desktop, Startup, Sendto, or QuickLaunch shortcut(s).

<OS>

(Optional)
Single-line only. Used by ssWPI for filtering app/game lists or by SetupS to gate installs. Use: 1 (2K/XP/2K3) | 2 (Vista/7)

<Architecture>

(Optional)
Single-line only. Used by ssWPI for filtering app/game lists or by SetupS to gate installs. Use: 1 (x86) | 2 (x64) | 3 (DualArch)

<LicenseType>

(Optional)
Single-line only. Used by ssWPI for filtering app/game lists. Use: 1 (non-gratis) | 2 (gratis-only) | 4 (libre)

<BuildType>

(Optional)
Single-line only. Use: ssApp|ppApp|ppGame

<Script>

(Optional)
Multiline allowed. Place batch file (.bat) or script (.cmd) contents here. Use of %Variables% including Component variables is allowed (and encouraged). Also, Gate Directives (such as #Is_x64#, #Is_NT6#, etc.) are allowed.

<Registry>

(Optional)
Multiline allowed. Place the contents of registy tweaks or patches (.reg) here. Use of %Variables% and Gate Directives (such as #Is_x64#, #Is_NT6#, etc.) is allowed (and encouraged).

<Extensions>

(Optional)
List the file extension(s) (one per line) to associate with the entire Application or Game. The use of Gate Directives (such as #Is_x64#, #Is_NT6#, etc.) is allowed.

<InstallFonts>

(Optional)
List font-files (one per line) here to be installed to the Windows Fonts applet. Use of %Variables% and Gate Directives (such as #Is_x64#, #Is_NT6#, etc.) is allowed.

<RegisterDLL>

(Optional)
List any files (one per line) here to be installed via the Windows Register Server. Use of %Variables% and Gate Directives (such as #Is_x64#, #Is_NT6#, etc.) is allowed.

<ShortcutS>

(Optional)
List ppApp/ppGame or extra ssApp shortcuts here. Each Shortcut is defined as follows:

Target=

Required. Must be first in the section. This is the actual physical filename of app or game; usually the .exe. Do not use parameters or arguments here (see below for that).

Shortcut=

Required. This is link or name of the shortcut as it will appear in the StartMenu, etc.

WorkingDir=

Optional. What folder to start in, or work from.

Comment=

Optional. A short description of this shortcut.

Arguments=

Optional. Shortcut arguments or parameters, if any

Icon=

Optional. File name of icon to use.

IconIndex=

Optional. The icon instance to use (default is 0)

Extension=

Optional. File extension(s) to associate with this Shortcut/app. Over-rides <Extensions> above.

Windowstate=

Optional. The state the shortcut is launched in. Use 1=Normal (default), 2=Minimized, not active, 3=Maximized, 7=Minimized but not active.

Flags=

Optional. Only gates (such as #Is_x64, #Is_NT6, etc.) are supported at the moment.

<Meta>

(Optional)
Tags=

Optional. Separate multiple tags with "|". Currently only used by ssWPI. Unlike <Category>, this is a searchable-freeform field where any keyword or phrase is allowed.

Publisher=

Language=

Releaser=

Additional=

Rating=

RequiredRuntimes=

ReleaseVersion=

ReleaseDate=

InstalledSize=

LicenseType=

Optional. The type of license that applies. Use as so:

0 (N/A or Unassigned).

1 (non-gratis). Proprietary and closed-source (commercial). Example: Microsoft Office.

2 (gratis-only). Proprietary and closed-source (non-commercial). Example: Kingsoft Office.

3 (libre). Non-proprietary and open-source. Example: LibreOffice.

<End>


Automatic Variable Substitution Chart

Automatic Variable Substitution Chart Previous page Return to chapter overview Next page

System/Environment data

%Variable% | NT v5.x (XP/2K/2K3) | NT v6.x (Vista/7)
%SystemDrive% | C: | C:
%SystemRoot% | C:\Windows | C:\Windows
%WinDir% | C:\Windows | C:\Windows
%SystemDir% 1 | C:\Windows\System32 | C:\Windows\System32
%ProgramFiles% | C:\Program Files | C:\Program Files
%ProgramFiles(x86)% 2 | C:\Program Files (x86) | C:\Program Files (x86)
%CommonProgramfiles% | %ProgramFiles%\Common Files | %ProgramFiles%\Common Files
%CommonProgramfiles(x86)% 2 | %ProgramFiles(x86)%\Common Files | %ProgramFiles(x86)%\Common Files
%ComputerName% | {computername} | {computername}
%Comspec% | %WinDir%\System32\cmd.exe | %WinDir%\System32\cmd.exe
%Path% | {system paths};{program paths} | {system paths};{program paths}

1 SetupS-only generated.

2 Variables with (x86) are only available with x64 architectures.

"Current User" data

%Variable% | NT v5.x (XP/2K/2K3) | NT v6.x (Vista/7)
%Username% | {username} | {username}
%HomeDrive% | C: | C:
%HomePath% | \Documents and Settings\{username} | \Users\{username}
%UserProfile% | C:\Documents and Settings\{username} | C:\Users\{username}
%Temp% | %UserProfile%\Local Settings\Temp | %UserProfile%\AppData\Local\Temp
%Tmp% | %Temp% | %Temp%
%AppData% | %UserProfile%\Application Data | %UserProfile%\AppData\Roaming
%Desktop% | %UserProfile%\Desktop | %UserProfile%\Desktop
%Favorites% | %UserProfile%\Favorites | %UserProfile%\Favorites
%MyDocuments% | %UserProfile%\{username}'s Documents | %UserProfile%\Documents
%StartMenu% | %UserProfile%\Start Menu | %AppData%\Microsoft\Windows\Start Menu
%Programs% | %StartMenu%\Programs | %StartMenu%\Programs
%Startup% | %Programs%\Startup | %Programs%\Startup
%SendtoPath% | %UserProfile%\SendTo | %AppData%\Microsoft\Windows\SendTo
%QuickLaunch% | %AppData%\Microsoft\Internet Explorer\Quick Launch | %AppData%\Microsoft\Internet Explorer\Quick Launch
%LocalAppData% | %UserProfile%\Local Settings\Application Data 1 | %UserProfile%\AppData\Local

1 SetupS-simulated.

"All Users" data

%Variable% | NT v5.x (XP/2K/2K3) | NT v6.x (Vista/7)
%AllUsersProfile% | C:\Documents and Settings\All Users | C:\ProgramData
%AppDataCommon% | %AllUsersProfile%\Application Data | %AllUsersProfile%\Application Data
%DesktopCommon% | %AllUsersProfile%\Desktop | %Public%\Desktop
%DocumentsCommon% | %AllUsersProfile%\Documents | %Public%\Documents
%FavoritesCommon% | %AllUsersProfile%\Favorites | %Public%\Favorites
%StartMenuCommon% | %AllUsersProfile%\Start Menu | %AllUsersProfile%\Microsoft\Windows\Start Menu
%ProgramsCommon% | %StartMenuCommon%\Programs | %StartMenuCommon%\Programs
%StartupCommon% | %ProgramsCommon%\Startup | %ProgramsCommon%\Startup
%SendtoCommon% | %AllUsersProfile%\SendTo 1 | %AllUsersProfile%\SendTo
%Public% | %AllUsersProfile%\..\Public 1 | C:\Users\Public

1 SetupS-simulated.

SetupS data

%Variable% | Description
%INIpath% | Same as %SourcePath% (legacy).
%SourcePath% | Full path (drive + folder) to the .app or .ppg file.
%SourceDrive% | Drive only of the .app or .ppg file.
%SourceFolder% | Folder only path to the .app or .ppg file.
%ppApps% | Full path (drive + folder) to the system's "x:\ppApps\" folder.
%ppAppsDrive% | Drive only of the system's "x:\ppApps\" folder.
%ppGames% | Full path (drive + folder) to the system's "x:\ppGames\" folder.
%ppGamesDrive% | Drive only of the system's "x:\ppGames\" folder.
%Tools% | Full path (drive + folder) to SetupS's Tools folder.
%ToolsDrive% | Drive only of SetupS's Tools folder.
%ToolsFolder% | Folder only path to SetupS's Tools folder.
%InstalledPath% | Same as %AppPath%.
%AppPath% | Full path (drive + folder) to the App's or Game's actual installed-to folder.
%AppDrive% | Drive only of the App's or Game's actual installed-to folder.
%AppFolder% | Folder only path to the App's or Game's actual installed-to folder.
%CDROM% | Same as %CDDRIVE%.
%CDDRIVE% | Drive only of the system's optical drive (real or virtual).
%ssTekResources% | For "%WinDir%\ssTek" (ie, "C:\Windows\ssTek").

SetupS Component Tools.

%AddonInstaller% {path\filename} : Process Addons such as ones from Kel or RyanVM.

Exactly equivalent to: 'AddonInstaller.exe {path\filename}'

%ProcessKill% {filename} : To force a process/task to close from a given filename.

Exactly equivalent to: 'ProcessKill.exe {filename}'

%AddToHosts% {IP address} {host name} : Sets mappings of IP addresses to host names.

Exactly equivalent to: 'AddToHosts.exe {IP address} {host name}'

%WaitForIt% {path\filename}|{filename} : Force SetupS to pause until a specific file or process is created.

Shortcut files (.lnk) are recommended because they are often created last by installers.

Exactly equivalent to: 'WaitForIt.exe {path\filename}|{filename}'

%Extract% {archive} -o{destination path} : Extract an archive to a specified destination path.

Exactly equivalent to: '7z x -y -aoa {archive} -o{destination path}'

SetupS Directives. Note: Except for Gate Directives (#Is_x64#, #Is_NT6#, etc.) these are for the <Assembly> section ONLY.

#Is_x86# : Process this line for 32-bit OS-Architectures (x86) only. May also be used in any of the following:

<Assembly>, <Script>, <Registry>, <Extensions>, <InstallFonts>, <RegisterDLL>; and <ShortcutS> with the Flags definition.

#Is_x64# : Process this line for 64-bit OS-Architectures (x64) only. May also be used in any of the following:

<Assembly>, <Script>, <Registry>, <Extensions>, <InstallFonts>, <RegisterDLL>; and <ShortcutS> with the Flags definition.

#Is_NT5# : Process this line for NT5.x OS's only (Windows 2000/XP/2003). May also be used in any of the following:

<Assembly>, <Script>, <Registry>, <Extensions>, <InstallFonts>, <RegisterDLL>; and <ShortcutS> with the Flags definition.

#Is_NT6# : Process this line for NT6.x OS's only (Windows Vista/7/2008). May also be used in any of the following:

<Assembly>, <Script>, <Registry>, <Extensions>, <InstallFonts>, <RegisterDLL>; and <ShortcutS> with the Flags definition.

#CMD# : Process this line as a command-line using the DOS console (aka, the Command-line Interpreter).

#ApplyRegistry# : Apply the <Registry> section. Skips it during Post-processing.

#RunScript# : Run the <Script> section with the Source folder as the 'Start In' or working folder. Skips it during Post-processing.

#RegisterDLL# : Process the <RegisterDLL> section. Skips it during Post-processing.

#InstallFonts# : Process the <InstallFonts> section. Skips it during Post-processing.

#ShortcutS# : Process the <ShortcutS> section... all shortcut/startmenu related tasks (w/ StartMenu Folder icons) AND File Association(s). Skips it during Post-processing.

#AppPathFolderIcon# : Install-path Folder Icon


Recommended 7zip archive settings

Recommended 7zip archive settings Previous page Return to chapter overview Next page

After many long discussions and a lot of trial & error, the team recommends the following settings to use with 7zip, especially if one has the computing power:

"Install" archive Archive deployment (.apz/.pgz)
ssApp: N/A LZMA2,Ultra,Non-solid
ppApp: LZMA2,Ultra,Solid Copy/Store*
ppGame: LZMA2,Ultra,Solid Copy/Store*

Ξ Note that non-solid is not an option for Copy/Store since there is no compression algorithm involved.


File-Naming Best Practices

File-Naming Best Practices Previous page Return to chapter overview Next page

Introduction:

This guide is an introduction to the file naming conventions you will see used when using ssTek. As the already well-established release groups had long ago discovered, a filename can contain a ton of info. So it's important how we structure or format our database-like filenames.

Indexing Structures, Filing Systems, and Character Sets:

With any large amount of information, it is important for the people accessing it to have some kind of structure to navigate their way to the information they're looking for. If there is no structure for locating specific data, the collection of information is virtually useless and the task of finding what you are looking for becomes like trying to find a needle in a haystack.

For this reason, a relatively new convention was developed for the naming of files. This naming convention was formally ratified by many - if not most - of the well known release groups. The use of these standards, along with the files they are attached to, have trickled down to the P2P community, and now to us here at ssTek.

Rules for naming files and folders are an important part of the standards. Correctly named folders make it easier to maintain clean archives and unique filenames are necessary to allow any duplicate checker program to work properly.

Also, since FTP servers, operating systems, or file systems may not allow special characters in file or directory names, only a small set of characters is allowed. And substitutions are made where special characters would normally be used (e.g. ç replaced by c); or these characters are simply omitted, such as an asterisk(*).

So in order to minimize the problems due to the many platforms a release may encounter during its distribution, a very specifically defined character set is used in naming of the files and folders. This ubiquitous character set includes the upper- and lower-case English alphabet, numerals, and several basic punctuation marks. It is outlined below:

ABCDEFGHIJKLMNOPQRSTUVWXYZ

abcdefghijklmnopqrstuvwxyz

0123456789'!+-,._()[]

The Absence of Spaces:

Since spaces are explicitly disallowed in all current standards, the first thing you'll see is a lot of dots; or full stops if you insist on using the 20th century term for them. Get used to it and learn to love 'em.

The reason you see dots instead of spaces (Kind.Of.Like.This) is because different operating systems and software read spaces in different ways. For example, even in simple HTML, a space can often be automatically converted to %20, depending on why kind of software you're using to read it and how well that software converts the encoded text into human-readable text.

Rather than making people decipher file%20names%20like%20this%20which%20are%20hard%20to%20read, the dots make file.names.like.this.much.easier.to.read.

Spaces in file names can also cause broken links, because word processing tools like Microsoft Word, and e-mail clients like Microsoft Outlook, recognize spaces as an opportunity to move to another line. Therefore, a link to

\\Ah1\Intranet\ar\naming conventions

could become

\\Ah1\Intranet\ar\naming

conventions

Another difference that is found among operating systems and software is the acceptable length of file names. Some systems allow up to 256 characters, while others allow far fewer.

And finally many scripts/batch/cmd files would require filenames with spaces to be enclosed in double-quotes otherwise the spaces are interpreted as parameter breaks much like what the word processing tools would do to them.

Tagging Convention:

First the syntax. (NOTE: The following should be considered all one file or folder name):

[<Publisher>.]<Title>_v<Version>|c<Year>[_<Language>][_<OS>][_<Architecture>][_<LicenseType>]_<BuildType>[_<Category>|<Additional>][_<Releaser>]

Yes, this does look very cryptic and daunting but fear not, that's what you have this guide for. A couple things you should know about the syntax are follows:

    • Anything inside brackets "[ ]" is optional.
    • Do not actually enter the "< >" or the "[ ]" characters.
    • " | " represent choices.

Here, we'll try to walk you through some of the most important parts of our file-naming standard:

    1. NO spaces.
    2. Substitute dots(.) for spaces inside <field>s.
    3. Use underscores(_) as separators between <field>s.
    4. NO double-dots nor double-underscores.
    5. <Publisher> is only really mandatory if the application name is not unique enough that duplicates are not likely to exist. This means that you must include the developer in the case where checks for duplicates for your application name will also return results that do not match the application you are releasing. Including the developer would also be appropriate if the developer's releases are typically listed together, those from Adobe or Microsoft for example.
    6. <Title> must be the "official" name of the application. Do not omit dashes, think of your duplicate checking results. This is the name in the about box or splashscreen of the application, or if this is not available, the name listed on the website.
    7. _v<Version> should be used for applications, and _c<Year> should be used for games. Dashes are also appropriate here. E.g, "-Beta"
    8. The <Language> tag must be used only on NON English releases. Multilingual and bilingual are optional.
    9. It is recommended to omit the <OS> tag when it is "All Windows" (= NT5 & NT6 based windows, always with latest official service pack). Currently valid OS tags are:
      • NT5 [2K/XP/2K3]
      • NT6 [Vista/7]
    10. It is recommended to omit the <Architecture> tag when it is x86 and it works perfectly okay on an x64 system or if separate installers are included for the two different architectures but only one will get installed depending on the target system. Currently valid Architecture tags are:
      • x86 [will ONLY run correctly on x86 systems]
      • x64 [will ONLY run on x64 systems]
      • DualArch [will run on either x86 or x64 systems... this only works with ppApps or ppGames exclusively]
        (See " DualArch-Installers ").
    11. <BuildType> is the type of deployment package/build. Possible tags are:
      • ssApp
      • ppApp
      • ppGame
    12. Releasers should use some common sense to keep the filename a reasonable length.

Examples:

Finally, to help illustrate some of the rules, we present a few examples of what properly formatted filenames would look like:

7-Zip_v9.25Beta_x64_ssApp_bphlpt.apz

Bulk.Rename.Utility_v2.7.1.1_ppApp.apz

CCleaner_v2.36.1233_ppApp.apz

Elaborate.Bytes.Virtual.CloneDrive_v5.4.4.0_ssApp.apz

HashCheck.Shell.Extension_v2.1.11.1_ssApp_Addon.apz

Ben.There,Dan.That!_c2008_ppGame_Adventure_TheFreezerBox.pgz


DualArch-Installers

DualArch-Installers Previous page Return to chapter overview Next page

There are basically two ways of handling the OSArch issue(s):

Type 1

SingleArch-Installer --> SingleArch-Installed. It is the most primitive but effective way of deploying apps. It only requires the release-package to designate the target OSArch in the .app-file (under <Architecture>). It is also going to have the smallest-sized deployment packages. But to be complete, one will need to create two such packages: one for x86 (32-bit) and another for x64 (64-bit). They'll also have separate but different file-names for each package, as discussed in " File-Naming Best Practices " already (see bullet point 10).

Type 2

    1. DualArch-Installer --> SingleArch-Installed. It is the scheme used almost exclusively with ssApps -- because their original installers were designed to install this way. We say almost exclusively because until now this was only used by ssApps -- this is a scheme that has been devised recently to work with ppApps as well.
    2. DualArch-Installer --> DualArch-Installed. It is a scheme only used by ppApps -- because only ppApps can utilize it. 'Nuff said.

This new scheme had created a bit of a problem for someone looking at a DualArch ppApp. Is it a Type 2a or 2b? Previously, the assumption could have been made that if it's an ssApp it's Type 2a and if it's a ppApp then it's Type 2b. So a decision was made on how to designate the two kinds of Type 2's and how to start naming the resulting deployment packages.

There's no question that ssApp packages were on the scene first (so to speak) and they are in fact the more traditional-behaving unattended installing technique; whereas, ppApps are a more extreme and unique method of deployment that they are also an exclusive design of ssTek tools.

Looking at it thus, it's obvious that the Type 2a DualArch used by ssApps (and now ppApps) should therefore be the default when "Any" is selected under <Architecture>. It will also require no extra filename tag since this is the naming scheme ssApp packages have been utilizing for quite some time already. (Note: there was a tag for these, "_x86-x64", but it was rarely used if at all.)

Type 2b is a universal DualArch but will now need a special tag added to the filename in order to distinguish this particular type of DualArch ppApp from it's Type 2a brother. It is this type that truly deserves to be called "DualArch" because it IS a true Dual Architecture -- and in every sense of the definition.

Both types of "DualArch-Installer" ppApp packages are using the already established form of including both OSArch's under their respective subfolders ("_x86\" & "_x64\") -- all contained in the ppApp.7z archive -- and the shortcut flags for handling the respective OSArch's ("Is_x86" & "Is_x64").

So to toggle between either type of "DualArch-Installer" ppApp package, one only needs to "Edit" the .app-file (or .apz-file) with ssEditor and simply select Architecture "Any" (for Type 2a) or "DualArch" (for Type 2b)

The first one, "Any" -- the default -- will merely install the single-OSArch package of the target system. To accomplish this, SetupS excludes installing the other OSArch package of the target system (i.e., the "_x86\" or "_x64\" subfolders). For example, if installing one of these packages on an x86 system, the "_x64\" subfolder will be missing. This is important in case any common files or folders are also included in the ppApp.7z archive. To get the other OSArch installed, one will need to boot into an OS of the other arch and re-install the ppApp from its original deployment package.

The last one, "DualArch" installs both OSArch packages regardless of the target system's OSArch. To establish shortcuts of the other OSArch, one will simply need to boot into an OS of the other arch and run Regenerator (or use SendTo SetupS on the ppApp's installed folder).


Archive Filename Standard

Archive Filename Standards Previous page Return to chapter overview Next page

These days, many apps and games utilize archives as part of the software (for example, a data store) and during Install-mode it would be undesirable to extract those archives. The problem is that those integral archives can be named anything -- and therefore, unpredictable. As a consequence, SetupS cannot determine which are the install-archives and which are the integral archives.

We cannot control the filenames of those integral archives but we can control the filenames of the "install" ones. The solution has been to limit the install-archive filenames to a filenaming "standard" -- similarly to how the faders and screenshots are handled, like so:

    • {BuildType}.7z|.rar|.zip|.cab (ie, ssApp.7z, ppApp.rar, etc.)
    • {SourceFolderName}.7z|.rar|.zip|.cab (ie, CCleaner_ppApp.7z, CCleaner_ppApp.rar, etc.)
    • {InstallPath}.7z|.rar|.zip|.cab (ie, CCleaner.7z, CCleaner.rar, etc.)
    • SetupS.7z|.rar|.zip|.cab
    • Patch.7z|.rar|.zip|.cab

Ξ Some Notes:

    1. {BuildType} can be one of the following 'ssApp', 'ppApp', or 'ppGame'.
    2. {SourceFolderName} is the same as %SourcePath% which is the full path (drive + folder) to the {BuildType}.app|.ppg file.
    3. {InstallPath} is the same as %AppPath% which is the full path (drive + folder) to the App's or Game's actual installed-to folder.
    4. The exception to this standard will be with "legacy" ppGames which are detected by their lack of both the <BuildType> and <Catalog> keys in the .app-file.


Directives

Directives Previous page Return to chapter overview Next page

Process-order Directives. Use these to alter the "mainline" install/assembly sequence. The following are listed in the order of the default post-assembly sequence:

    • #ApplyPatch# : Apply patch archives/folders.
    • #ShortcutS# : Process the <ShortcutS> section... all shortcut/startmenu related tasks (w/ StartMenu Folder icons) AND File Association(s). Skips it during Post-processing.
    • #AppPathFolderIcon# : Install-path Folder Icon
    • #RunScript# : Run the <Script> section and skip it during Post-processing. Uses the Source folder as the 'Start In' or working folder.
    • #ApplyRegistry# : Apply the <Registry> section and skip it during Post-processing.
    • #InstallFonts# : Process the <InstallFonts> section. Skips it during Post-processing.
    • #RegisterDLL# : Process the <RegisterDLL> section. Skips it during Post-processing.

Ξ Some Notes:

    1. These are for the <Assembly> section ONLY.
    2. For ssApp's it is NOT recommended to place post-install #directives# *before* its installer or setup program since the install-to path (or <AppPath>) is often not created nor determined until after it has been run. So if need be, make use instead of .cmd/.bat and/or .reg files and of any of the Component %variables%.

CLI Directives:

    • #CMD# : Process this line as a command-line using the DOS console (aka, the Command-line Interpreter).
    • #DOS# : Same as #CMD#, above.

Ξ Some Notes:

    1. These are for the <Assembly> section ONLY.
    2. These can be at the beginning or at the end of each line.

Gate Directives: Use these filter a line by its OS and/or Architecture.

    • #Is_x86# : Process this line for 32-bit OS-Architectures (x86) only.
    • #Is_x64# : Process this line for 64-bit OS-Architectures (x64) only.
    • #Is_NT5# : Process this line for NT5.x OS's only. E.g., Windows 2000, XP, Server 2003.
    • #Is_NT6# : Process this line for NT6.x OS's only. E.g., Windows Vista, 7, Server 2008, 8, 8.1, Phone 8.
    • #Is_Metro#: Process this line for Windows versions using the StartScreen (Metro). E.g., Windows 8, 8.1, Server 2012, Phone 8.
    • Comparative Gates: These gates allow more specific line processing. The syntax is as follows:

#Is_OS<|=|>|<>|<=|>=V[.v[.bbbb]]#

with:

< : "less than"

= : "equal to"

> : "greater than"

<> : "not equal to"

>< : "not equal to"

<= : "less than or equal to"

>= : "greater than or equal to"

=< : "equal to or less than"

=> : "equal to or greater than"

where:

V.v.bbbb : The Windows NT version . This can be just the Major, the Major.minor, or Major.minor.build.

Ξ Some Notes:

    1. These can be at the beginning or at the end of each line.
    2. Gate directives may also be used in the following: Script-files (.cmd/.bat), Registry-files(.reg), and in the .app/.ppg-file under the keys "FileTypes", "RegisterDLLs", "InstallFonts", and the ShortcutS definitions. With ShortcutS definitions, placement of the gate(s) is via the "Flags" key (with or without "#" delimiters).
    3. Two or more gates used together will have a logical "AND" effect. This will allow one to specify OS ranges and OSArch combinations.

Some examples:

      • #Is_OS=5.1# : Windows XP
      • #Is_OS=5.2##Is_x64# : Windows XP Professional x64 Edition
      • #Is_OS=5# : Same as #Is_NT5#
      • #Is_NT6##Is_OS<6.2# : Windows Vista & 7 (also Server 2008)
      • #Is_x86##Is_NT6# : The x86 editions of Vista/7/8
      • #Is_OS>=6.2# : Same as #Is_Metro#


Components

Components Previous page Return to chapter overview Next page

Useful SetupS Component Tools

    • %WaitForIt% "[path\filename]|[filename]" : Force SetupS to pause until a specific file or process is created. Shortcut files (.lnk) are recommended because they are often created last by installers.
    • %AddonInstaller% "[path\filename]" : Process Addons such as ones from Kel or RyanVM.
      Note: This requires 7-Zip be available (usually in Tools).
    • %ProcessKill% "[filename]" : To force a process/task to close from a given filename.
    • %AddToHosts% "{IP address} {host name}" : Sets mappings of IP addresses to host names.

For example:

%AddToHosts% "127.0.0.1 secure.example.com"

    • %Extract% "{archive}" -o"{destination path}" : Extract an archive to a specified destination path. Exactly equivalent to: '7z x -y -aoa {archive} -o{destination path}'. Note: This requires 7-Zip be available (usually in Tools).

For example:

%Extract% "Extras.rar" -o"%SystemRoot%\ssTek"

becomes...

7z.exe x -y -aoa "Extras.rar" -o"C:Windows\ssTek"

Ξ Some Notes:

    1. These can be used in <Assembly> or <Script> only.
    2. With the exception of %Extract%, the components are built into SetupS when used within <Assembly>. All are evoked as external tools when used within <Script>.


Category List

Category List Previous page Return to chapter overview Next page

Note: This list is in perpetual continuous improvement and is therefore subject to frequent changes. It is provided here as reference only.

The Category list (described with the file "Category.ini") is used by ssEditor to make available (and maintain some consistency) the various categories that are currently possible. This list also provides the suggested Catalog entry that could be used.

[Category]

Addon=System Addon

Anti-Malware=Security Malware

Audio=Audio

Bandwidth=Bandwidth

Burning=Optical Burning

Collection=Collection

Comic=Comic

Database=Office Database

Development=Development

Devices=Device

Disk=Disk

Drivers=System Driver

eBook=eBook

eMail=eMail

File Utility=File Utility

Fitness=Fitness

Emulation=System Emulation

Games=Game

Games\Abstract=Game Abstract

Games\Action=Game Action

Games\Adult=Game Adult

Games\Adventure=Game Adventure

Games\Arcade=Game Arcade

Games\Board=Game Board

Games\Breakout=Game Breakout

Games\Card=Game Card

Games\Collect=Game Collect

Games\Dash=Game Dash

Games\Demo=Game Demo

Games\Dice=Game Dice

Games\DVD=Game DVD

Games\Educational=Game Educational

Games\Emulation=Game Emulation

Games\Fighting=Game Fighting

Games\Flight=Game Flight

Games\Gambling=Game Gambling

Games\Mahjong=Game Mahjong

Games\Management=Game Management

Games\Match=Game Match

Games\Modifying=Game Modifying

Games\Number=Game Number

Games\Objects=Game Objects

Games\Other=Game Other

Games\Patching=Game Patching

Games\Pinball=Game Pinball

Games\Platform=Game Platform

Games\Puzzle=Game Puzzle

Games\Racing=Game Racing

Games\Role Playing=Game Role Playing

Games\Sandbox Physics=Game Sandbox Physics

Games\Shooter=Game Shooter

Games\Simulation=Game Simulation

Games\Sport=Game Sport

Games\Strategy=Game Strategy

Games\Word=Game Word

Games\2D=Game

Games\3D=Game

Games\1st-Person Perspective=Game

Games\3rd-Person Perspective=Game

Games\Top-Down=Game

Games\Isometric=Game

Games\Side-Scrolling=Game

Games\Adult=Game

Games\Anime=Game

Games\BattleMech=Game

Games\Casino=Game Gambling

Games\Chess=Game Board

Games\Comics=Game

Games\Driving=Game

Games\Fantasy=Game

Games\Finder=Game Objects

Games\Game Show=Game

Games\God=Game Simulation

Games\Historical=Game

Games\Horror=Game

Games\Interactive Fiction=Game

Games\Interactive Movie=Game

Games\Managerial=Game

Games\Martial Arts=Game Fighting

Games\Meditative=Game

Games\Multi-Player=Game

Games\Music=Game

Games\Mystery=Game

Games\Paddle & Pong=Game

Games\Party=Game

Games\Persistent Universe=Game

Games\Real-Time=Game

Games\Sci-Fi=Game

Games\Spy & Espionage=Game

Games\Stealth=Game

Games\Training=Game

Games\Turn-based=Game Strategy

Games\Video Backdrop=Game

Games\Add-on=Game

Games\Browser-based=Game

Games\Coin-Op Conversion=Game

Games\Compilation & Shovelware=Game Other

Games\Editor & Construction Set=Game

Games\Licensed Title=Game

Games\Vista=Game Vista

Genealogy=Genealogy

GPS Device=GPS Device

Graphics=Graphics

Installing=Installing

Instant Messaging=Instant Messaging

Internet=Internet

Mobile Device=Mobile Device

MP3 Tool=MP3 Tool

Multimedia=Video

Network=Network

Office=Office

Optical=Optical

Other=Other

P2P=Internet Peer to Peer

Printing=Printing

Recovery=Disk Recovery

Remote Access=Remote Access

Scanning=Scanning

Security=Security

Sound=Audio

System=System

Theme=System Theme

Tweaks=System Tweak

Video=Video

Viewers=Viewing

Virtual Drive=Optical Virtual Drive

Virtual Machine=Virtual Machine


StartMenu Catalog

StartMenu Catalog Previous page Return to chapter overview Next page

Note: This list is in perpetual continuous improvement and is therefore subject to frequent changes. It is provided here as reference only.

This is the system that SetupS uses to determine or "map" a Catalog entry into into one's chosen advanced Startmenu Style (ssTek/Kazz/Custom). They are defined in a standard INI-type of database file called "Definitions.ini" which is located in the respective advanced menu sub-folder under the "Tools" folder.

Within a standard INI-file each property is defined by a "key" and a "value", delimited by an equals sign (=). The "key" appears to the left of the equals sign and the "value" to the right of it. Properties may be grouped into arbitrarily named "sections". The "section" name appears on a line by itself, in square brackets ([ and ]).

In the "Definitions.ini" file, each property is defined such that the "key" represents a particular Catalog entry and the "value" represents the actual location within the advanced Startmenu itself. The remainder of the file is devoted to detailing each advanced Startmenu location by way of the "sections"; but so far, only icons are defined at the moment.

Finally, an exclamation (!) is used at the beginning of a "key" to mean that that particular Catalog entry is being renamed or forwarded to another Catalog entry.

The following is an example taken from the ssTek advanced Startmenu Style:

[SetupS Menu]

Style=ssTek

Version=v8.12.4.0

Description=

[Catalog]

Accessibility Tool=- System\- Windows Tools\Accessibility

Audio=- Audio

Audio Codec=- System\- Drivers & Codec

Audio Converting=- Audio\- Edit, Record & Convert

Audio Editing=- Audio\- Edit, Record & Convert

Audio Filtering=- Audio\- Filters & Distorting

Audio Playing=- Audio\- Players

Audio Recording=- Audio\- Edit, Record & Convert

Audio Sequencing=- Audio\- Sequencers & MIDI

Audio Speech=- Audio\- Speech

Audio Synthesizing=- Audio\- Sequencers & MIDI

Bandwidth=- Internet\- Network & Bandwidth Software

Collection=- Other\- Collections

Comic=- Office\- Viewers & Readers\- Comics & eBooks

!Console Gaming=Game Console

Development=- Development

Development Coding=- Development\- Editor, Compiler and IDE

Development Compiling=- Development\- Editor, Compiler and IDE

Development Environment=- Development\- Editor, Compiler and IDE

Development Help Tool=- Development\- HTML & Help Editors

Development HTML Tool=- Development\- HTML & Help Editors

Development Hypertext Tool=- Development\- HTML & Help Editors

Development IDE=- Development\- Editor, Compiler and IDE

Development Programming=- Development\- Editor, Compiler and IDE

Development Setup & Installing=- Development\- Setup & Install Makers

Development Tools=- Development\- Tools & Design

Device=- Devices

Disk=- Disk

Disk Archiving=- Disk\- Archive, Imaging & Backup

Disk Backup=- Disk\- Archive, Imaging & Backup

Disk Cleaning=- Disk\- Clean, Defrag & Uninstall

Disk Compression=- Disk\- Archive, Imaging & Backup

Disk Defragmenting=- Disk\- Clean, Defrag & Uninstall

Disk Directory=- Disk\- Directory & File Utilities

Disk Imaging=- Disk\- Archive, Imaging & Backup

Disk Management=- Disk\- Clean, Defrag & Uninstall

Disk Partitioning=- Disk\- Recovery & Partition

Disk Recovery=- Disk\- Recovery & Partition

Disk Uninstalling=- Disk\- Clean, Defrag & Uninstall

eBook=- Office\- Viewers & Readers\- Comics & eBooks

eMail=- Internet\- eMail & Instant Messengers

!Emulation=Virtual Machine

File Utility=- Disk\- Directory & File Utilities

Fitness=- Other\- Fitness Analysis

Game=- Games

!Game A to B=Game Puzzle

!Game AtoB=Game Puzzle

Game Abstract=- Games\Abstract

Game Action=- Games\Action

Game Adult=- Games\Adult

Game Adventure=- Games\Adventure

Game Arcade=- Games\Arcade

Game Ball=- Games\Ball

Game Board=- Games\Board

!Game Brainteaser=Game Puzzle

!Game Breakout=Game Ball

Game Card=- Games\Card

!Game Casino=Game Gambling

!Game Collapse=Game Match

Game Collect=- Games\Collect

Game Console=- Games\- Consoles

!Game Crossword=Game Word

Game Dash=- Games\Dash

Game Demo=- Games\- Demo's

Game Dice=- Games\Dice

Game DVD=- Games\- DVD Games

Game Educational=- Games\- Educational

Game Emulation=- Games\- Emulation

Game Fighting= - Games\Fighting

!Game Finder=Game Objects

Game Flight=- Games\Flight

Game Gambling=- Games\Gambling

!Game Jigsaw=Game Shapes

!Game Lines=Game Match

!Game Mahjong=Game Table

Game Management=- Games\Simulation\Management

Game Match=- Games\Match

!Game Marble Popper=Game Match

!Game Match-Three=Game Match

!Game Mix=Game Various

Game Modifying=- Games\- Patching & Modding

!Game Number=Game Puzzle

Game Objects=- Games\Objects

!Game Objects Difference=Game Objects

!Game Objects Fractured=Game Objects

!Game Objects Hidden=Game Objects

!Game Objects Hidden Adventure=Game Objects

!Game Objects Hidden List=Game Objects

Game Other=- Games\Other

Game Patching=- Games\- Patching & Modding

!Game Path=Game Puzzle

!Game Physics=Game Sandbox Physics

!Game Pinball=Game Ball

Game Platform=- Games\Platform

Game Puzzle=- Games\Puzzle

Game Racing=- Games\Racing

!Game RPG=Game Role Playing

Game Role Playing=- Games\Role Playing

!Game Sandbox=Game Sandbox Physics

Game Sandbox Physics=- Games\Sandbox Physics

!Game ShapeFitting=Game Shapes

Game Shapes=- Games\Shapes

Game Strategy=- Games\Strategy

Game Shooter=- Games\Shooter

!Game ShootMatch=Game Match

!Game First-person Shooter=Game Shooter

!Game Third-person Shooter=Game Shooter

!Game Top-down Shooter=Game Shooter

Game Simulation=- Games\Simulation

!Game Sims=Game Simulation

!Game SkyRace=Game Racing

!Game Sokoban=Game Puzzle

Game Sports=- Games\Sport

Game Table=- Games\Table

!Game Time Management=Game Management

!Game Unique=Game Abstract

Game Various=- Games\Various

Game Vista=- Games\- Vista Games

Game Word=- Games\Word

!Game Word Search=Game Word

!Game Word Tile=Game Word

Genealogy=- Other\- Genealogy

GPS Device=- Devices\- Travel & GPS

Graphics=- Graphics

Graphics 3D=- Graphics\- 3D, Generating & Morph

Graphics CAD=- Graphics\- CAD & Vector

Graphics Designing=- Graphics\- Tools & Design

Graphics Editing=- Graphics\- Photo Editing

Graphics Fonts=- Graphics\- Font

Graphics Generating=- Graphics\- 3D, Generating & Morph

Graphics Icons=- Graphics\- Icon

Graphics Morphing=- Graphics\- 3D, Generating & Morph

Graphics Tools=- Graphics\- Tools & Design

Graphics Vector=- Graphics\- CAD & Vector

Graphics Viewing=- Graphics\- Viewers

Installing=- System\- Add, Install, & Setup

Instant Messaging=- Internet\- eMail & Instant Messengers

Internet=- Internet

Internet Bookmarks=- Internet\- Browsers & Bookmarks

Internet Booster=- Internet\- Download Managers

Internet Browser=- Internet\- Browsers & Bookmarks

Internet Communication=- Internet\- Communications

Internet Download Manager=- Internet\- Download Managers

Internet Favorites=- Internet\- Browsers & Bookmarks

Internet Peer to Peer=- Internet\- Peer to Peer

IP Blocker=- Internet\- Network & Bandwidth Software

Microsoft X-Box 360=- Consoles\- X-Box 360

Mini Game=- Games

Mini Game Emulation=- Games\- Emulation

Mobile Device=- Devices\- Mobile & PDA Tools

MP3 Tool=- Audio\- Edit, Record & Convert

Multimedia=- Multimedia

Network=- Internet\- Network & Bandwidth Software

Nintendo Wii=- Games\- Consoles\- Nintendo Wii

Office=- Office

Office Accessory=- Office\- Calculators & Calendars

Office Converting=- Office\- Converters & Creators

Office Database=- Office\- Dictionaries & Databases

Office Dictionary=- Office\- Dictionaries & Databases

Office Printing=- Office\- Printing & Scanning

Office Reading=- Office\- Viewers & Readers

Office Research=- Office\- Dictionaries & Databases

Office Scanning=- Office\- Printing & Scanning

Office Viewing=- Office\- Viewers & Readers

Office Word Processing=- Office\- Editors & Word Processors

Online Gaming Tool=- Games\- Online Tools & Utilities

Optical=- CD & DVD

Optical Authoring=- CD & DVD\- DVD Authoring & Menu Creation

Optical Burning=- CD & DVD\- Burning & Copying

Optical Copying=- CD & DVD\- Burning & Copying

Optical Image=- CD & DVD\- ISO Image & Virtual Drives

Optical Virtual Drive=- CD & DVD\- ISO Image & Virtual Drives

Other=- Other

ppGame=- Games

Remote Access=- Internet\- Communications

Security=- Security

Security Adware=- Security\- Firewall, Virus & Adware

Security Cracking=- Security\- Hacking & Hex\- Cracks

Security Encryption=- Security\- Password & Encryption

Security Firewall=- Security\- Firewall, Virus & Adware

Security Hacking=- Security\- Hacking & Hex

Security Internet=- Security\- Firewall, Virus & Adware

Security Key=- Security\- Hacking & Hex\- Serials & Keygens

Security Malware=- Security\- Firewall, Virus & Adware

Security Monitoring=- Internet\- Network & Bandwidth Software

Security Password=- Security\- Password & Encryption

Security Serial=- Security\- Hacking & Hex\- Serials & Keygens

Security Spyware=- Security\- Firewall, Virus & Adware

Security Stealth=- Internet\- Network & Bandwidth Software

Security Virus=- Security\- Firewall, Virus & Adware

Security Workarounds=- Security\- Hacking & Hex\- Workarounds

Sega DreamCast=- Games\- Consoles\- DreamCast

Sony Playstation 2=- Games\- Consoles\- Playstation 2

Sony Playstation 3=- Games\- Consoles\- Playstation 3

Sony PSP=- Games\- Consoles\- PSP

System=- System

System Addon=- System\- Launching, Context Menu & Tray

System Codec=- System\- Drivers & Codec

System Context Menu=- System\- Launching, Context Menu & Tray

System Driver=- System\- Drivers & Codec

System Emulation=- System\- Virtual Machines

System Hardware=- System\- Hardware Monitor & Control

System Installing=- System\- Add, Install, & Setup

System Launching=- System\- Launching, Context Menu & Tray

System Process=- System\- Process & Task Control

System Registry=- System\- Repair & Registry

System Repairing=- System\- Repair & Registry

System Task=- System\- Process & Task Control

System Theme=- System\- Theme & Icons

System Tool=- System\- Windows Tools

System Tray=- System\- Launching, Context Menu & Tray

System Tweak=- System\- Tweaking & Tuning

System Uninstalling=- Disk\- Clean, Defrag & Uninstall

System Utility=- System\- All In One Tools

Video=- Video

Video Animation=- Video\- Animation

Video Codec=- System\- Drivers & Codec

Video Converting=- Video\- Convert & Transcode

Video Editing=- Video\- Editors

Video Playing=- Video\- Players

Video Transcoding=- Video\- Convert & Transcode

Vista Tool=- System\- Windows Tools

Virtual Machine=- System\- Virtual Machines

[Startup]

IconFile=%SystemRoot%\ssTek\Icons\LXP_zSTARTUP.ico

IconIndex=0

[- Audio]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SOUND.ico

IconIndex=0

[- Audio\- Edit, Record & Convert]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SOUND_Edit.ico

IconIndex=0

[- Audio\- Filters & Distorting]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SOUND_Filters.ico

IconIndex=0

[- Audio\- Players]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SOUND_Players.ico

IconIndex=0

[- Audio\- Sequencers & MIDI]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SOUND_Sequencer.ico

IconIndex=0

[- Audio\- Speech]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SOUND_Speech.ico

IconIndex=0

[- CD & DVD]

IconFile=%SystemRoot%\ssTek\Icons\LXP_CDDVD.ico

IconIndex=0

[- CD & DVD\- DVD Authoring & Menu Creation]

IconFile=%SystemRoot%\ssTek\Icons\LXP_CDDVD_DVDAuthoring.ico

IconIndex=0

[- CD & DVD\- Burning & Copying]

IconFile=%SystemRoot%\ssTek\Icons\LXP_CDDVD_Burning.ico

IconIndex=0

[- CD & DVD\- ISO Image & Virtual Drives]

IconFile=%SystemRoot%\ssTek\Icons\LXP_CDDVD_ISO.ico

IconIndex=0

[- Development]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DEVELOPMENT.ico

IconIndex=0

[- Development\- Editor, Compiler and IDE]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DEVELOPMENT_Editor.ico

IconIndex=0

[- Development\- HTML & Help Editors]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DEVELOPMENT_HTML.ico

IconIndex=0

[- Development\- Setup & Install Makers]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DEVELOPMENT_Setup.ico

IconIndex=0

[- Development\- Tools & Design]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DEVELOPMENT_Tools.ico

IconIndex=0

[- Devices]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DEVICES.ico

IconIndex=0

[- Devices\- Mobile & PDA Tools]

IconFile=%SystemRoot%\system32\SHELL32.dll

IconIndex=196

[- Devices\- Travel & GPS]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Travel.ico

IconIndex=0

[- Disk]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DISK.ico

IconIndex=0

[- Disk\- Archive, Imaging & Backup]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DISK_Archive.ico

IconIndex=0

[- Disk\- Clean, Defrag & Uninstall]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DISK_Clean.ico

IconIndex=0

[- Disk\- Directory & File Utilities]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DISK_Directory.ico

IconIndex=0

[- Disk\- Recovery & Partition]

IconFile=%SystemRoot%\ssTek\Icons\LXP_DISK_Recovery.ico

IconIndex=0

[- Games]

IconFile=%SystemRoot%\ssTek\Icons\LXP_Games.ico

IconIndex=0

[- Games\- Consoles]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Console.ico

IconIndex=0

[- Games\- Consoles\- DreamCast]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Dreamcast.ico

IconIndex=0

[- Games\- Consoles\- Nintendo Wii]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Wii.ico

IconIndex=0

[- Games\- Consoles\- Playstation 2]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Playstation2.ico

IconIndex=0

[- Games\- Consoles\- Playstation 3]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Playstation3.ico

IconIndex=0

[- Games\- Consoles\- PSP]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_PSP.ico

IconIndex=0

[- Games\- Consoles\- X-Box 360]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Xbox360.ico

IconIndex=0

[- Games\- Demo's]

IconFile=%SystemRoot%\ssTek\Icons\Games_Demo.ico

IconIndex=0

[- Games\- DVD Games]

IconFile=%SystemRoot%\ssTek\Icons\Games_DVD.ico

IconIndex=0

[- Games\- DVD-ROM Games]

IconFile=%SystemRoot%\ssTek\Icons\Games_DVD.ico

IconIndex=0

[- Games\- Emulation]

IconFile=%SystemRoot%\ssTek\Icons\Games_Emulation.ico

IconIndex=0

[- Games\- Online Tools & Utilities]

IconFile=%SystemRoot%\system32\SHELL32.dll

IconIndex=14

[- Games\- Patching & Modding]

IconFile=%SystemRoot%\ssTek\Icons\Games_Patching.ico

IconIndex=0

[- Games\- Vista Games]

IconFile=%SystemRoot%\ssTek\Icons\Games_Vista.ico

IconIndex=0

[- Games\Abstract]

IconFile=%SystemRoot%\ssTek\Icons\Games_Abstract.ico

IconIndex=0

[- Games\Action]

IconFile=%SystemRoot%\ssTek\Icons\Games_Action.ico

IconIndex=0

[- Games\Adult]

IconFile=%SystemRoot%\ssTek\Icons\Games_Adult.ico

IconIndex=0

[- Games\Adventure]

IconFile=%SystemRoot%\ssTek\Icons\Games_Adventure.ico

IconIndex=0

[- Games\Arcade]

IconFile=%SystemRoot%\ssTek\Icons\Games_Arcade.ico

IconIndex=0

[- Games\Ball]

IconFile=%SystemRoot%\ssTek\Icons\Games_Ball.ico

IconIndex=0

[- Games\Board]

IconFile=%SystemRoot%\ssTek\Icons\Games_Board.ico

IconIndex=0

[- Games\Card]

IconFile=%SystemRoot%\ssTek\Icons\Games_Card.ico

IconIndex=0

[- Games\Collect]

IconFile=%SystemRoot%\ssTek\Icons\Games_Collect.ico

IconIndex=0

[- Games\Various]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Collections.ico

IconIndex=0

[- Games\Dash]

IconFile=%SystemRoot%\ssTek\Icons\Games_Dash.ico

IconIndex=0

[- Games\Dice]

IconFile=%SystemRoot%\ssTek\Icons\Games_Dice.ico

IconIndex=0

[- Games\Educational]

IconFile=%SystemRoot%\ssTek\Icons\Games_Educational.ico

IconIndex=0

[- Games\Fighting]

IconFile=%SystemRoot%\ssTek\Icons\Games_Fighting.ico

IconIndex=0

[- Games\Finder]

IconFile=%SystemRoot%\ssTek\Icons\Games_Finder.ico

IconIndex=0

[- Games\Flight]

IconFile=%SystemRoot%\ssTek\Icons\Games_Flight.ico

IconIndex=0

[- Games\Gambling]

IconFile=%SystemRoot%\ssTek\Icons\Games_Gambling.ico

IconIndex=0

[- Games\Match]

IconFile=%SystemRoot%\ssTek\Icons\Games_Match.ico

IconIndex=0

[- Games\Objects]

IconFile=%SystemRoot%\ssTek\Icons\Games_Objects.ico

IconIndex=0

[- Games\Other]

IconFile=%SystemRoot%\ssTek\Icons\Games_Other.ico

IconIndex=0

[- Games\Platform]

IconFile=%SystemRoot%\ssTek\Icons\Games_Platform.ico

IconIndex=0

[- Games\Puzzle]

IconFile=%SystemRoot%\ssTek\Icons\Games_Puzzle.ico

IconIndex=0

[- Games\Racing]

IconFile=%SystemRoot%\ssTek\Icons\Games_Racing.ico

IconIndex=0

[- Games\Role Playing]

IconFile=%SystemRoot%\ssTek\Icons\Games_Role Playing.ico

IconIndex=0

[- Games\Sandbox Physics]

IconFile=%SystemRoot%\ssTek\Icons\Games_Sandbox Physics.ico

IconIndex=0

[- Games\Shapes]

IconFile=%SystemRoot%\ssTek\Icons\Games_Shapes.ico

IconIndex=0

[- Games\Shooter]

IconFile=%SystemRoot%\ssTek\Icons\Games_Shooter.ico

IconIndex=0

[- Games\Simulation]

IconFile=%SystemRoot%\ssTek\Icons\Games_Simulation.ico

IconIndex=0

[- Games\Simulation\Management]

IconFile=%SystemRoot%\ssTek\Icons\Games_Management.ico

IconIndex=0

[- Games\Sport]

IconFile=%SystemRoot%\ssTek\Icons\Games_Sport.ico

IconIndex=0

[- Games\Strategy]

IconFile=%SystemRoot%\ssTek\Icons\Games_Strategy.ico

IconIndex=0

[- Games\Table]

IconFile=%SystemRoot%\ssTek\Icons\Games_Table.ico

IconIndex=0

[- Games\Word]

IconFile=%SystemRoot%\ssTek\Icons\Games_Word.ico

IconIndex=0

[- Graphics]

IconFile=%SystemRoot%\ssTek\Icons\LXP_GRAPHICS.ico

IconIndex=0

[- Graphics\- 3D, Generating & Morph]

IconFile=%SystemRoot%\ssTek\Icons\LXP_GRAPHICS_3D.ico

IconIndex=0

[- Graphics\- CAD & Vector]

IconFile=%SystemRoot%\ssTek\Icons\LXP_GRAPHICS_CAD.ico

IconIndex=0

[- Graphics\- Font]

IconFile=%SystemRoot%\ssTek\Icons\LXP_GRAPHICS_Font.ico

IconIndex=0

[- Graphics\- Icon]

IconFile=%SystemRoot%\ssTek\Icons\LXP_GRAPHICS_Icon.ico

IconIndex=0

[- Graphics\- Photo Editing]

IconFile=%SystemRoot%\ssTek\Icons\LXP_GRAPHICS_Photo.ico

IconIndex=0

[- Graphics\- Tools & Design]

IconFile=%SystemRoot%\ssTek\Icons\LXP_GRAPHICS_Tools.ico

IconIndex=0

[- Graphics\- Viewers]

IconFile=%SystemRoot%\ssTek\Icons\LXP_GRAPHICS_Viewers.ico

IconIndex=0

[- Internet]

IconFile=%SystemRoot%\ssTek\Icons\LXP_INTERNET.ico

IconIndex=0

[- Internet\- Browsers & Bookmarks]

IconFile=%SystemRoot%\ssTek\Icons\LXP_INTERNET_Browsers.ico

IconIndex=0

[- Internet\- Communications]

IconFile=%SystemRoot%\system32\SHELL32.dll

IconIndex=135

[- Internet\- Download Managers]

IconFile=%SystemRoot%\ssTek\Icons\LXP_INTERNET_Download.ico

IconIndex=0

[- Internet\- eMail & Instant Messengers]

IconFile=%SystemRoot%\ssTek\Icons\LXP_INTERNET_Email.ico

IconIndex=0

[- Internet\- Network & Bandwidth Software]

IconFile=%SystemRoot%\ssTek\Icons\LXP_INTERNET_Network.ico

IconIndex=0

[- Internet\- Peer to Peer]

IconFile=%SystemRoot%\ssTek\Icons\LXP_INTERNET_P2P.ico

IconIndex=0

[- Multimedia]

IconFile=%SystemRoot%\ssTek\Icons\LXP_MultiMedia.ico

IconIndex=0

[- Office]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE.ico

IconIndex=0

[- Office\- Calculators & Calendars]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Calculator.ico

IconIndex=0

[- Office\- Converters & Creators]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Doc_Convert.ico

IconIndex=0

[- Office\- Dictionaries & Databases]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Database.ico

IconIndex=0

[- Office\- Editors & Word Processors]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Editors.ico

IconIndex=0

[- Office\- Printing]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Printing.ico

IconIndex=0

[- Office\- Printing & Scanning]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Printing.ico

IconIndex=0

[- Office\- Printing & Scanning\- Comics & eBooks]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Comics.ico

IconIndex=0

[- Office\- Scanning]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Scanning.ico

IconIndex=0

[- Office\- Scanning & Converting]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Scanning & Converting.ico

IconIndex=0

[- Office\- Scanning & Converting\- Comics & eBooks]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Comics.ico

IconIndex=0

[- Office\- Viewers & Readers]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OFFICE_Viewers.ico

IconIndex=0

[- Office\- Viewers & Readers\- Comics & eBooks]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Comics.ico

IconIndex=0

[- Other]

IconFile=%SystemRoot%\ssTek\Icons\LXP_OTHER.ico

IconIndex=0

[- Other\- Collections]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Collections.ico

IconIndex=0

[- Other\- Fitness Analysis]

IconFile=%SystemRoot%\ssTek\Icons\Sport.ico

IconIndex=0

[- Other\- Genealogy]

IconFile=%SystemRoot%\system32\SHELL32.dll

IconIndex=22

[- Security]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SECURITY.ico

IconIndex=0

[- Security\- Firewall, Virus & Adware]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SECURITY_Firewall.ico

IconIndex=0

[- Security\- Password & Encryption]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SECURITY_Password.ico

IconIndex=0

[- Security\- Hacking & Hex]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SECURITY_Hacking.ico

IconIndex=0

[- Security\- Hacking & Hex\- Cracks]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Cracks.ico

IconIndex=0

[- Security\- Hacking & Hex\- Serials & Keygens]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Serials.ico

IconIndex=0

[- Security\- Hacking & Hex\- Workarounds]

IconFile=%SystemRoot%\ssTek\Icons\Kazz_Hacking.ico

IconIndex=0

[- System]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM.ico

IconIndex=0

[- System\- Add, Install, & Setup]

IconFile=%SystemRoot%\ssTek\Icons\Installers.ico

IconIndex=0

[- System\- All In One Tools]

IconFile=%SystemRoot%\ssTek\Icons\LXP_System_Utils.ico

IconIndex=0

[- System\- Drivers & Codec]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM_Codecs.ico

IconIndex=0

[- System\- Hardware Monitor & Control]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM_Hardware.ico

IconIndex=0

[- System\- Launching, Context Menu & Tray]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM_Launching.ico

IconIndex=0

[- System\- Process & Task Control]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM_Process.ico

IconIndex=0

[- System\- Repair & Registry]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM_Registry.ico

IconIndex=0

[- System\- Theme & Icons]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM_Themes.ico

IconIndex=0

[- System\- Tweaking & Tuning]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM_Tweaking.ico

IconIndex=0

[- System\- Virtual Machines]

IconFile=%SystemRoot%\ssTek\Icons\Emulation.ico

IconIndex=0

[- System\- Windows Tools]

IconFile=%SystemRoot%\ssTek\Icons\LXP_SYSTEM_WindowsTools.ico

IconIndex=0

[- System\- Windows Tools\Accessibility]

IconFile=%SystemRoot%\system32\SHELL32.dll

IconIndex=171

[- Video]

IconFile=%SystemRoot%\ssTek\Icons\LXP_VIDEO.ico

IconIndex=0

[- Video\- Animation]

IconFile=%SystemRoot%\ssTek\Icons\LXP_VIDEO_Animation.ico

IconIndex=0

[- Video\- Convert & Transcode]

IconFile=%SystemRoot%\ssTek\Icons\LXP_VIDEO_Convert.ico

IconIndex=0

[- Video\- Design & Tools]

IconFile=%SystemRoot%\LastXP\Icons\LXP_VIDEO_Editors.ico

IconIndex=0

[- Video\- Editors]

IconFile=%SystemRoot%\ssTek\Icons\LXP_VIDEO_Editors.ico

IconIndex=0

[- Video\- Players]

IconFile=%SystemRoot%\ssTek\Icons\LXP_VIDEO_Players.ico

IconIndex=0


Legacy StartMenu Destinations

StartMenu Destinations Previous page Return to chapter overview Next page

Note: These lists are in perpetual continuous improvement and are therefore subject to frequent changes. They are provided here as reference only.

Currently there are only two custom advanced StartMenu layouts:

Kazz

ssTek


Kazz

Kazz Previous page Return to chapter overview Next page

0 Disk

0 Disk\1 Management

0 Disk\2 Backup Recovery

0 Disk\3 Optical & Image Editing

0 Disk\4 Directory & File Utilities

0 Disk\5 Compression

1 Internet

1 Internet\1 Peer To Peer

1 Internet\2 Network Tools

1 Internet\3 Communications

1 Internet\4 Browsers

1 Internet\5 Bookmarks

1 Internet\6 HTML Tools

1 Internet\7 Download Managers & Boosters

1 Internet\8 Email & Instant Messenger

1 Internet\9 Remote Access & Tools

2 Office

2 Office\1 Text

2 Office\2 Tools

2 Office\3 Research

2 Office\4 Microsoft Office

2 Office\5 Adobe Tools

3 Security

3 Security\1 Anti Virus

3 Security\2 Spyware

3 Security\3 Firewall

3 Security\4 IP Blockers

3 Security\5 Passwords & Encryption

3 Security\6 Stealth & Monitoring

3 Security\7 Internet Security

3 Security\8 Hacking & Workarounds

3 Security\8 Hacking & Workarounds\1 Cracks

3 Security\8 Hacking & Workarounds\2 Serials

3 Security\8 Hacking & Workarounds\3 Keygens

4 System

4 System\1 Windows Tools

4 System\1 Windows Tools\Accessibility

4 System\2 Registry

4 System\3 Task Services

4 System\4 Theme

4 System\5 Utilities

4 System\6 Hardware

4 System\6 Hardware\Emulation

4 System\7 Vista Tools

4 System\8 Tweaking

4 System\9 Development & Code

4 System\0 Installers & Setups

5 Games

5 Games\1 Consoles

5 Games\1 Consoles\1 DreamCast

5 Games\1 Consoles\2 Playstation 2

5 Games\1 Consoles\3 Playstation 3

5 Games\1 Consoles\4 PSP

5 Games\1 Consoles\5 X-Box 360

5 Games\1 Consoles\6 Nintendo Wii

5 Games\2 DVD-ROM Games

5 Games\3 Patching & Modding

5 Games\4 Emulation

5 Games\5 Mini Games

5 Games\6 Vista Games

5 Games\7 Demo's

5 Games\8 Online Tools & Utilities

5 Games\9 Vista Games

5 Games\Abstract

5 Games\Action

5 Games\Adult

5 Games\Adventure

5 Games\Arcade

5 Games\Board

5 Games\Breakout

5 Games\Card

5 Games\Collect

5 Games\Dash

5 Games\Dice

5 Games\Educational

5 Games\Fighting

5 Games\Finder

5 Games\Flight

5 Games\Gambling

5 Games\Mahjong

5 Games\Match

5 Games\Number

5 Games\Objects

5 Games\Other

5 Games\Pinball

5 Games\Platform

5 Games\Puzzle

5 Games\Racing

5 Games\Role Playing

5 Games\Sandbox Physics

5 Games\Shooter

5 Games\Simulation

5 Games\Simulation\Management

5 Games\Sport

5 Games\Strategy

5 Games\Word

6 Graphics

6 Graphics\1 Design & Edit

6 Graphics\2 Viewing & Printing

6 Graphics\3 Scanning & Converting

6 Graphics\5 Theme Creation

6 Graphics\6 CAD & Advanced Design

7 Sound

7 Sound\1 Audio Players

7 Sound\2 Codecs

7 Sound\3 MP3 Tools

7 Sound\4 Converting & Editing

7 Sound\5 Speech

8 Video

8 Video\1 Video Players

8 Video\2 Codecs

8 Video\3 Converting & Editing

9 Other

9 Other\1 Collections

9 Other\2 Genealogy

9 Other\3 Comics & eBooks

9 Other\4 Mobile & PDA Tools

9 Other\5 Travel & GPS

9 Other\6 Fitness Analysis


LastOS

LastOS Previous page Return to chapter overview Next page

- Audio

- Audio\- Edit, Record & Convert

- Audio\- Filters & Distorting

- Audio\- Players

- Audio\- Sequencers & MIDI

- Audio\- Speech

- CD & DVD

- CD & DVD\- DVD Authoring & Menu Creation

- CD & DVD\- Burning & Copying

- CD & DVD\- ISO Image & Virtual Drives

- Development

- Development\- Editor, Compiler and IDE

- Development\- HTML & Help Editors

- Development\- Setup & Install Makers

- Development\- Tools & Design

- Devices

- Devices\- Mobile & PDA Tools

- Devices\- Travel & GPS

- Disk

- Disk\- Archive, Imaging & Backup

- Disk\- Clean, Defrag & Uninstall

- Disk\- Directory & File Utilities

- Disk\- Recovery & Partition

- Games

- Games\- Consoles

- Games\- Consoles\- DreamCast

- Games\- Consoles\- Nintendo Wii

- Games\- Consoles\- Playstation 2

- Games\- Consoles\- Playstation 3

- Games\- Consoles\- PSP

- Games\- Consoles\- X-Box 360

- Games\- Demo's

- Games\- DVD Games

- Games\- DVD-ROM Games

- Games\- Emulation

- Games\- Online Tools & Utilities

- Games\- Patching & Modding

- Games\- Vista Games

- Games\Abstract

- Games\Action

- Games\Adult

- Games\Adventure

- Games\Arcade

- Games\Board

- Games\Breakout

- Games\Card

- Games\Collect

- Games\Dash

- Games\Dice

- Games\Educational

- Games\Fighting

- Games\Finder

- Games\Flight

- Games\Gambling

- Games\Mahjong

- Games\Match

- Games\Number

- Games\Objects

- Games\Other

- Games\Pinball

- Games\Platform

- Games\Puzzle

- Games\Racing

- Games\Role Playing

- Games\Sandbox Physics

- Games\Shooter

- Games\Simulation

- Games\Simulation\Management

- Games\Sport

- Games\Strategy

- Games\Word

- Graphics

- Graphics\- 3D, Generating & Morph

- Graphics\- CAD & Vector

- Graphics\- Font

- Graphics\- Icon

- Graphics\- Photo Editing

- Graphics\- Tools & Design

- Graphics\- Viewers

- Internet

- Internet\- Browsers & Bookmarks

- Internet\- Communications

- Internet\- Download Managers

- Internet\- eMail & Instant Messengers

- Internet\- Network & Bandwidth Software

- Internet\- Peer to Peer

- Multimedia

- Office

- Office\- Calculator, Calendar & Clock

- Office\- Database & Dictionary

- Office\- Editors & Word Processors

- Office\- Printing

- Office\- Scanning & Converting

- Office\- Viewing & Printing

- Office\- Viewing & Printing\- Comics & eBooks

- Other

- Other\- Collections

- Other\- Fitness Analysis

- Other\- Genealogy

- Security

- Security\- Firewall, Virus & Adware

- Security\- Password & Encryption

- Security\- Hacking & Hex

- Security\- Hacking & Hex\- Cracks

- Security\- Hacking & Hex\- Serials & Keygens

- Security\- Hacking & Hex\- Workarounds

- System

- System\- Add, Install, & Setup

- System\- All In One Tools

- System\- Drivers & Codec

- System\- Hardware Monitor & Control

- System\- Launching, Context Menu & Tray

- System\- Process & Task Control

- System\- Repair & Registry

- System\- Theme & Icons

- System\- Tweaking & Tuning

- System\- Virtual Machines

- System\- Windows Tools

- System\- Windows Tools\Accessibility

- Video

- Video\- Animation

- Video\- Convert & Transcode

- Video\- Design & Tools

- Video\- Editors

- Video\- Players


Licenses and External Tools

License Previous page Return to chapter overview Next page

Listed here are the licenses for the SetupS Sendto Suite and its various utilities and their licenses:

SetupS SendTo Suite

7-Zip

FontReg

md5sum

FART - Find And Replace Text

cURL

UPX - The Ultimate Packer for eXecutables

Anolis Resourcer

Innounp - The Inno Setup Unpacker

UnZip

Pic2File

IconsExtract

SKF - Silent Key Finder

USSF - Universal Silent Switch Finder

PEiD - Portable Executable iDentifier

TrID - File Identifier

REF:

GNU General Public License (GPLv3)

GNU Lesser General Public License (LGPLv2.1)


SetupS SendTo Suite

SetupS SendTo Suite v20.02.13.0 (2020-02-13)
Copyright © 2017, Vergitek Solutions
All rights reserved.

The SetupS SendTo Suite is open-source software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version of the License.

DISCLAIMER:

The SetupS SendTo Suite is distributed in the hope that it will be useful, but is provided by Vergitek Solutions "AS IS", without warranty of any kind, express or implied, including but not limited to the warranties of MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE and NON-INFRINGEMENT. In no event shall the authors or Vergitek Solutions be liable for any direct, indirect, incidental, special, exemplary, or consequential damages (including, but not limited to, procurement of substitute goods or services; loss of use, data, or profits; or business interruption) however caused and on any theory of liability, whether in an action of contract, strict liability, or tort (including negligence or otherwise) arising from, out of or in connection with the software or the use or other dealings in the software, even if advised of the possibility of such damage.

See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with the SetupS SendTo Suite. If not, see < http://www.gnu.org/licenses/ >.


7-Zip

7-Zip v16.04
Copyright © 1999-2016 Igor Pavlov : 2016-10-04

http://www.7-zip.org

7-Zip is a file archiver with a high compression ratio.

In addition, licenses for 7-Zip are as follows:

      • 7z.dll: GNU LGPL + unRAR restriction. All other files: GNU LGPL
      • The GNU LGPL + unRAR restriction means that you must follow both GNU LGPL rules and unRAR restriction rules.

Ξ Note: You can use 7-Zip on any computer, including a computer in a commercial organization. You don't need to register or pay for 7-Zip.

Read the file "7-Zip.License.txt" for full information about license.


7-Zip License

7-Zip License Previous page Return to chapter overview Next page

7-Zip

~~~~~

License for use and distribution

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

7-Zip Copyright (C) 1999-2010 Igor Pavlov.

Licenses for files are:

1) 7z.dll: GNU LGPL + unRAR restriction

2) All other files: GNU LGPL

The GNU LGPL + unRAR restriction means that you must follow both GNU LGPL rules and unRAR restriction rules.

Ξ Note: You can use 7-Zip on any computer, including a computer in a commercial organization. You don't need to register or pay for 7-Zip.

GNU LGPL information

--------------------

This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You can receive a copy of the GNU Lesser General Public License from http://www.gnu.org/

unRAR restriction

-----------------

The decompression engine for RAR archives was developed using source code of unRAR program. All copyrights to original unRAR code are owned by Alexander Roshal.

The license for original unRAR code has the following restriction:

The unRAR sources cannot be used to re-create the RAR compression algorithm, which is proprietary. Distribution of modified unRAR sources in separate form or as a part of other software is permitted, provided that it is clearly stated in the documentation and source comments that the code may not be used to develop a RAR (WinRAR) compatible archiver.

Igor Pavlov


FontReg

FontReg v2.1.3
Copyright © 2011 Kai Liu. All rights reserved.

http://code.kliu.org/misc/fontreg

FontReg is a small Windows utility to register and install fonts and/or repair the font registry. It can be used by scripts, batch files, or custom installers to install Windows fonts. It can also replace Microsoft's outdated fontinst utility. Compared to fontinst, FontReg is lighter, supports .otf fonts, and is easier to use.

FontReg can be used to ensure the consistency of the Windows font registry. It does this by registering fonts that are not properly registered and removing leftover stale registrations for fonts that are no longer present on the system.

Licensed under a BSD-style license:

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The name of the copyright holder may not be used to endorse or promote
products derived from this software without specific prior written
permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.


md5sum

md5sum v.1.3.0
Copyright © 2008-2009 Kai Liu. All rights reserved.

http://code.kliu.org/misc/hashutils/

A simple command-line check-summing/hashing utility for Windows, similar to the ones found on most Unix-like systems. The md5sum utility found in this package will produce output similar to and compatible with that of its Unix counterpart.

The -c switch is not supported; to verify checksum files, use HashCheck . All of these utilities support recursive directory traversals with the -r switch.

Licensed under a BSD-style license:

Copyright (C) 2008-2009 Kai Liu. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The name of the copyright holder may not be used to endorse or promote
products derived from this software without specific prior written
permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.


FART - Find And Replace Text

FART v1.99b
Find And Replace Text
Copyright © 2010 Lionello Lunesu

http://fart-it.sourceforge.net/

Find And Replace Text command line utility. New & improved version of the well-known grep command, with advanced features such as: case-adoption of the replace string; find (& replace) in filenames, auto CVS edit.

Licensed under the GNU General Public License (GPL)


cURL

cURL v7.46.0 (2015-12-02)
Copyright © 1996 - 2015, Daniel Stenberg, daniel@haxx.se.
All rights reserved.

http://curl.haxx.se/

Curl and libcurl are true Open Source/Free Software and meet all definitions as such. It means that you are free to modify and redistribute all contents of the curl distributed archives. You may also freely use curl and libcurl in your commercial projects.

Curl and libcurl are licensed under a MIT/X derivate license:

Permission to use, copy, modify, and distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of a copyright holder shall not be used in advertising or otherwise to promote the sale, use or other dealings in this Software without prior written authorization of the copyright holder.


UPX - The Ultimate Packer for eXecutables

UPX v3.91 (2013-09-30)
The Ultimate Packer for eXecutables
Copyright © 1996-2013 Markus Oberhumer, Laszlo Molnar & John Reiser

http://upx.sourceforge.net

UPX is a portable, extendable, high-performance executable packer for several different executable formats. It achieves an excellent compression ratio and offers very fast decompression. Your executables suffer no memory overhead or other drawbacks for most of the formats supported, because of in-place decompression.

UPX can be distributed and used freely. And UPX is released under the GNU General Public License (GPL)


Anolis Resourcer

Anolis Resourcer v0.9.0 (2009-09-01)
Copyright © David Rees 2008, 2009

http://www.anol.is/resourcer/

Anolis Resourcer is a free and open-source utility to view, replace, add, delete, and extract resources located in 32-bit and 64-bit Windows executables and resource (*.res) files.

Windows executables (or more specifically, Win32 PE files) often contain a small database of resources, these are graphics files, text strings, icons, and other programming paraphernalia. Often it can be advantageous to modify these resources, such as to modify a program's visual appearance or to correct a mistranslation in a string table. Anolis Resourcer is a "resource hacker" program which enables you to do this.

Anolis Resourcer is licensed under GNU General Public License (GPL) .


Innounp - The Inno Setup Unpacker

Innounp v0.46 (2016-04-11)
The Inno Setup Unpacker
Copyright © 2004-2015 QuickeneR, 2009-2015 Ariman

http://innounp.sourceforge.net

Supports and unpacks Inno Setup versions 2.0.7 through 5.5.9.

This program is licensed under the terms of the GNU General Public License (GPL)


UnZip

UnZip v6.0 (2009-04-20)
Copyright © 2009 by Info-ZIP

http://www.info-zip.org/UnZip.html

UnZip is an extraction utility for archives compressed in .zip format (also called "zipfiles"). Although highly compatible both with PKWARE's PKZIP and PKUNZIP utilities and with Info-ZIP's own Zip program, our primary objectives have been portability and non-MSDOS functionality.

Released under a modified BSD license:

This is version 2007-Mar-4 of the Info-ZIP license. The definitive version of this document should be available at ftp://ftp.info-zip.org/pub/infozip/license.html indefinitely and a copy at http://www.info-zip.org/pub/infozip/license.html.

Copyright (c) 1990-2007 Info-ZIP. All rights reserved.

For the purposes of this copyright and license, "Info-ZIP" is defined as the following set of individuals:

Mark Adler, John Bush, Karl Davis, Harald Denker, Jean-Michel Dubois, Jean-loup Gailly, Hunter Goatley, Ed Gordon, Ian Gorman, Chris Herborth, Dirk Haase, Greg Hartwig, Robert Heath, Jonathan Hudson, Paul Kienitz, David Kirschbaum, Johnny Lee, Onno van der Linden, Igor Mandrichenko, Steve P. Miller, Sergio Monesi, Keith Owens, George Petrov, Greg Roelofs, Kai Uwe Rommel, Steve Salisbury, Dave Smith, Steven M. Schweda, Christian Spieler, Cosmin Truta, Antoine Verheijen, Paul von Behren, Rich Wales, Mike White.

This software is provided "as is," without warranty of any kind, express or implied. In no event shall Info-ZIP or its contributors be held liable for any direct, indirect, incidental, special or consequential damages arising out of the use of or inability to use this software.

Permission is granted to anyone to use this software for any purpose, including commercial applications, and to alter it and redistribute it freely, subject to the above disclaimer and the following restrictions:

1. Redistributions of source code (in whole or in part) must retain the above copyright notice, definition, disclaimer, and this list of conditions.

2. Redistributions in binary form (compiled executables and libraries) must reproduce the above copyright notice, definition, disclaimer, and this list of conditions in documentation and/or other materials provided with the distribution. The sole exception to this condition is redistribution of a standard UnZipSFX binary (including SFXWiz) as part of a self-extracting archive; that is permitted without inclusion of this license, as long as the normal SFX banner has not been removed from the binary or disabled.

3. Altered versions--including, but not limited to, ports to new operating systems, existing ports with new graphical interfaces, versions with modified or added functionality, and dynamic, shared, or static library versions not from Info-ZIP--must be plainly marked as such and must not be misrepresented as being the original source or, if binaries, compiled from the original source. Such altered versions also must not be misrepresented as being Info-ZIP releases--including, but not limited to, labeling of the altered versions with the names "Info-ZIP" (or any variation thereof, including, but not limited to, different capitalizations), "Pocket UnZip," "WiZ" or "MacZip" without the explicit permission of Info-ZIP. Such altered versions are further prohibited from misrepresentative use of the Zip-Bugs or Info-ZIP e-mail addresses or the Info-ZIP URL(s), such as to imply Info-ZIP will provide support for the altered versions.

4. Info-ZIP retains the right to use the names "Info-ZIP," "Zip," "UnZip," "UnZipSFX," "WiZ," "Pocket UnZip," "Pocket Zip," and "MacZip" for its own source and binary releases.


Pic2File

Pic2File (2009-10-05)
Copyright © 2009 by James K. Lawless (jimbo@radiks.net)

http://www.mailsend-online.com/blog/auto-save-images-from-the-clipboard.html

Utility to automatically save bitmaps on the clipboard to the file system. Requires the .NET 2.0 runtimes.

Licensed under MIT / X11:

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


IconsExtract

IconsExtract v1.47 (2010.09.26)
Copyright © 2003-2010 Nir Sofer

http://www.nirsoft.net

Utility to extract icon/cursor stored in EXE, DLL, OCX, CPL files.

Freeware (free-to-use).


SKF - Silent Key Finder

SKF v1.0.0.12
Silent Key Finder
Copyright © 2016 Dmitry Malgin

http://checkdevice.narod.ru

Utility to identify the installer to determine the key (options) for the automatic (silent) installation.

Freeware (free-to-use).


USSF - Universal Silent Switch Finder

USSF v1.15.0.0
Universal Silent Switch Finder
Copyright © 2005-2011 Kelsenellenelvian

http://www.msfn.org

USSF detects most common installers, self-extracting archives and packages. It also detects .reg, .inf, and .msi files. The program was coded by ZoSTeR of MSFN and updated by CyberSlug, sadicq, & Kelsenellenelvian.

Freeware (free-to-use).


PEiD - Portable Executable iDentifier

PEiD v0.95
Portable Executable iDentifier
Copyright © 2008 by snaker, Qwerton, Jibz & xineohP
All rights reserved.

https://www.aldeid.com/wiki/PEiD

The Portable Executable (PE) format is a file format for executables, object code, DLLs, FON Font files, and others used in 32-bit and 64-bit versions of Windows operating systems. The PE format is a data structure that encapsulates the information necessary for the Windows OS loader to manage the wrapped executable code.

PEiD is an intuitive application that relies PE signatures to detect compilers, packers, and cryptors found in PE files – its detection rate is higher than that of other similar tools since the app packs more than 600 different signatures in PE files - while also featuring a HEX viewer and a task manager.

PEiD comes with three different scanning methods, each suitable for a distinct purpose. Regardless of the chosen type, the generated results are as accurate as possible due to PEiD’s error control method.

Freeware (free-to-use).


TrID - File Identifier

TrID v2.24 (TrIDDefs: 03-Jun-2016)
File Identifier
Copyright © 2003-2016 by M. Pontello

http://mark0.net/soft-trid-e.html

TrID is a utility designed to identify file types from their binary signatures. While there are similar utilities with hard coded logic, TrID has no fixed rules. Instead, it's extensible and can be trained to recognize new formats in a fast and automatic way. TrID has many uses: identify what kind of file was sent to you via e-mail, aid in forensic analysis, support in file recovery, etc. TrID uses a database of definitions which describe recurring patterns for supported file types.

TrID is simple to use. Just run TrID and point it to the file to be analyzed. The file will be read and compared with the definitions in the database. Results are presented in order of highest probability.

Freeware (free-to-use).


GNU General Public License (GPLv3)

GNU General Public License (GPLv3) Previous page Return to chapter overview Next page

GNU GENERAL PUBLIC LICENSE

Version 3, 29 June 2007

Copyright © 2007 Free Software Foundation, Inc. < http://fsf.org/ >

Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not allowed.

Preamble

The GNU General Public License is a free, copyleft license for software and other kinds of works.

The licenses for most software and other practical works are designed to take away your freedom to share and change the works. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change all versions of a program--to make sure it remains free software for all its users. We, the Free Software Foundation, use the GNU General Public License for most of our software; it applies also to any other work released this way by its authors. You can apply it to your programs, too.

When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for them if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs, and that you know you can do these things.

To protect your rights, we need to prevent others from denying you these rights or asking you to surrender the rights. Therefore, you have certain responsibilities if you distribute copies of the software, or if you modify it: responsibilities to respect the freedom of others.

For example, if you distribute copies of such a program, whether gratis or for a fee, you must pass on to the recipients the same freedoms that you received. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights.

Developers that use the GNU GPL protect your rights with two steps: (1) assert copyright on the software, and (2) offer you this License giving you legal permission to copy, distribute and/or modify it.

For the developers' and authors' protection, the GPL clearly explains that there is no warranty for this free software. For both users' and authors' sake, the GPL requires that modified versions be marked as changed, so that their problems will not be attributed erroneously to authors of previous versions.

Some devices are designed to deny users access to install or run modified versions of the software inside them, although the manufacturer can do so. This is fundamentally incompatible with the aim of protecting users' freedom to change the software. The systematic pattern of such abuse occurs in the area of products for individuals to use, which is precisely where it is most unacceptable. Therefore, we have designed this version of the GPL to prohibit the practice for those products. If such problems arise substantially in other domains, we stand ready to extend this provision to those domains in future versions of the GPL, as needed to protect the freedom of users.

Finally, every program is threatened constantly by software patents. States should not allow patents to restrict development and use of software on general-purpose computers, but in those that do, we wish to avoid the special danger that patents applied to a free program could make it effectively proprietary. To prevent this, the GPL assures that patents cannot be used to render the program non-free.

The precise terms and conditions for copying, distribution and modification follow.

TERMS AND CONDITIONS

0. Definitions.

“This License” refers to version 3 of the GNU General Public License.

“Copyright” also means copyright-like laws that apply to other kinds of works, such as semiconductor masks.

“The Program” refers to any copyrightable work licensed under this License. Each licensee is addressed as “you”. “Licensees” and “recipients” may be individuals or organizations.

To “modify” a work means to copy from or adapt all or part of the work in a fashion requiring copyright permission, other than the making of an exact copy. The resulting work is called a “modified version” of the earlier work or a work “based on” the earlier work.

A “covered work” means either the unmodified Program or a work based on the Program.

To “propagate” a work means to do anything with it that, without permission, would make you directly or secondarily liable for infringement under applicable copyright law, except executing it on a computer or modifying a private copy. Propagation includes copying, distribution (with or without modification), making available to the public, and in some countries other activities as well.

To “convey” a work means any kind of propagation that enables other parties to make or receive copies. Mere interaction with a user through a computer network, with no transfer of a copy, is not conveying.

An interactive user interface displays “Appropriate Legal Notices” to the extent that it includes a convenient and prominently visible feature that (1) displays an appropriate copyright notice, and (2) tells the user that there is no warranty for the work (except to the extent that warranties are provided), that licensees may convey the work under this License, and how to view a copy of this License. If the interface presents a list of user commands or options, such as a menu, a prominent item in the list meets this criterion.

1. Source Code.

The “source code” for a work means the preferred form of the work for making modifications to it. “Object code” means any non-source form of a work.

A “Standard Interface” means an interface that either is an official standard defined by a recognized standards body, or, in the case of interfaces specified for a particular programming language, one that is widely used among developers working in that language.

The “System Libraries” of an executable work include anything, other than the work as a whole, that (a) is included in the normal form of packaging a Major Component, but which is not part of that Major Component, and (b) serves only to enable use of the work with that Major Component, or to implement a Standard Interface for which an implementation is available to the public in source code form. A “Major Component”, in this context, means a major essential component (kernel, window system, and so on) of the specific operating system (if any) on which the executable work runs, or a compiler used to produce the work, or an object code interpreter used to run it.

The “Corresponding Source” for a work in object code form means all the source code needed to generate, install, and (for an executable work) run the object code and to modify the work, including scripts to control those activities. However, it does not include the work's System Libraries, or general-purpose tools or generally available free programs which are used unmodified in performing those activities but which are not part of the work. For example, Corresponding Source includes interface definition files associated with source files for the work, and the source code for shared libraries and dynamically linked subprograms that the work is specifically designed to require, such as by intimate data communication or control flow between those subprograms and other parts of the work.

The Corresponding Source need not include anything that users can regenerate automatically from other parts of the Corresponding Source.

The Corresponding Source for a work in source code form is that same work.

2. Basic Permissions.

All rights granted under this License are granted for the term of copyright on the Program, and are irrevocable provided the stated conditions are met. This License explicitly affirms your unlimited permission to run the unmodified Program. The output from running a covered work is covered by this License only if the output, given its content, constitutes a covered work. This License acknowledges your rights of fair use or other equivalent, as provided by copyright law.

You may make, run and propagate covered works that you do not convey, without conditions so long as your license otherwise remains in force. You may convey covered works to others for the sole purpose of having them make modifications exclusively for you, or provide you with facilities for running those works, provided that you comply with the terms of this License in conveying all material for which you do not control copyright. Those thus making or running the covered works for you must do so exclusively on your behalf, under your direction and control, on terms that prohibit them from making any copies of your copyrighted material outside their relationship with you.

Conveying under any other circumstances is permitted solely under the conditions stated below. Sublicensing is not allowed; section 10 makes it unnecessary.

3. Protecting Users' Legal Rights From Anti-Circumvention Law.

No covered work shall be deemed part of an effective technological measure under any applicable law fulfilling obligations under article 11 of the WIPO copyright treaty adopted on 20 December 1996, or similar laws prohibiting or restricting circumvention of such measures.

When you convey a covered work, you waive any legal power to forbid circumvention of technological measures to the extent such circumvention is effected by exercising rights under this License with respect to the covered work, and you disclaim any intention to limit operation or modification of the work as a means of enforcing, against the work's users, your or third parties' legal rights to forbid circumvention of technological measures.

4. Conveying Verbatim Copies.

You may convey verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice; keep intact all notices stating that this License and any non-permissive terms added in accord with section 7 apply to the code; keep intact all notices of the absence of any warranty; and give all recipients a copy of this License along with the Program.

You may charge any price or no price for each copy that you convey, and you may offer support or warranty protection for a fee.

5. Conveying Modified Source Versions.

You may convey a work based on the Program, or the modifications to produce it from the Program, in the form of source code under the terms of section 4, provided that you also meet all of these conditions:

a) The work must carry prominent notices stating that you modified it, and giving a relevant date.

b) The work must carry prominent notices stating that it is released under this License and any conditions added under section 7. This requirement modifies the requirement in section 4 to “keep intact all notices”.

c) You must license the entire work, as a whole, under this License to anyone who comes into possession of a copy. This License will therefore apply, along with any applicable section 7 additional terms, to the whole of the work, and all its parts, regardless of how they are packaged. This License gives no permission to license the work in any other way, but it does not invalidate such permission if you have separately received it.

d) If the work has interactive user interfaces, each must display Appropriate Legal Notices; however, if the Program has interactive interfaces that do not display Appropriate Legal Notices, your work need not make them do so.

A compilation of a covered work with other separate and independent works, which are not by their nature extensions of the covered work, and which are not combined with it such as to form a larger program, in or on a volume of a storage or distribution medium, is called an “aggregate” if the compilation and its resulting copyright are not used to limit the access or legal rights of the compilation's users beyond what the individual works permit. Inclusion of a covered work in an aggregate does not cause this License to apply to the other parts of the aggregate.

6. Conveying Non-Source Forms.

You may convey a covered work in object code form under the terms of sections 4 and 5, provided that you also convey the machine-readable Corresponding Source under the terms of this License, in one of these ways:

a) Convey the object code in, or embodied in, a physical product (including a physical distribution medium), accompanied by the Corresponding Source fixed on a durable physical medium customarily used for software interchange.

b) Convey the object code in, or embodied in, a physical product (including a physical distribution medium), accompanied by a written offer, valid for at least three years and valid for as long as you offer spare parts or customer support for that product model, to give anyone who possesses the object code either (1) a copy of the Corresponding Source for all the software in the product that is covered by this License, on a durable physical medium customarily used for software interchange, for a price no more than your reasonable cost of physically performing this conveying of source, or (2) access to copy the Corresponding Source from a network server at no charge.

c) Convey individual copies of the object code with a copy of the written offer to provide the Corresponding Source. This alternative is allowed only occasionally and noncommercially, and only if you received the object code with such an offer, in accord with subsection 6b.

d) Convey the object code by offering access from a designated place (gratis or for a charge), and offer equivalent access to the Corresponding Source in the same way through the same place at no further charge. You need not require recipients to copy the Corresponding Source along with the object code. If the place to copy the object code is a network server, the Corresponding Source may be on a different server (operated by you or a third party) that supports equivalent copying facilities, provided you maintain clear directions next to the object code saying where to find the Corresponding Source. Regardless of what server hosts the Corresponding Source, you remain obligated to ensure that it is available for as long as needed to satisfy these requirements.

e) Convey the object code using peer-to-peer transmission, provided you inform other peers where the object code and Corresponding Source of the work are being offered to the general public at no charge under subsection 6d.

A separable portion of the object code, whose source code is excluded from the Corresponding Source as a System Library, need not be included in conveying the object code work.

A “User Product” is either (1) a “consumer product”, which means any tangible personal property which is normally used for personal, family, or household purposes, or (2) anything designed or sold for incorporation into a dwelling. In determining whether a product is a consumer product, doubtful cases shall be resolved in favor of coverage. For a particular product received by a particular user, “normally used” refers to a typical or common use of that class of product, regardless of the status of the particular user or of the way in which the particular user actually uses, or expects or is expected to use, the product. A product is a consumer product regardless of whether the product has substantial commercial, industrial or non-consumer uses, unless such uses represent the only significant mode of use of the product.

“Installation Information” for a User Product means any methods, procedures, authorization keys, or other information required to install and execute modified versions of a covered work in that User Product from a modified version of its Corresponding Source. The information must suffice to ensure that the continued functioning of the modified object code is in no case prevented or interfered with solely because modification has been made.

If you convey an object code work under this section in, or with, or specifically for use in, a User Product, and the conveying occurs as part of a transaction in which the right of possession and use of the User Product is transferred to the recipient in perpetuity or for a fixed term (regardless of how the transaction is characterized), the Corresponding Source conveyed under this section must be accompanied by the Installation Information. But this requirement does not apply if neither you nor any third party retains the ability to install modified object code on the User Product (for example, the work has been installed in ROM).

The requirement to provide Installation Information does not include a requirement to continue to provide support service, warranty, or updates for a work that has been modified or installed by the recipient, or for the User Product in which it has been modified or installed. Access to a network may be denied when the modification itself materially and adversely affects the operation of the network or violates the rules and protocols for communication across the network.

Corresponding Source conveyed, and Installation Information provided, in accord with this section must be in a format that is publicly documented (and with an implementation available to the public in source code form), and must require no special password or key for unpacking, reading or copying.

7. Additional Terms.

“Additional permissions” are terms that supplement the terms of this License by making exceptions from one or more of its conditions. Additional permissions that are applicable to the entire Program shall be treated as though they were included in this License, to the extent that they are valid under applicable law. If additional permissions apply only to part of the Program, that part may be used separately under those permissions, but the entire Program remains governed by this License without regard to the additional permissions.

When you convey a copy of a covered work, you may at your option remove any additional permissions from that copy, or from any part of it. (Additional permissions may be written to require their own removal in certain cases when you modify the work.) You may place additional permissions on material, added by you to a covered work, for which you have or can give appropriate copyright permission.

Notwithstanding any other provision of this License, for material you add to a covered work, you may (if authorized by the copyright holders of that material) supplement the terms of this License with terms:

a) Disclaiming warranty or limiting liability differently from the terms of sections 15 and 16 of this License; or

b) Requiring preservation of specified reasonable legal notices or author attributions in that material or in the Appropriate Legal Notices displayed by works containing it; or

c) Prohibiting misrepresentation of the origin of that material, or requiring that modified versions of such material be marked in reasonable ways as different from the original version; or

d) Limiting the use for publicity purposes of names of licensors or authors of the material; or

e) Declining to grant rights under trademark law for use of some trade names, trademarks, or service marks; or

f) Requiring indemnification of licensors and authors of that material by anyone who conveys the material (or modified versions of it) with contractual assumptions of liability to the recipient, for any liability that these contractual assumptions directly impose on those licensors and authors.

All other non-permissive additional terms are considered “further restrictions” within the meaning of section 10. If the Program as you received it, or any part of it, contains a notice stating that it is governed by this License along with a term that is a further restriction, you may remove that term. If a license document contains a further restriction but permits relicensing or conveying under this License, you may add to a covered work material governed by the terms of that license document, provided that the further restriction does not survive such relicensing or conveying.

If you add terms to a covered work in accord with this section, you must place, in the relevant source files, a statement of the additional terms that apply to those files, or a notice indicating where to find the applicable terms.

Additional terms, permissive or non-permissive, may be stated in the form of a separately written license, or stated as exceptions; the above requirements apply either way.

8. Termination.

You may not propagate or modify a covered work except as expressly provided under this License. Any attempt otherwise to propagate or modify it is void, and will automatically terminate your rights under this License (including any patent licenses granted under the third paragraph of section 11).

However, if you cease all violation of this License, then your license from a particular copyright holder is reinstated (a) provisionally, unless and until the copyright holder explicitly and finally terminates your license, and (b) permanently, if the copyright holder fails to notify you of the violation by some reasonable means prior to 60 days after the cessation.

Moreover, your license from a particular copyright holder is reinstated permanently if the copyright holder notifies you of the violation by some reasonable means, this is the first time you have received notice of violation of this License (for any work) from that copyright holder, and you cure the violation prior to 30 days after your receipt of the notice.

Termination of your rights under this section does not terminate the licenses of parties who have received copies or rights from you under this License. If your rights have been terminated and not permanently reinstated, you do not qualify to receive new licenses for the same material under section 10.

9. Acceptance Not Required for Having Copies.

You are not required to accept this License in order to receive or run a copy of the Program. Ancillary propagation of a covered work occurring solely as a consequence of using peer-to-peer transmission to receive a copy likewise does not require acceptance. However, nothing other than this License grants you permission to propagate or modify any covered work. These actions infringe copyright if you do not accept this License. Therefore, by modifying or propagating a covered work, you indicate your acceptance of this License to do so.

10. Automatic Licensing of Downstream Recipients.

Each time you convey a covered work, the recipient automatically receives a license from the original licensors, to run, modify and propagate that work, subject to this License. You are not responsible for enforcing compliance by third parties with this License.

An “entity transaction” is a transaction transferring control of an organization, or substantially all assets of one, or subdividing an organization, or merging organizations. If propagation of a covered work results from an entity transaction, each party to that transaction who receives a copy of the work also receives whatever licenses to the work the party's predecessor in interest had or could give under the previous paragraph, plus a right to possession of the Corresponding Source of the work from the predecessor in interest, if the predecessor has it or can get it with reasonable efforts.

You may not impose any further restrictions on the exercise of the rights granted or affirmed under this License. For example, you may not impose a license fee, royalty, or other charge for exercise of rights granted under this License, and you may not initiate litigation (including a cross-claim or counterclaim in a lawsuit) alleging that any patent claim is infringed by making, using, selling, offering for sale, or importing the Program or any portion of it.

11. Patents.

A “contributor” is a copyright holder who authorizes use under this License of the Program or a work on which the Program is based. The work thus licensed is called the contributor's “contributor version”.

A contributor's “essential patent claims” are all patent claims owned or controlled by the contributor, whether already acquired or hereafter acquired, that would be infringed by some manner, permitted by this License, of making, using, or selling its contributor version, but do not include claims that would be infringed only as a consequence of further modification of the contributor version. For purposes of this definition, “control” includes the right to grant patent sublicenses in a manner consistent with the requirements of this License.

Each contributor grants you a non-exclusive, worldwide, royalty-free patent license under the contributor's essential patent claims, to make, use, sell, offer for sale, import and otherwise run, modify and propagate the contents of its contributor version.

In the following three paragraphs, a “patent license” is any express agreement or commitment, however denominated, not to enforce a patent (such as an express permission to practice a patent or covenant not to sue for patent infringement). To “grant” such a patent license to a party means to make such an agreement or commitment not to enforce a patent against the party.

If you convey a covered work, knowingly relying on a patent license, and the Corresponding Source of the work is not available for anyone to copy, free of charge and under the terms of this License, through a publicly available network server or other readily accessible means, then you must either (1) cause the Corresponding Source to be so available, or (2) arrange to deprive yourself of the benefit of the patent license for this particular work, or (3) arrange, in a manner consistent with the requirements of this License, to extend the patent license to downstream recipients. “Knowingly relying” means you have actual knowledge that, but for the patent license, your conveying the covered work in a country, or your recipient's use of the covered work in a country, would infringe one or more identifiable patents in that country that you have reason to believe are valid.

If, pursuant to or in connection with a single transaction or arrangement, you convey, or propagate by procuring conveyance of, a covered work, and grant a patent license to some of the parties receiving the covered work authorizing them to use, propagate, modify or convey a specific copy of the covered work, then the patent license you grant is automatically extended to all recipients of the covered work and works based on it.

A patent license is “discriminatory” if it does not include within the scope of its coverage, prohibits the exercise of, or is conditioned on the non-exercise of one or more of the rights that are specifically granted under this License. You may not convey a covered work if you are a party to an arrangement with a third party that is in the business of distributing software, under which you make payment to the third party based on the extent of your activity of conveying the work, and under which the third party grants, to any of the parties who would receive the covered work from you, a discriminatory patent license (a) in connection with copies of the covered work conveyed by you (or copies made from those copies), or (b) primarily for and in connection with specific products or compilations that contain the covered work, unless you entered into that arrangement, or that patent license was granted, prior to 28 March 2007.

Nothing in this License shall be construed as excluding or limiting any implied license or other defenses to infringement that may otherwise be available to you under applicable patent law.

12. No Surrender of Others' Freedom.

If conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot convey a covered work so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not convey it at all. For example, if you agree to terms that obligate you to collect a royalty for further conveying from those to whom you convey the Program, the only way you could satisfy both those terms and this License would be to refrain entirely from conveying the Program.

13. Use with the GNU Affero General Public License.

Notwithstanding any other provision of this License, you have permission to link or combine any covered work with a work licensed under version 3 of the GNU Affero General Public License into a single combined work, and to convey the resulting work. The terms of this License will continue to apply to the part which is the covered work, but the special requirements of the GNU Affero General Public License, section 13, concerning interaction through a network will apply to the combination as such.

14. Revised Versions of this License.

The Free Software Foundation may publish revised and/or new versions of the GNU General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number. If the Program specifies that a certain numbered version of the GNU General Public License “or any later version” applies to it, you have the option of following the terms and conditions either of that numbered version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of the GNU General Public License, you may choose any version ever published by the Free Software Foundation.

If the Program specifies that a proxy can decide which future versions of the GNU General Public License can be used, that proxy's public statement of acceptance of a version permanently authorizes you to choose that version for the Program.

Later license versions may give you additional or different permissions. However, no additional obligations are imposed on any author or copyright holder as a result of your choosing to follow a later version.

15. Disclaimer of Warranty.

THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM “AS IS” WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

16. Limitation of Liability.

IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

17. Interpretation of Sections 15 and 16.

If the disclaimer of warranty and limitation of liability provided above cannot be given local legal effect according to their terms, reviewing courts shall apply local law that most closely approximates an absolute waiver of all civil liability in connection with the Program, unless a warranty or assumption of liability accompanies a copy of the Program in return for a fee.

END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs

If you develop a new program, and you want it to be of the greatest possible use to the public, the best way to achieve this is to make it free software which everyone can redistribute and change under these terms.

To do so, attach the following notices to the program. It is safest to attach them to the start of each source file to most effectively state the exclusion of warranty; and each file should have at least the “copyright” line and a pointer to where the full notice is found.

<one line to give the program's name and a brief idea of what it does.>

Copyright (C) <year> <name of author>

This program is free software: you can redistribute it and/or modify

it under the terms of the GNU General Public License as published by

the Free Software Foundation, either version 3 of the License, or

(at your option) any later version.

This program is distributed in the hope that it will be useful,

but WITHOUT ANY WARRANTY; without even the implied warranty of

MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the

GNU General Public License for more details.

You should have received a copy of the GNU General Public License

along with this program. If not, see <http://www.gnu.org/licenses/>.

Also add information on how to contact you by electronic and paper mail.

If the program does terminal interaction, make it output a short notice like this when it starts in an interactive mode:

<program> Copyright (C) <year> <name of author>

This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.

This is free software, and you are welcome to redistribute it

under certain conditions; type `show c' for details.

The hypothetical commands `show w' and `show c' should show the appropriate parts of the General Public License. Of course, your program's commands might be different; for a GUI interface, you would use an “about box”.

You should also get your employer (if you work as a programmer) or school, if any, to sign a “copyright disclaimer” for the program, if necessary. For more information on this, and how to apply and follow the GNU GPL, see < http://www.gnu.org/licenses/ >.

The GNU General Public License does not permit incorporating your program into proprietary programs. If your program is a subroutine library, you may consider it more useful to permit linking proprietary applications with the library. If this is what you want to do, use the GNU Lesser General Public License instead of this License. But first, please read < http://www.gnu.org/philosophy/why-not-lgpl.html >.


GNU Lesser General Public License (LGPLv2.1)

GNU Lesser General Public License (LGPLv2.1) Previous page Return to chapter overview Next page

GNU LESSER GENERAL PUBLIC LICENSE

Version 2.1, February 1999

Copyright (C) 1991, 1999 Free Software Foundation, Inc.

51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

Everyone is permitted to copy and distribute verbatim copies

of this license document, but changing it is not allowed.

[This is the first released version of the Lesser GPL. It also counts

as the successor of the GNU Library Public License, version 2, hence

the version number 2.1.]

Preamble

The licenses for most software are designed to take away your freedom to share and change it. By contrast, the GNU General Public Licenses are intended to guarantee your freedom to share and change free software--to make sure the software is free for all its users.

This license, the Lesser General Public License, applies to some specially designated software packages--typically libraries--of the Free Software Foundation and other authors who decide to use it. You can use it too, but we suggest you first think carefully about whether this license or the ordinary General Public License is the better strategy to use in any particular case, based on the explanations below.

When we speak of free software, we are referring to freedom of use, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for this service if you wish); that you receive source code or can get it if you want it; that you can change the software and use pieces of it in new free programs; and that you are informed that you can do these things.

To protect your rights, we need to make restrictions that forbid distributors to deny you these rights or to ask you to surrender these rights. These restrictions translate to certain responsibilities for you if you distribute copies of the library or if you modify it.

For example, if you distribute copies of the library, whether gratis or for a fee, you must give the recipients all the rights that we gave you. You must make sure that they, too, receive or can get the source code. If you link other code with the library, you must provide complete object files to the recipients, so that they can relink them with the library after making changes to the library and recompiling it. And you must show them these terms so they know their rights.

We protect your rights with a two-step method: (1) we copyright the library, and (2) we offer you this license, which gives you legal permission to copy, distribute and/or modify the library.

To protect each distributor, we want to make it very clear that there is no warranty for the free library. Also, if the library is modified by someone else and passed on, the recipients should know that what they have is not the original version, so that the original author's reputation will not be affected by problems that might be introduced by others.

Finally, software patents pose a constant threat to the existence of any free program. We wish to make sure that a company cannot effectively restrict the users of a free program by obtaining a restrictive license from a patent holder. Therefore, we insist that any patent license obtained for a version of the library must be consistent with the full freedom of use specified in this license.

Most GNU software, including some libraries, is covered by the ordinary GNU General Public License. This license, the GNU Lesser General Public License, applies to certain designated libraries, and is quite different from the ordinary General Public License. We use this license for certain libraries in order to permit linking those libraries into non-free programs.

When a program is linked with a library, whether statically or using a shared library, the combination of the two is legally speaking a combined work, a derivative of the original library. The ordinary General Public License therefore permits such linking only if the entire combination fits its criteria of freedom. The Lesser General Public License permits more lax criteria for linking other code with the library.

We call this license the "Lesser" General Public License because it does Less to protect the user's freedom than the ordinary General Public License. It also provides other free software developers Less of an advantage over competing non-free programs. These disadvantages are the reason we use the ordinary General Public License for many libraries. However, the Lesser license provides advantages in certain special circumstances.

For example, on rare occasions, there may be a special need to encourage the widest possible use of a certain library, so that it becomes a de-facto standard. To achieve this, non-free programs must be allowed to use the library. A more frequent case is that a free library does the same job as widely used non-free libraries. In this case, there is little to gain by limiting the free library to free software only, so we use the Lesser General Public License.

In other cases, permission to use a particular library in non-free programs enables a greater number of people to use a large body of free software. For example, permission to use the GNU C Library in non-free programs enables many more people to use the whole GNU operating system, as well as its variant, the GNU/Linux operating system.

Although the Lesser General Public License is Less protective of the users' freedom, it does ensure that the user of a program that is linked with the Library has the freedom and the wherewithal to run that program using a modified version of the Library.

The precise terms and conditions for copying, distribution and modification follow. Pay close attention to the difference between a "work based on the library" and a "work that uses the library". The former contains code derived from the library, whereas the latter must be combined with the library in order to run.

TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

0. This License Agreement applies to any software library or other program which contains a notice placed by the copyright holder or other authorized party saying it may be distributed under the terms of this Lesser General Public License (also called "this License"). Each licensee is addressed as "you".

A "library" means a collection of software functions and/or data prepared so as to be conveniently linked with application programs (which use some of those functions and data) to form executables.

The "Library", below, refers to any such software library or work which has been distributed under these terms. A "work based on the Library" means either the Library or any derivative work under copyright law: that is to say, a work containing the Library or a portion of it, either verbatim or with modifications and/or translated straightforwardly into another language. (Hereinafter, translation is included without limitation in the term "modification".)

"Source code" for a work means the preferred form of the work for making modifications to it. For a library, complete source code means all the source code for all modules it contains, plus any associated interface definition files, plus the scripts used to control compilation and installation of the library.

Activities other than copying, distribution and modification are not covered by this License; they are outside its scope. The act of running a program using the Library is not restricted, and output from such a program is covered only if its contents constitute a work based on the Library (independent of the use of the Library in a tool for writing it). Whether that is true depends on what the Library does and what the program that uses the Library does.

1. You may copy and distribute verbatim copies of the Library's complete source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice and disclaimer of warranty; keep intact all the notices that refer to this License and to the absence of any warranty; and distribute a copy of this License along with the Library.

You may charge a fee for the physical act of transferring a copy, and you may at your option offer warranty protection in exchange for a fee.

2. You may modify your copy or copies of the Library or any portion of it, thus forming a work based on the Library, and copy and distribute such modifications or work under the terms of Section 1 above, provided that you also meet all of these conditions:

a) The modified work must itself be a software library.

b) You must cause the files modified to carry prominent notices stating that you changed the files and the date of any change.

c) You must cause the whole of the work to be licensed at no charge to all third parties under the terms of this License.

d) If a facility in the modified Library refers to a function or a table of data to be supplied by an application program that uses the facility, other than as an argument passed when the facility is invoked, then you must make a good faith effort to ensure that, in the event an application does not supply such function or table, the facility still operates, and performs whatever part of its purpose remains meaningful.

(For example, a function in a library to compute square roots has a purpose that is entirely well-defined independent of the application. Therefore, Subsection 2d requires that any application-supplied function or table used by this function must be optional: if the application does not supply it, the square root function must still compute square roots.)

These requirements apply to the modified work as a whole. If identifiable sections of that work are not derived from the Library, and can be reasonably considered independent and separate works in themselves, then this License, and its terms, do not apply to those sections when you distribute them as separate works. But when you distribute the same sections as part of a whole which is a work based on the Library, the distribution of the whole must be on the terms of this License, whose permissions for other licensees extend to the entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest your rights to work written entirely by you; rather, the intent is to exercise the right to control the distribution of derivative or collective works based on the Library.

In addition, mere aggregation of another work not based on the Library with the Library (or with a work based on the Library) on a volume of a storage or distribution medium does not bring the other work under the scope of this License.

3. You may opt to apply the terms of the ordinary GNU General Public License instead of this License to a given copy of the Library. To do this, you must alter all the notices that refer to this License, so that they refer to the ordinary GNU General Public License, version 2, instead of to this License. (If a newer version than version 2 of the ordinary GNU General Public License has appeared, then you can specify that version instead if you wish.) Do not make any other change in these notices.

Once this change is made in a given copy, it is irreversible for that copy, so the ordinary GNU General Public License applies to all subsequent copies and derivative works made from that copy.

This option is useful when you wish to copy part of the code of the Library into a program that is not a library.

4. You may copy and distribute the Library (or a portion or derivative of it, under Section 2) in object code or executable form under the terms of Sections 1 and 2 above provided that you accompany it with the complete corresponding machine-readable source code, which must be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange.

If distribution of object code is made by offering access to copy from a designated place, then offering equivalent access to copy the source code from the same place satisfies the requirement to distribute the source code, even though third parties are not compelled to copy the source along with the object code.

5. A program that contains no derivative of any portion of the Library, but is designed to work with the Library by being compiled or linked with it, is called a "work that uses the Library". Such a work, in isolation, is not a derivative work of the Library, and therefore falls outside the scope of this License.

However, linking a "work that uses the Library" with the Library creates an executable that is a derivative of the Library (because it contains portions of the Library), rather than a "work that uses the library". The executable is therefore covered by this License. Section 6 states terms for distribution of such executables.

When a "work that uses the Library" uses material from a header file that is part of the Library, the object code for the work may be a derivative work of the Library even though the source code is not. Whether this is true is especially significant if the work can be linked without the Library, or if the work is itself a library. The threshold for this to be true is not precisely defined by law.

If such an object file uses only numerical parameters, data structure layouts and accessors, and small macros and small inline functions (ten lines or less in length), then the use of the object file is unrestricted, regardless of whether it is legally a derivative work. (Executables containing this object code plus portions of the Library will still fall under Section 6.)

Otherwise, if the work is a derivative of the Library, you may distribute the object code for the work under the terms of Section 6. Any executables containing that work also fall under Section 6, whether or not they are linked directly with the Library itself.

6. As an exception to the Sections above, you may also combine or link a "work that uses the Library" with the Library to produce a work containing portions of the Library, and distribute that work under terms of your choice, provided that the terms permit modification of the work for the customer's own use and reverse engineering for debugging such modifications.

You must give prominent notice with each copy of the work that the Library is used in it and that the Library and its use are covered by this License. You must supply a copy of this License. If the work during execution displays copyright notices, you must include the copyright notice for the Library among them, as well as a reference directing the user to the copy of this License. Also, you must do one of these things:

a) Accompany the work with the complete corresponding machine-readable source code for the Library including whatever changes were used in the work (which must be distributed under Sections 1 and 2 above); and, if the work is an executable linked with the Library, with the complete machine-readable "work that uses the Library", as object code and/or source code, so that the user can modify the Library and then relink to produce a modified executable containing the modified Library. (It is understood that the user who changes the contents of definitions files in the Library will not necessarily be able to recompile the application to use the modified definitions.)

b) Use a suitable shared library mechanism for linking with the Library. A suitable mechanism is one that (1) uses at run time a copy of the library already present on the user's computer system, rather than copying library functions into the executable, and (2) will operate properly with a modified version of the library, if the user installs one, as long as the modified version is interface-compatible with the version that the work was made with.

c) Accompany the work with a written offer, valid for at least three years, to give the same user the materials specified in Subsection 6a, above, for a charge no more than the cost of performing this distribution.

d) If distribution of the work is made by offering access to copy from a designated place, offer equivalent access to copy the above specified materials from the same place.

e) Verify that the user has already received a copy of these materials or that you have already sent this user a copy.

For an executable, the required form of the "work that uses the Library" must include any data and utility programs needed for reproducing the executable from it. However, as a special exception, the materials to be distributed need not include anything that is normally distributed (in either source or binary form) with the major components (compiler, kernel, and so on) of the operating system on which the executable runs, unless that component itself accompanies the executable.

It may happen that this requirement contradicts the license restrictions of other proprietary libraries that do not normally accompany the operating system. Such a contradiction means you cannot use both them and the Library together in an executable that you distribute.

7. You may place library facilities that are a work based on the Library side-by-side in a single library together with other library facilities not covered by this License, and distribute such a combined library, provided that the separate distribution of the work based on the Library and of the other library facilities is otherwise permitted, and provided that you do these two things:

a) Accompany the combined library with a copy of the same work based on the Library, uncombined with any other library facilities. This must be distributed under the terms of the Sections above.

b) Give prominent notice with the combined library of the fact that part of it is a work based on the Library, and explaining where to find the accompanying uncombined form of the same work.

8. You may not copy, modify, sublicense, link with, or distribute the Library except as expressly provided under this License. Any attempt otherwise to copy, modify, sublicense, link with, or distribute the Library is void, and will automatically terminate your rights under this License. However, parties who have received copies, or rights, from you under this License will not have their licenses terminated so long as such parties remain in full compliance.

9. You are not required to accept this License, since you have not signed it. However, nothing else grants you permission to modify or distribute the Library or its derivative works. These actions are prohibited by law if you do not accept this License. Therefore, by modifying or distributing the Library (or any work based on the Library), you indicate your acceptance of this License to do so, and all its terms and conditions for copying, distributing or modifying the Library or works based on it.

10. Each time you redistribute the Library (or any work based on the Library), the recipient automatically receives a license from the original licensor to copy, distribute, link with or modify the Library subject to these terms and conditions. You may not impose any further restrictions on the recipients' exercise of the rights granted herein. You are not responsible for enforcing compliance by third parties with this License.

11. If, as a consequence of a court judgment or allegation of patent infringement or for any other reason (not limited to patent issues), conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot distribute so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not distribute the Library at all. For example, if a patent license would not permit royalty-free redistribution of the Library by all those who receive copies directly or indirectly through you, then the only way you could satisfy both it and this License would be to refrain entirely from distribution of the Library.

If any portion of this section is held invalid or unenforceable under any particular circumstance, the balance of the section is intended to apply, and the section as a whole is intended to apply in other circumstances.

It is not the purpose of this section to induce you to infringe any patents or other property right claims or to contest validity of any such claims; this section has the sole purpose of protecting the integrity of the free software distribution system which is implemented by public license practices. Many people have made generous contributions to the wide range of software distributed through that system in reliance on consistent application of that system; it is up to the author/donor to decide if he or she is willing to distribute software through any other system and a licensee cannot impose that choice.

This section is intended to make thoroughly clear what is believed to be a consequence of the rest of this License.

12. If the distribution and/or use of the Library is restricted in certain countries either by patents or by copyrighted interfaces, the original copyright holder who places the Library under this License may add an explicit geographical distribution limitation excluding those countries, so that distribution is permitted only in or among countries not thus excluded. In such case, this License incorporates the limitation as if written in the body of this License.

13. The Free Software Foundation may publish revised and/or new versions of the Lesser General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number. If the Library specifies a version number of this License which applies to it and "any later version", you have the option of following the terms and conditions either of that version or of any later version published by the Free Software Foundation. If the Library does not specify a license version number, you may choose any version ever published by the Free Software Foundation.

14. If you wish to incorporate parts of the Library into other free programs whose distribution conditions are incompatible with these, write to the author to ask for permission. For software which is copyrighted by the Free Software Foundation, write to the Free Software Foundation; we sometimes make exceptions for this. Our decision will be guided by the two goals of preserving the free status of all derivatives of our free software and of promoting the sharing and reuse of software generally.

NO WARRANTY

15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE LIBRARY IS WITH YOU. SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Libraries

If you develop a new library, and you want it to be of the greatest possible use to the public, we recommend making it free software that everyone can redistribute and change. You can do so by permitting redistribution under these terms (or, alternatively, under the terms of the ordinary General Public License).

To apply these terms, attach the following notices to the library. It is safest to attach them to the start of each source file to most effectively convey the exclusion of warranty; and each file should have at least the "copyright" line and a pointer to where the full notice is found.

one line to give the library's name and an idea of what it does.

Copyright (C) year name of author

This library is free software; you can redistribute it and/or

modify it under the terms of the GNU Lesser General Public

License as published by the Free Software Foundation; either

version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,

but WITHOUT ANY WARRANTY; without even the implied warranty of

MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU

Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public

License along with this library; if not, write to the Free Software

Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

Also add information on how to contact you by electronic and paper mail.

You should also get your employer (if you work as a programmer) or your school, if any, to sign a "copyright disclaimer" for the library, if necessary. Here is a sample; alter the names:

Yoyodyne, Inc., hereby disclaims all copyright interest in

the library `Frob' (a library for tweaking knobs) written

by James Random Hacker.

signature of Ty Coon, 1 April 1990

Ty Coon, President of Vice

That's all there is to it!


Command Line Usages

Command Line Usage Previous page Return to chapter overview Next page

The ssTek tools can also be invoked via the command line. See the following for details on each tool:

SetupS

ssControlPanel

ssRegenerator

ssEditor